package com.intuit.sb.payroll.capability.ca.client.dto;

import com.intuit.sb.payroll.capability.ca.common.EnumBase;

/**
 * How often the worker is paid.
 */
public class PayrollScheduleFrequency extends EnumBase
{
	/** Every week.  Ordinal 0 */ 
	public static final PayrollScheduleFrequency Weekly = new PayrollScheduleFrequency("Weekly", 0);

	/** Every other week (once per fortnight).  Ordinal 1 */ 
	public static final PayrollScheduleFrequency Biweekly = new PayrollScheduleFrequency("Biweekly", 1);

	/**  Twice per month.  Ordinal 2 */ 
	public static final PayrollScheduleFrequency Semimonthly = new PayrollScheduleFrequency("Semimonthly", 2);
	
	/** Once per month.  Ordinal 3 */ 
	public static final PayrollScheduleFrequency Monthly = new PayrollScheduleFrequency("Monthly", 3);
	
	/** Once per month.  Ordinal 4 */ 
	public static final PayrollScheduleFrequency Daily = new PayrollScheduleFrequency("Daily", 4);
    
    /**  Not Set.  Ordinal 10 */ 
    public static final PayrollScheduleFrequency NotSet = new PayrollScheduleFrequency("NotSet", 10);

	private static final long serialVersionUID = 2327965258280240009L;

	/*
	 * Constructor should not be called other than by this class itself.
	 */
	private PayrollScheduleFrequency(String name, int ordinal)
	{
		super(name, ordinal);
	}

	/** 
	 * Public no-arg constructor is required by LCDS.  Without it, you get an exception
	 * with the following message: "Types must have a public, no arguments constructor".
	 * This should never be used by hand-written code.
	 * @deprecated
	 */
	public PayrollScheduleFrequency()
	{
		super();
	}
}