package com.intuit.sb.payroll.capability.ca.workerpayment;

import java.math.BigDecimal;







public class LineItemAmount {
	
    private String itemId;
    private BigDecimal amount;
    private BigDecimal ytdAmount;
    private BigDecimal isttAmount;
    private BigDecimal wagebaseAmount;
    
    public LineItemAmount(String id, BigDecimal amt) {
        this(id, amt, amt, new BigDecimal("0.00"), new BigDecimal("0.00"));
    }
    
    public LineItemAmount(String id, BigDecimal amt, BigDecimal incomeSubjectToTaxAmt, BigDecimal wageBaseAmt) {
        this(id, amt, amt, incomeSubjectToTaxAmt, wageBaseAmt);
    }
    
    public LineItemAmount(String id, BigDecimal amt, BigDecimal ytdAmt) {
        this(id, amt, ytdAmt, new BigDecimal("0.00"), new BigDecimal("0.00"));
    }
    
    public LineItemAmount(String id, BigDecimal amt, BigDecimal ytdAmt, BigDecimal incomeSubjectToTaxAmt, BigDecimal wageBaseAmt) {
        itemId = id;
        amount = amt;
        ytdAmount = ytdAmt;
        isttAmount = incomeSubjectToTaxAmt;
        wagebaseAmount = wageBaseAmt;
    }
    
    public String getItemId() {
        return itemId;
    }
    
    public BigDecimal getAmount() {
        return amount;
    }
    
    public BigDecimal getYtdAmount() {
        return ytdAmount;
    }
    
    public BigDecimal getIsttAmount() {
        return isttAmount;
    }
    
    public BigDecimal getWagebaseAmount() {
        return wagebaseAmount;
    }
    
    public boolean equals(Object other) {
        if (other == this) {
            return true;            
        }
                
        if(!(other instanceof LineItemAmount)) {
            return false;
        }
        //If we reach here, other is not null
        LineItemAmount otherLineItemAmount = (LineItemAmount) other;
        //Useful for debugging that's why temporary variables
        boolean idEquals = otherLineItemAmount.getItemId().equals(this.itemId);
        boolean amountEquals = (0 == otherLineItemAmount.getAmount().compareTo(this.amount));
        boolean ytdAmountEquals = (0 == otherLineItemAmount.getYtdAmount().compareTo(this.ytdAmount));
        return  idEquals && amountEquals && ytdAmountEquals;
    }
    
    //If We overrode equals method then we must override hashCode   
    @Override
    public int hashCode() {
        int hash = 1;
        if (this.itemId != null) {
            hash = hash * 31 + this.itemId.hashCode();
        }
        if (this.amount != null) 
        {
            hash = hash * 31 + this.amount.hashCode();
        }
        if (this.ytdAmount != null)
        {
            hash = hash * 31 + this.ytdAmount.hashCode();
        }
        if (this.isttAmount != null)
        {
            hash = hash * 31 + this.isttAmount.hashCode();
        }
        if (this.wagebaseAmount != null)
        {
            hash = hash * 31 + this.wagebaseAmount.hashCode();
        }
        return hash;        
    }
    


}
