package com.intuit.sb.payroll.capability.workerpayments;

import java.io.Serializable;

import com.intuit.sb.payroll.entity.model.Datum;

/**
 * CalculationInputs is intended to be a carrier vessel for Datums that are not going
 * to be persisted in a PayrollItemDtl derivative, but are going to be used in calculation,
 * and eventually on a PaycheckLineItem.
 *
 * $Author$ 
 * $Revision$
 * $DateTime$
 */
public class CalculationInputs implements Serializable {

	private static final long serialVersionUID = 787804425364724657L;
	private Datum quantity;
	private Datum rate;
	private long sourcePayrollItemDtlId;
	
	public CalculationInputs() {}

	public Datum getQuantity() {
		return quantity;
	}

	public void setQuantity(Datum quantity) {
		this.quantity = quantity;
	}

	public Datum getRate() {
		return rate;
	}

	public void setRate(Datum rate) {
		this.rate = rate;
	}

	public long getSourcePayrollItemDtlId() {
		return sourcePayrollItemDtlId;
	}

	public void setSourcePayrollItemDtlId(long sourcePayrollItemDtlId) {
		this.sourcePayrollItemDtlId = sourcePayrollItemDtlId;
	}
}
