package com.intuit.sb.payroll.capability.workerpayments;

import java.io.Serializable;
import java.util.List;

import com.intuit.sb.payroll.entity.model.PayrollDistributionMethodEnum;
import com.intuit.sb.payroll.entity.model.Worker;

public class PaycheckInputs implements Serializable {

	private static final long serialVersionUID = 693331775626559840L;

	private Worker worker;
	private List<CalculationInputs> calculationInputs;
	private PayrollDistributionMethodEnum distributionMethod;
	private boolean partialPayPeriod = false;
	
	public PaycheckInputs() {
	}
	
	public PaycheckInputs(Worker worker,
			List<CalculationInputs> calculationInputs) {
		super();
		this.worker = worker;
		this.calculationInputs = calculationInputs;
		this.distributionMethod = PayrollDistributionMethodEnum.HANDWRITTENPAYCHECK;
	}
	
	public PaycheckInputs(Worker worker, List<CalculationInputs> calculationInputs,
			PayrollDistributionMethodEnum distributionMethod, boolean partialPayPeriod) {
		super();
		this.worker = worker;
		this.calculationInputs = calculationInputs;
		this.distributionMethod = distributionMethod;
		this.partialPayPeriod = partialPayPeriod;
	}

	public Worker getWorker() {
		return worker;
	}

	public void setWorker(Worker worker) {
		this.worker = worker;
	}

	public void setCalculationInputs(List<CalculationInputs> calculationInputs) {
		this.calculationInputs = calculationInputs;
	}

	public List<CalculationInputs> getCalculationInputs() {
		return calculationInputs;
	}

	public void setDistributionMethod(PayrollDistributionMethodEnum distributionMethod) {
		this.distributionMethod = distributionMethod;
	}

	public PayrollDistributionMethodEnum getDistributionMethod() {
		return distributionMethod;
	}

	public void setPartialPayPeriod(boolean partialPayPeriod) {
		this.partialPayPeriod = partialPayPeriod;
	}

	public boolean isPartialPayPeriod() {
		return partialPayPeriod;
	}
}
