package com.intuit.sb.payroll.capability.workerpayments;

import java.io.Serializable;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

import com.intuit.sb.payroll.entity.model.PaycheckWorkflowStatusEnum;

/**
 * DTO that provides a means to update a restricted set of fields on a Paycheck that has been committed.
 * 
 * $Author$ 
 * $Revision$ 
 * $DateTime$
 */
public class PaycheckUpdateRequest implements Serializable {

	private static final long serialVersionUID = 2882739061438688699L;

	private Long paycheckId;
	private String checkNumber;
	private String memo;
	private PaycheckWorkflowStatusEnum paycheckStatus;

	public PaycheckUpdateRequest() {
	}

	public PaycheckUpdateRequest(Long paycheckId, String checkNumber, String memo,
			PaycheckWorkflowStatusEnum paycheckStatus) {
		this.paycheckId = paycheckId;
		this.checkNumber = checkNumber;
		this.memo = memo;
		this.paycheckStatus = paycheckStatus;
	}

	public Long getPaycheckId() {
		return paycheckId;
	}

	public void setPaycheckId(Long paycheckId) {
		this.paycheckId = paycheckId;
	}

	public String getCheckNumber() {
		return checkNumber;
	}

	public void setCheckNumber(String checkNumber) {
		this.checkNumber = checkNumber;
	}

	public String getMemo() {
		return memo;
	}

	public void setMemo(String memo) {
		this.memo = memo;
	}

	public PaycheckWorkflowStatusEnum getPaycheckStatus() {
		return paycheckStatus;
	}

	public void setPaycheckStatus(PaycheckWorkflowStatusEnum paycheckStatus) {
		this.paycheckStatus = paycheckStatus;
	}

	@Override
	public boolean equals(Object other) {
		return EqualsBuilder.reflectionEquals(this, other);
	}

	@Override
	public int hashCode() {
		return HashCodeBuilder.reflectionHashCode(this);
	}

	@Override
	public String toString() {
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}

}
