package com.intuit.sb.payroll.capability.workerpayments;

import java.io.Serializable;
import java.util.List;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

/**
 * Container class for a set of updates to a Payroll Run.
 * 
 * $Author$ $Revision$ $DateTime$
 */
public class PayrollRunUpdateRequest implements Serializable {

	private static final long serialVersionUID = 1978053986696480870L;

	private Long payrollRunId;
	private List<PaycheckUpdateRequest> paycheckUpdateRequests;

	public PayrollRunUpdateRequest() {
	}

	public PayrollRunUpdateRequest(Long payrollRunId, List<PaycheckUpdateRequest> paycheckUpdateRequests) {
		super();
		this.payrollRunId = payrollRunId;
		this.paycheckUpdateRequests = paycheckUpdateRequests;
	}

	public Long getPayrollRunId() {
		return payrollRunId;
	}

	public void setPayrollRunId(Long payrollRunId) {
		this.payrollRunId = payrollRunId;
	}

	public List<PaycheckUpdateRequest> getPaycheckUpdateRequests() {
		return paycheckUpdateRequests;
	}

	public void setPaycheckUpdateRequests(List<PaycheckUpdateRequest> paycheckUpdateRequests) {
		this.paycheckUpdateRequests = paycheckUpdateRequests;
	}

	@Override
	public boolean equals(Object other) {
		return EqualsBuilder.reflectionEquals(this, other);
	}

	@Override
	public int hashCode() {
		return HashCodeBuilder.reflectionHashCode(this);
	}

	@Override
	public String toString() {
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}

}
