package com.intuit.sb.payroll.capability.workerpayments.impl;

import java.util.List;

import com.intuit.sb.payroll.ValidationException;
import com.intuit.sb.payroll.capability.workerpayments.PayrollRunCommitRequest;
import com.intuit.sb.payroll.capability.workerpayments.PayrollRunInfo;
import com.intuit.sb.payroll.common.validation.AbstractEntityDataValidator;

/**
 * Validates fields in the PayrollRunRequest object.
 * 
 * $Author$ $Revision$ $DateTime$
 * 
 */
public class PayrollRunRequestValidator extends AbstractEntityDataValidator<PayrollRunCommitRequest> {
	private static PayrollRunRequestValidator sInstance = new PayrollRunRequestValidator();

	private PayrollRunRequestValidator() {
	}

	public static PayrollRunRequestValidator getInstance() {
		return sInstance;
	}

	@Override
	public void validateEntityCollection(List<PayrollRunCommitRequest> payRunCollection) throws ValidationException {
		for (PayrollRunCommitRequest payrRun : payRunCollection) {
			validateEntityImpl(payrRun);
		}
	}

	@Override
	public void validateEntity(PayrollRunCommitRequest payRun) throws ValidationException {
		validateEntityImpl(payRun);
	}

	public void validateEntityImpl(PayrollRunCommitRequest payRun) throws ValidationException {
		if (payRun == null) {
			throw new ValidationException("PayrollRunSaveRequest can not be null ..");
		}

		PayrollRunInfo payrollRunInfo = payRun.getPayrollRunInfo();
		PayrollRunInfoValidator.getInstance().validateEntity(payrollRunInfo);
	}
}
