package com.intuit.sb.payroll.capability.workerpayments.impl;

import java.util.List;

import com.intuit.sb.payroll.ValidationException;

public class VoidPaychecksRequestValidator {
	
	private VoidPaychecksRequestValidator(){}
	
	/**
	 * Ensures that the minimal information is present to process a void request.
	 * 
	 * @param request
	 * @throws ValidationException
	 */
    static void validateVoidPaychecksRequest(List<Long> paycheckIds) throws ValidationException {
		if (null == paycheckIds) {
			throw new ValidationException("paycheckIds list is null");
		}
		if (0 == paycheckIds.size()) {
			throw new ValidationException("paycheckIds list is empty");
		}
		for (Long paycheckId : paycheckIds) {
			if (null == paycheckId) {
				throw new ValidationException("paycheckId is null");
			}
		}
    }
}
