package com.intuit.sb.payroll.capability.workerpayments.impl.calcengine;

import java.util.List;

import com.intuit.sb.payroll.entity.model.Employer;
import com.intuit.sb.payroll.entity.model.Worker;
import com.intuit.sb.payroll.entity.workerpayments.CompanyAdjustmentTotals;
import com.intuit.sb.payroll.entity.workerpayments.WorkerTotals;

public class AdjustmentContext extends PayrollEngineContext {

	private List<Worker> affectedWorkers;
	private CompanyAdjustmentTotals companyTotals;
	private WorkerTotals workerTotals;

	public AdjustmentContext(Employer employer) {
		this.setEmployer(employer);
	}
	
	public CompanyAdjustmentTotals getCompanyTotals() {
		return this.companyTotals;
	}

	public void setCompanyTotals(CompanyAdjustmentTotals priorAdjustments) {
		this.companyTotals = priorAdjustments;
	}

	public void setWorkerTotals(WorkerTotals workerTotals) {
		this.workerTotals = workerTotals;
	}

	public WorkerTotals getWorkerTotals() {
		return workerTotals;
	}

	public void setAffectedWorkers(List<Worker> affectedWorkers) {
		this.affectedWorkers = affectedWorkers;
	}

	public List<Worker> getAffectedWorkers() {
		return affectedWorkers;
	}
}
