package com.intuit.sb.payroll.capability.workerpayments.impl.calcengine;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

import org.apache.log4j.Logger;

import com.intuit.dataTypes.QBDate;
import com.intuit.payroll.j.AdjustmentDatesChooserIf;
import com.intuit.sb.payroll.common.PayrollLoggerFactory;
// Callback allows Gemini to determine the desired date for adjustment transactions in each quarter. 
// Presumably this would be the date of the last transaction in that quarter. 
class AdjustmentDatesChooser implements AdjustmentDatesChooserIf {

	private static Logger sLogger = PayrollLoggerFactory.makeLogger("-=:|AdjustmentsIntegration|:=-");
	
	public Map<QBDate, QBDate> getAdjustmentDatesPerQtr(Collection<QBDate> keys) {
		// Normally would return the last date of ANY payroll tx in each of the passed quarters
		// For now just return the passed date
		Map<QBDate, QBDate> result = new HashMap<QBDate, QBDate>();
		for (QBDate key : keys) {
			result.put(key, key);
			sLogger.info("Adding AdjustmentDate in Qtr:" + key.toShortString());
		}
		return result;
	}

}
