package com.intuit.sb.payroll.capability.workerpayments.impl.calcengine;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import com.intuit.payroll.j.AdjustmentControllerIf;
import com.intuit.payroll.j.AdjustmentDatesChooserIf;
import com.intuit.payroll.j.AdjustmentIf;
import com.intuit.payroll.j.CompanyIf;
import com.intuit.payroll.j.EmployeeAdjustmentCreatorIf;
import com.intuit.payroll.j.EmployeeIf;
import com.intuit.sb.payroll.entity.model.Worker;


public class EmployeeAdjustmentController {

	public static Collection<AdjustmentIf> createEmployeeAdjustments(AdjustmentContext adjustmentContext) {
		CompanyIf qboCompany = adjustmentContext.getQboCompany();
		AdjustmentControllerIf controller = qboCompany.getPayrollCheckupAdjustmentController();
		Collection<AdjustmentIf> allAdjustments = new ArrayList<AdjustmentIf>();
		List<EmployeeIf> qboEmployees = createQboEmployees(adjustmentContext);
		//For each employee that needs an adjustment, duu it.
		for (EmployeeIf qboEmployee : qboEmployees) {
			EmployeeAdjustmentCreatorIf empAdjCreator =
	            controller.createEmployeeAdjustmentCreator(qboEmployee, qboEmployee.getTotalsCollection(), null);
			AdjustmentDatesChooserIf datesChooser = new AdjustmentDatesChooser();
			Collection<AdjustmentIf> createdAdjustments = empAdjCreator.createAdjustments(datesChooser);			
			allAdjustments.addAll(createdAdjustments);
		}

		return allAdjustments;
	}

	private static List<EmployeeIf> createQboEmployees(AdjustmentContext adjustmentContext) {
		//Following the pattern of creating paychecks, create employees.
		List<EmployeeIf> results = new ArrayList<EmployeeIf>();
		List<Worker> affectedWorkers = adjustmentContext.getAffectedWorkers();
		for (Worker worker : affectedWorkers) {
			EmployeeIf qboEmployee = mapWorkerToEmployee(worker, adjustmentContext);
			results.add(qboEmployee);
		}
		return results;
	}

	private static EmployeeIf mapWorkerToEmployee(Worker worker, AdjustmentContext adjustmentContext) {
		
		return null;
	}
}
