package com.intuit.sb.payroll.capability.workerpayments.impl.calcengine;

import java.text.MessageFormat;
import java.util.Map;

import org.apache.commons.lang.StringUtils;

import com.intuit.payroll.j.NationalRegionIf;
import com.intuit.sb.payroll.entity.model.GlobalPostalAddress;

/**
 * Maps from a state or province to a Calc engine state or province.
 * 
 * $Author: $ $Revision: $ $DateTime: $
 * 
 */
@SuppressWarnings("nls")
public abstract class NationalRegionMapper {
	public NationalRegionIf mapToNationalRegion(GlobalPostalAddress address) {
		String region = address.getCountrySubDivisionCode();
		
		if (StringUtils.isEmpty(region)) {
			String mesg = CalcEngineResources.getString("MissingNationalRegion"); //$NON-NLS-1$

			throw new IllegalArgumentException(mesg);
		}

		NationalRegionIf payrollRegion = getRegionMap().get(region);

		if (null == payrollRegion) {
			String mesg = MessageFormat.format(CalcEngineResources.getString("UnsupportedRegion"), region); //$NON-NLS-1$

			throw new IllegalArgumentException(mesg);
		}
		return payrollRegion;
	}

	protected abstract Map<String, ? extends NationalRegionIf> getRegionMap();
}
