package com.intuit.sb.payroll.capability.workerpayments.impl.calcengine;

import java.util.Map;

import com.intuit.payroll.j.EmployeeIf;
import com.intuit.payroll.j.PaycheckIf;
import com.intuit.payroll.j.PaycheckLineIf;
import com.intuit.sb.payroll.entity.model.Employer;
import com.intuit.sb.payroll.entity.model.Paycheck;
import com.intuit.sb.payroll.entity.model.PaycheckLineItem;
import com.intuit.sb.payroll.entity.model.Worker;

public class PaycheckCalculationContext extends PayrollEngineContext {

	private EmployeeIf qboeEmployee;
	private PaycheckIf qboePaycheck;
	private Worker worker;
	private Map<PaycheckLineIf, PaycheckLineItem> paycheckLineItemMap;
	private Paycheck paycheck;

	public PaycheckCalculationContext(Employer employer, Worker worker, 
			Map<PaycheckLineIf, PaycheckLineItem> paycheckLineItemMap) {
		this.setEmployer(employer);
		this.worker = worker;
		this.paycheckLineItemMap = paycheckLineItemMap;
	}

	public EmployeeIf getQboeEmployee() {
		return qboeEmployee;
	}

	public void setQboeEmployee(EmployeeIf qboeEmployee) {
		this.qboeEmployee = qboeEmployee;
	}

	public PaycheckIf getQboePaycheck() {
		return qboePaycheck;
	}

	public void setQboePaycheck(PaycheckIf qboePaycheck) {
		this.qboePaycheck = qboePaycheck;
	}

	public Worker getWorker() {
		return worker;
	}

	public void setWorker(Worker worker) {
		this.worker = worker;
	}

	public void setPaycheck(Paycheck paycheck) {
		this.paycheck = paycheck;
	}

	public Paycheck getPaycheck() {
		return paycheck;
	}

	public Map<PaycheckLineIf, PaycheckLineItem> getPaycheckLineItemMap() {
		return paycheckLineItemMap;
	}

	public void setPaycheckLineItemMap(
			Map<PaycheckLineIf, PaycheckLineItem> paycheckLineItemMap) {
		this.paycheckLineItemMap = paycheckLineItemMap;
	}
	
}
