package com.intuit.sb.payroll.capability.workerpayments.impl.calcengine;

import java.util.EnumMap;

import com.intuit.payroll.types.enumtype.PayFrequencyType;
import com.intuit.sb.payroll.entity.model.PayrollFrequencyEnum;

public class PayrollFrequencyMapper {
	private static EnumMap<PayrollFrequencyEnum, PayFrequencyType> PayrollFrequencyMap = new EnumMap<PayrollFrequencyEnum, PayFrequencyType>(
			PayrollFrequencyEnum.class);
	static {
		PayrollFrequencyMap.put(PayrollFrequencyEnum.DAILY, PayFrequencyType.DAILY);
		PayrollFrequencyMap.put(PayrollFrequencyEnum.WEEKLY, PayFrequencyType.WEEKLY);
		PayrollFrequencyMap.put(PayrollFrequencyEnum.BIWEEKLY, PayFrequencyType.BIWEEKLY);
		PayrollFrequencyMap.put(PayrollFrequencyEnum.SEMIMONTHLY, PayFrequencyType.SEMIMONTHLY);
		PayrollFrequencyMap.put(PayrollFrequencyEnum.MONTHLY, PayFrequencyType.MONTHLY);
		PayrollFrequencyMap.put(PayrollFrequencyEnum.QUARTERLY, PayFrequencyType.QUARTERLY);
		PayrollFrequencyMap.put(PayrollFrequencyEnum.SEMIANNUALLY, PayFrequencyType.SEMIANNUALLY);
		PayrollFrequencyMap.put(PayrollFrequencyEnum.ANNUALLY, PayFrequencyType.ANNUALLY);
		PayrollFrequencyMap.put(PayrollFrequencyEnum.RARELY, PayFrequencyType.RARELY);
	}

	private PayrollFrequencyMapper () {}
	
	/**
	 * Map a payroll frequency to a QBOE {@PayFrequencyType}.
	 * 
	 * @param payrollFrequency
	 *            The payroll frequency to map.
	 * @return the mapped payroll frequency.
	 */
	public static PayFrequencyType mapToPayFrequency(PayrollFrequencyEnum payrollFrequency) {
		return PayrollFrequencyMap.get(payrollFrequency);
	}
}
