package com.intuit.sb.payroll.capability.workerpayments.impl.calcengine;

import java.util.ArrayList;
import java.util.List;

public class PayrollItemHandlerChain {
	
	private final List<PayrollItemHandler> handlerList;
	
	public PayrollItemHandlerChain() {
		this.handlerList = new ArrayList<PayrollItemHandler>();
	}
	
	public void addHandler(PayrollItemHandler handler) {
		handlerList.add(handler);
	}
	
	public void removeHandler(PayrollItemHandler handler) {
		handlerList.remove(handler);
	}
	
	public void addHandlers(List<PayrollItemHandler> handlers) {
		handlerList.addAll(handlers);
	}
	
	public void execute(PaycheckCalculationContext context) {
		for (PayrollItemHandler handler : handlerList) {
			handler.handle(context);
		}
	}
	
	public void reset() {
		handlerList.clear();
	}
}
