/**
 * 
 */
package com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.handlers;

import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.Set;

import com.intuit.payroll.j.EmployeeIf;
import com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.PaycheckCalculationContext;
import com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.PayrollEngineContext;
import com.intuit.sb.payroll.entity.model.DeductionDtl;
import com.intuit.sb.payroll.entity.model.DeductionTypeEnum;
import com.intuit.sb.payroll.entity.model.Worker;

/**
 * $Author: $ 
 * $Revision: $
 * $DateTime: $
 *
 */
public class CALoanRepaymentDeductionHandler extends AbstractFlatRateDeductionHandler {

	private static List<Locale> localeList = new ArrayList<Locale>();
	
	//FIXME this can come from JavaConfig @ExternalValue?  Otherwise, externalize locale-to-handler collections.
	static {
		localeList.add(Locale.CANADA);
	}
	
	/**
	 * FIXME get the law id from CanadaLawId
	 */
	public String getLawId() {
		return "";
	}
	
	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.PayrollItemHandler#handle(com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.PaycheckCalculationContext)
	 */
	public void handle(PaycheckCalculationContext context) {
		Set<DeductionDtl> workerDeductions = context.getWorker().getDeductionDtls();
		for (final DeductionDtl deductionDtl : workerDeductions) {
			if (deductionDtl.getDeductionType() == DeductionTypeEnum.LOANREPAYMENT) {
				handleImpl(context, deductionDtl);
			}
		}
	}
	
	public void createQboPayrollItemsFromPayrollItemDtls(PayrollEngineContext context, EmployeeIf employee,
			Worker worker) {
		Set<DeductionDtl> workerDeductions = worker.getDeductionDtls();
		for (final DeductionDtl deductionDtl : workerDeductions) {
			if (deductionDtl.getDeductionType() == DeductionTypeEnum.LOANREPAYMENT) {
				createImpl(context, worker, employee, deductionDtl);
			}
		}
	}

	public List<Locale> getLocaleList() {
		return localeList ;
	}
}
