package com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.handlers;

import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.Set;

import com.intuit.payroll.j.EmployeeIf;
import com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.PaycheckCalculationContext;
import com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.PayrollEngineContext;
import com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.QboeLawIdConstants;
import com.intuit.sb.payroll.entity.model.CompensationDtl;
import com.intuit.sb.payroll.entity.model.CompensationTypeEnum;
import com.intuit.sb.payroll.entity.model.Worker;

public class IntlCommissionCompensationHandler extends AbstractFlatRateCompensationHandler {

	private static List<Locale> localeList = new ArrayList<Locale>();

	static {
		localeList.add(Locale.US);
		localeList.add(Locale.CANADA);
	}

	public String getLawId() {
		return QboeLawIdConstants.sCommissionLawId;
	}

	public List<Locale> getLocaleList() {
		return localeList;
	}

	public void handle(PaycheckCalculationContext context) {
		Set<CompensationDtl> workerCompensations = context.getWorker().getCompensationDtls();
		for (final CompensationDtl compensationDtl : workerCompensations) {
			if (compensationDtl.getCompensationType() == CompensationTypeEnum.COMMISSION) {
				handleImpl(context, compensationDtl);
			}
		}
	}
	
	/*
	 * (non-Javadoc)
	 * @see com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.PayrollItemHandler#createQboPayrollItemsFromPayrollItemDtls(com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.PayrollEngineContext, com.intuit.payroll.j.EmployeeIf, com.intuit.sb.payroll.entity.model.Worker)
	 */
	public void createQboPayrollItemsFromPayrollItemDtls(PayrollEngineContext context, EmployeeIf employee,	Worker worker) {
		Set<CompensationDtl> workerCompensations = worker.getCompensationDtls();
		for (final CompensationDtl compensationDtl : workerCompensations) {
			if (compensationDtl.getCompensationType() == CompensationTypeEnum.COMMISSION) {
				createImpl(context, worker, employee, compensationDtl);
			}
		}
	}
}
