package com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.handlers;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Locale;
import java.util.Set;

import com.intuit.payroll.j.EmployeeIf;
import com.intuit.payroll.j.EmployeePayrollItemIf;
import com.intuit.payroll.j.PaycheckLineIf;
import com.intuit.payroll.j.PayrollItemIf;
import com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.PaycheckCalculationContext;
import com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.PayrollEngineContext;
import com.intuit.sb.payroll.entity.model.PaycheckLineItem;
import com.intuit.sb.payroll.entity.model.TaxDtl;
import com.intuit.sb.payroll.entity.model.Worker;

public class IntlTaxHandler extends AbstractPayrollItemHandler {

	private static List<Locale> localeList = new ArrayList<Locale>();

	static {
		localeList.add(Locale.US);
		localeList.add(Locale.CANADA);
	}
	
	public void createQboPayrollItemsFromPayrollItemDtls(PayrollEngineContext context, EmployeeIf employee,
			Worker worker) {
		Set<TaxDtl> taxDtls = worker.getTaxDtls();
		for (TaxDtl taxDtl : taxDtls) {
			
			String lawId = String.valueOf(taxDtl.getPayrollItem().getLawId().getValue());
			PayrollItemIf qboePayrollItem = context.getPayrollItemForLaw(lawId);
			
			employee.createEmployeePayrollItem(qboePayrollItem);
			//We don't set tax rates, they are set for us by the PE.
		}
		
	}

	public String getLawId() {
		// TODO Auto-generated method stub
		return null;
	}

	public List<Locale> getLocaleList() {
		return localeList;
	}

	public void handle(PaycheckCalculationContext context) {
		Worker worker = context.getWorker();
		Set<TaxDtl> taxDtls = worker.getTaxDtls();
		for (TaxDtl taxDtl : taxDtls) {
			EmployeePayrollItemIf qboeEmployeePayrollItem = null;
			
			String lawId = taxDtl.getPayrollItem().getLawId().getValue();
			Collection<EmployeePayrollItemIf> employeePayrollItems = context.getQboeEmployee().getEmployeePayrollItems();
			for (EmployeePayrollItemIf employeePayrollItemIf : employeePayrollItems) {
				String ePILawId = new Integer(employeePayrollItemIf.getPayrollItem().getDetailType().toInt()).toString();
				if (lawId.equals(ePILawId)) {
					//It's already on the employee
					qboeEmployeePayrollItem = employeePayrollItemIf;
					break;
				}
			}
			
			//If it was not found, create it.
			if (qboeEmployeePayrollItem == null) {
				PayrollItemIf qboePayrollItem = context.getPayrollItemForLaw(lawId);
				
				qboeEmployeePayrollItem = context.getQboeEmployee().createEmployeePayrollItem(
						qboePayrollItem);
			}

			// Create a line item for OE, one for us. Link the Line item to the
			// original Payroll Item
			PaycheckLineIf qboePaycheckLine = context.getQboePaycheck().createLine(qboeEmployeePayrollItem);
			PaycheckLineItem paycheckLineItem = new PaycheckLineItem();
			paycheckLineItem.setSourcePayrollItemDtl(taxDtl);

			// YTD			
			createYTDTotals(context, worker, taxDtl, qboeEmployeePayrollItem);
			
			context.getPaycheck().addPaycheckLineItem(paycheckLineItem);
			context.getPaycheckLineItemMap().put(qboePaycheckLine, paycheckLineItem);
		}

	}

}
