package com.intuit.sb.payroll.common;

import com.intuit.sb.payroll.ValidationException;

/**
 * Base class for classes that evaluate the completeness of an entity.  Returns the state.
 *
 * $Author$
 * $Revision$
 * $DateTime$
 *
 * @see PayrollEntityDataState
 * @param <T>
 */
public abstract class AbstractPayrollEntityDataEvaluator<T extends Object> implements PayrollEntityDataEvaluator<T>
{
	public abstract PayrollEntityDataState evaluateState(T entity) throws ValidationException;
	
}
