package com.intuit.sb.payroll.common;

import org.apache.log4j.Logger;

import com.intuit.sb.payroll.common.i18n.LocaleGuru;

/**
 * This class manages payroll related resource Strings
 * 
 * $Author$ $Revision$ $DateTime$
 */
@SuppressWarnings("nls")
public class PayrollResourceManager {
	private static PayrollResourceManager sInstance = new PayrollResourceManager();
	private static final String sPayrollResourceName = "com.intuit.sb.payroll.common.payroll-resources";
	private static final Logger sLogger = PayrollLoggerFactory.makeLogger(PayrollResourceManager.class);

	public static PayrollResourceManager getInstance() {
		return sInstance;
	}

	/**
	 * Private constructor to disable instantiation
	 * 
	 * @param locale
	 */
	private PayrollResourceManager() {

	}

	/**
	 * Static convenience accessor for retrieving the a string from the current ResourceBundle.
	 * 
	 * @param key the string key into the resource bundle
	 * @return the string from the current resource bundle, having the given key
	 */
	public String getString(String key) {
		try {
			return LocaleGuru.getInstance().getString(sPayrollResourceName, key);
		} catch (Exception e) {
			sLogger.error("Resource Value not found for key - " + key + "\n");
			return null;
		}
	}
}
