package com.intuit.sb.payroll.common;

import java.io.Serializable;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

/**
 * WIP - Capturing the data missing for Entities to be in a certain state.
 *
 */
public class RequiredData implements Serializable {

	private static final long serialVersionUID = -7408340018081913316L;
	
	private String fieldName;
	private String entityName;
	private String description;
	private String key;

	public RequiredData() {
	}

	public RequiredData(String key, String fieldName, String entityName, String description) {
		this.key = key;
		this.fieldName = fieldName;
		this.entityName = entityName;
		this.description = description;
	}

	public String getKey() {
		return key;
	}

	public void setKey(String aKey) {
		this.key = aKey;
	}

	public String getFieldName() {
		return fieldName;
	}

	public void setFieldName(String fieldName) {
		this.fieldName = fieldName;
	}

	public String getEntityName() {
		return entityName;
	}

	public void setEntityName(String entityName) {
		this.entityName = entityName;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	@Override
	public boolean equals(Object other) {
		return EqualsBuilder.reflectionEquals(this, other);
	}

	@Override
	public int hashCode() {
		return HashCodeBuilder.reflectionHashCode(this);
	}

	@Override
	public String toString() {
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}
}
