package com.intuit.sb.payroll.common.management;

import java.io.Serializable;
import java.util.Calendar;

/**
 * SystemDate is a simple wrapper to allow for selective overrides of the date that the business logic
 * will respect, to allow for testing past and future behaviour without changing the actual system date.
 * 
 * The intent of this is for it to be used in the context of a ThreadLocal or a singleton JMX bean.
 * @see PayrollService#getSystemDate()
 * 
 * $Author$ 
 * $Revision$
 * $DateTime$
 *
 */
class SystemDate implements Serializable {

	private static final long serialVersionUID = -2743096912259848363L;
	
	private Calendar date;
	
	public SystemDate() {}
	
	public SystemDate(Calendar aDate) {
		this.date = aDate;
	}

	public Calendar getDate() {
		return date;
	}

	public void setDate(Calendar date) {
		this.date = date;
	}
	
}
