package com.intuit.sb.payroll.common.management;

import java.util.Calendar;

import org.testng.AssertJUnit;
import org.testng.annotations.Test;

import com.intuit.sb.payroll.common.DateUtil;

/**
 * Tests {@link PayrollService}
 * 
 * $Author: $ 
 * $Revision: $
 * $DateTime: $
 *
 */
public class PayrollServiceTest {

	@Test
	public void testSystemDateSetting() throws Exception {
		Calendar initialDate = PayrollService.getInstance().getSystemDate();
		AssertJUnit.assertTrue(DateUtil.isSameDay(DateUtil.getNowCalendar(), initialDate));
		
		Calendar nowDate = DateUtil.createCalendar(2008, 0, 1);
		PayrollService.getInstance().setSystemDate(nowDate);
		Calendar thenDate = PayrollService.getInstance().getSystemDate();
		AssertJUnit.assertEquals("Date is not on same day", nowDate, thenDate);
	}
}
