/*
 * -------------------------------------------------------------
 * Copyright (c) 2008 Intuit, Inc. All rights reserved.
 * Unauthorized reproduction is a violation of applicable law.
 * -------------------------------------------------------------
 *
 * -------------------------------------------------------------
 * Paycheck.java
 * @author auto-generated
 * -------------------------------------------------------------
 */

package com.intuit.sb.payroll.entity.model;

import javax.persistence.Transient;

/**
 * Fundamental payroll transaction representing periodic payment for employment service performed by a {@link Worker}.
 */
public class Paycheck extends PaycheckBase
{
    /**
     * Generated serial version id.
     */
    private static final long serialVersionUID = 3171536964602674891L;
    
    private boolean beingVoided;

    /**
     * Empty default constructor.
     */
    public Paycheck()
    {
        // This constructor is intentionally left empty.
    }

    /**
     * During the void process, set this so that components that handle the Paycheck can treat it accordingly.
     * This attribute is non-persistent.
     * 
     * @param beingVoided
     */
	public void setBeingVoided(boolean beingVoided) {
		this.beingVoided = beingVoided;
	}

	/**
	 * True if the Paycheck is in the process of being Voided.
	 * @return
	 */
	@Transient
	public boolean isBeingVoided() {
		return beingVoided;
	}
    

}
