    -- WARNING: UNSUPPORTED OPERATION NOT INCLUDED: Changing column type for PAYDATE from TIMESTAMP to DATE

    -- WARNING: UNSUPPORTED OPERATION NOT INCLUDED: Changing column type for PAYDATE from TIMESTAMP to DATE

		
CREATE TABLE PAYMENT (
    PRIMARY KEY(ID),
    ID NUMBER(20,0) NOT NULL, 
    REALM_ID NUMBER(20,0) DEFAULT -1 NOT NULL, 
    PAYMENTDATE DATE NULL, 
    PAYROLLPERIOD_STARTDATE DATE NULL, 
    PAYROLLPERIOD_ENDDATE DATE NULL, 
    CREATIONDATE TIMESTAMP NULL, 
    CREATEDBY VARCHAR2(100) NULL, 
    LASTMODIFICATIONDATE TIMESTAMP NULL, 
    LASTMODIFIEDBY VARCHAR2(100) NULL, 
    VERSION NUMBER(20,0) NOT NULL, 
    UUID VARCHAR2(255) NOT NULL, 
    EMPLOYER NUMBER(20,0) NULL
)
/

CREATE TABLE PAYMENTLINEITEM (
    PRIMARY KEY(ID),
    ID NUMBER(20,0) NOT NULL, 
    REALM_ID NUMBER(20,0) DEFAULT -1 NOT NULL, 
    AMOUNT_CUR VARCHAR2(100) NULL, 
    AMOUNT_AMT NUMBER(19,4) NULL, 
    PAYMENTTYPE VARCHAR2(100) DEFAULT 'NOTSET' NOT NULL, 
    CREATIONDATE TIMESTAMP NULL, 
    CREATEDBY VARCHAR2(100) NULL, 
    LASTMODIFICATIONDATE TIMESTAMP NULL, 
    LASTMODIFIEDBY VARCHAR2(100) NULL, 
    VERSION NUMBER(20,0) NOT NULL, 
    UUID VARCHAR2(255) NOT NULL, 
    PAYMENT NUMBER(20,0) NULL
)
/

CREATE TABLE PAYMENTLINEITEMSPLIT (
    PRIMARY KEY(ID),
    ID NUMBER(20,0) NOT NULL, 
    REALM_ID NUMBER(20,0) DEFAULT -1 NOT NULL, 
    SPLITAMOUNT_CUR VARCHAR2(100) NULL, 
    SPLITAMOUNT_AMT NUMBER(19,4) NULL, 
    SPLITDERIVED CHAR(1) NULL, 
    CREATIONDATE TIMESTAMP NULL, 
    CREATEDBY VARCHAR2(100) NULL, 
    LASTMODIFICATIONDATE TIMESTAMP NULL, 
    LASTMODIFIEDBY VARCHAR2(100) NULL, 
    VERSION NUMBER(20,0) NOT NULL, 
    UUID VARCHAR2(255) NOT NULL, 
    PAYROLLITEM NUMBER(20,0) NOT NULL, 
    PAYMENTLINEITEM NUMBER(20,0) NULL
)
/

CREATE INDEX PAYMENTLINEITEM_RX ON PAYMENTLINEITEM(REALM_ID ASC)
/

CREATE INDEX PAYMENTLINEITEM_FK_PAYMENT ON PAYMENTLINEITEM(PAYMENT ASC)
/

ALTER TABLE PAYMENTLINEITEM ADD CONSTRAINT PAYMENTLINEITEM_FK_PAYMENT
    FOREIGN KEY (PAYMENT)
    REFERENCES PAYMENT (ID)
/

CREATE OR REPLACE TRIGGER "PAYMENTLINEITEM_VT" BEFORE INSERT OR UPDATE ON "PAYMENTLINEITEM"
    FOR EACH ROW
    BEGIN
     IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 
    END;
/

CREATE INDEX PAYMENTLINEITEMSPLIT_RX ON PAYMENTLINEITEMSPLIT(REALM_ID ASC)
/

CREATE INDEX PAYMNTLITMSPLT_FK_PAYITM ON PAYMENTLINEITEMSPLIT(PAYROLLITEM ASC)
/

CREATE INDEX PAYMNTLITM_FK_PAYMNTLITMSPLT ON PAYMENTLINEITEMSPLIT(PAYMENTLINEITEM ASC)
/

ALTER TABLE PAYMENTLINEITEMSPLIT ADD CONSTRAINT PAYMNTLITMSPLT_FK_PAYITM
    FOREIGN KEY (PAYROLLITEM)
    REFERENCES PAYROLLITEM (ID)
/

ALTER TABLE PAYMENTLINEITEMSPLIT ADD CONSTRAINT PAYMNTLITM_FK_PAYMNTLITMSPLT
    FOREIGN KEY (PAYMENTLINEITEM)
    REFERENCES PAYMENTLINEITEM (ID)
/

CREATE OR REPLACE TRIGGER "PAYMENTLINEITEMSPLIT_VT" BEFORE INSERT OR UPDATE ON "PAYMENTLINEITEMSPLIT"
    FOR EACH ROW
    BEGIN
     IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 
    END;
/

CREATE INDEX PAYMENT_RX ON PAYMENT(REALM_ID ASC)
/

CREATE INDEX PAYMENT_FK_EMPLOYER ON PAYMENT(EMPLOYER ASC)
/

ALTER TABLE PAYMENT ADD CONSTRAINT PAYMENT_FK_EMPLOYER
    FOREIGN KEY (EMPLOYER)
    REFERENCES EMPLOYER (ID)
/

CREATE OR REPLACE TRIGGER "PAYMENT_VT" BEFORE INSERT OR UPDATE ON "PAYMENT"
    FOR EACH ROW
    BEGIN
     IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 
    END;
/


ALTER TABLE PAYROLLRUN ADD (PARTIALPERIOD CHAR(1) NULL)
/

CREATE INDEX PAYCHK_PAYDATE_IDX ON PAYCHECK(PAYDATE ASC)
/

GRANT SELECT, INSERT, UPDATE, DELETE ON PAYMENTLINEITEM TO &&2
/

GRANT SELECT, INSERT, UPDATE, DELETE ON PAYMENTLINEITEMSPLIT TO &&2
/

GRANT SELECT, INSERT, UPDATE, DELETE ON PAYMENT TO &&2
/

UPDATE PROJECT_VERSIONS_TABLE SET SCHEMA_VERSION='1.0.27', TIMESTAMP='2009-06-17 13:53:55.006' WHERE PROJECT_ID='_c4GAoJEkEd2zF5tDuPZkGw'
/

