	
    --
    -- VPD Twin-schema deployment - "APP" schema
    -- consisting of SYNONYMs and POLICY defintions
    --
DECLARE
	synonym_exists PLS_INTEGER;
  	object_exists PLS_INTEGER;
  	abort_run PLS_INTEGER := 0;
  	target_table_name VARCHAR(1024);
  	create_command VARCHAR2(1024);
  	grant_command VARCHAR2(1024);
  	drop_command VARCHAR(1024);
  	synonym_command VARCHAR2(1024);
  	BEGIN   
 		
	--
	-- check for the existence of the system table/sequence defintions from the APP schema as 
	-- this schema should only contain synonyms
	--
	--
	-- check for SBCORE_VPD_TABLE
	--
	SELECT COUNT(*) INTO object_exists
    FROM "USER_TABLES"
    WHERE TABLE_NAME = 'SBCORE_VPD_TABLE';
    IF object_exists = 1 THEN
      --EXECUTE IMMEDIATE 'DROP TABLE "SBCORE_VPD_TABLE" CASCADE CONSTRAINTS';
      abort_run := 1;
      RAISE_APPLICATION_ERROR(-20500, 'SBCORE_VPD_TABLE exists in APP schema, please drop this TABLE and rerun this script.');
    END IF;	
    --
   	-- check for PROJECT_VERSIONS_TABLE
   	--
    SELECT COUNT(*) INTO object_exists
    FROM "USER_TABLES"
    WHERE TABLE_NAME = 'PROJECT_VERSIONS_TABLE';
    IF object_exists = 1 THEN
      --EXECUTE IMMEDIATE 'DROP TABLE "PROJECT_VERSIONS_TABLE'" CASCADE CONSTRAINTS';
      abort_run := 1;
      RAISE_APPLICATION_ERROR(-20501, 'PROJECT_VERSIONS_TABLE exists in APP schema, please drop this TABLE and rerun this script.');
    END IF;	
  	--
  	-- check for SBCORE_VPD_SEQ
  	--
    SELECT COUNT(*) INTO object_exists
    FROM "USER_SEQUENCES"
    WHERE SEQUENCE_NAME = 'SBCORE_VPD_SEQ';
    IF object_exists = 1 THEN
      --EXECUTE IMMEDIATE 'DROP SEQUENCE "SBCORE_VPD_SEQ"';
      abort_run := 1;
      RAISE_APPLICATION_ERROR(-20502, 'SBCORE_VPD_SEQ exists in APP schema, please drop this SEQUENCE and rerun this script.');
    END IF;	
  	--
  	-- check for HIBERNATE_SEQUENCE
  	--
    SELECT COUNT(*) INTO object_exists
    FROM "USER_SEQUENCES"
    WHERE SEQUENCE_NAME = 'HIBERNATE_SEQUENCE';
    IF object_exists = 1 THEN
      --EXECUTE IMMEDIATE 'DROP SEQUENCE "HIBERNATE_SEQUENCE"';
      abort_run := 1;
      RAISE_APPLICATION_ERROR(-20503, 'HIBERNATE_SEQUENCE exists in APP schema, please drop this SEQUENCE and rerun this script.');     
    END IF;
    --
    -- check for HIBERNATE_SEQ
    --
    SELECT COUNT(*) INTO object_exists
    FROM "USER_SEQUENCES"
    WHERE SEQUENCE_NAME = 'HIBERNATE_SEQ';
    IF object_exists = 1 THEN
      --EXECUTE IMMEDIATE 'DROP SEQUENCE "HIBERNATE_SEQ"';
      abort_run := 1;
      RAISE_APPLICATION_ERROR(-20504, 'HIBERNATE_SEQ exists in APP schema, please drop this SEQUENCE and rerun this script.');    
    END IF;
    --
    	
	IF abort_run = 0 THEN
    	--
    	-- Create synonyms to non-generated artifacts that are needed to support
    	-- the VPD implementation
    	-- 
    	-- VPD internal to external realm-i lookup table
    	-- 
    	
		target_table_name := '&&1' || '.SBCORE_VPD_TABLE';
		create_command := 'CREATE OR REPLACE SYNONYM SBCORE_VPD_TABLE FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

	  	--
	  	-- vpd sequence generator for realm-ids
	  	--
    	
		target_table_name := '&&1' || '.SBCORE_VPD_SEQ';
		create_command := 'CREATE OR REPLACE SYNONYM SBCORE_VPD_SEQ FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

	  	--
	    --anduril schema version info table
	    --
    	
		target_table_name := '&&1' || '.PROJECT_VERSIONS_TABLE';
		create_command := 'CREATE OR REPLACE SYNONYM PROJECT_VERSIONS_TABLE FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

		--
    END IF;
    	
	--
    -- Generated using Intuit's Oracle VPD DDL Xpand template
    --
    -- Create sequences
    
    -- Create tables 
    
    
    
    

    
    
    -- Functions
    
    
    

    -- Synonyms
    
    
		target_table_name := '&&1' || '.HISTPAYCHECKLINEITEM';
		create_command := 'CREATE OR REPLACE SYNONYM HISTPAYCHECKLINEITEM FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.PAYROLLITEM';
		create_command := 'CREATE OR REPLACE SYNONYM PAYROLLITEM FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.HISTPAYCHECK';
		create_command := 'CREATE OR REPLACE SYNONYM HISTPAYCHECK FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.PAYROLLSCHEDULE';
		create_command := 'CREATE OR REPLACE SYNONYM PAYROLLSCHEDULE FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.CONTACTPERSON';
		create_command := 'CREATE OR REPLACE SYNONYM CONTACTPERSON FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.PAYROLLITEMDTL';
		create_command := 'CREATE OR REPLACE SYNONYM PAYROLLITEMDTL FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.DISABILITYINSDOCDTL';
		create_command := 'CREATE OR REPLACE SYNONYM DISABILITYINSDOCDTL FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.WORKERADJLINEITEM';
		create_command := 'CREATE OR REPLACE SYNONYM WORKERADJLINEITEM FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.BANKACCOUNT';
		create_command := 'CREATE OR REPLACE SYNONYM BANKACCOUNT FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.EMPLOYERCOMPLIANCEDOCDTL';
		create_command := 'CREATE OR REPLACE SYNONYM EMPLOYERCOMPLIANCEDOCDTL FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.EMPLOYMENTPERIOD';
		create_command := 'CREATE OR REPLACE SYNONYM EMPLOYMENTPERIOD FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.EMPLOYERADJLINEITEM';
		create_command := 'CREATE OR REPLACE SYNONYM EMPLOYERADJLINEITEM FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.JURISDICTION';
		create_command := 'CREATE OR REPLACE SYNONYM JURISDICTION FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.COMPLIANCEDOC';
		create_command := 'CREATE OR REPLACE SYNONYM COMPLIANCEDOC FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.PAYMENT';
		create_command := 'CREATE OR REPLACE SYNONYM PAYMENT FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.INDUSTRYTYPE';
		create_command := 'CREATE OR REPLACE SYNONYM INDUSTRYTYPE FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.BENEFITPROVIDER';
		create_command := 'CREATE OR REPLACE SYNONYM BENEFITPROVIDER FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.PAYCHECKLINEITEM';
		create_command := 'CREATE OR REPLACE SYNONYM PAYCHECKLINEITEM FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.LEGALSTRUCTURE';
		create_command := 'CREATE OR REPLACE SYNONYM LEGALSTRUCTURE FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.PAYMENTLINEITEMSPLIT';
		create_command := 'CREATE OR REPLACE SYNONYM PAYMENTLINEITEMSPLIT FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.PAYCHECK';
		create_command := 'CREATE OR REPLACE SYNONYM PAYCHECK FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.LAW';
		create_command := 'CREATE OR REPLACE SYNONYM LAW FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.WORKER';
		create_command := 'CREATE OR REPLACE SYNONYM WORKER FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.PAYROLLRUN';
		create_command := 'CREATE OR REPLACE SYNONYM PAYROLLRUN FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.WORKERADJUSTMENT';
		create_command := 'CREATE OR REPLACE SYNONYM WORKERADJUSTMENT FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.UNEMPLOYMENTINSDOCDTL';
		create_command := 'CREATE OR REPLACE SYNONYM UNEMPLOYMENTINSDOCDTL FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.EMPLOYERCONTACTPERSON';
		create_command := 'CREATE OR REPLACE SYNONYM EMPLOYERCONTACTPERSON FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.TASK';
		create_command := 'CREATE OR REPLACE SYNONYM TASK FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.WORKLOCATION';
		create_command := 'CREATE OR REPLACE SYNONYM WORKLOCATION FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.PTDDATUM';
		create_command := 'CREATE OR REPLACE SYNONYM PTDDATUM FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.PAYMENTLINEITEM';
		create_command := 'CREATE OR REPLACE SYNONYM PAYMENTLINEITEM FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.EMPLOYERADJUSTMENT';
		create_command := 'CREATE OR REPLACE SYNONYM EMPLOYERADJUSTMENT FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.EMPLOYER';
		create_command := 'CREATE OR REPLACE SYNONYM EMPLOYER FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.BENEFITSVC';
		create_command := 'CREATE OR REPLACE SYNONYM BENEFITSVC FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.EMPLOYERID';
		create_command := 'CREATE OR REPLACE SYNONYM EMPLOYERID FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.AGENCY';
		create_command := 'CREATE OR REPLACE SYNONYM AGENCY FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.WORKERCOMPLIANCEDOCDTL';
		create_command := 'CREATE OR REPLACE SYNONYM WORKERCOMPLIANCEDOCDTL FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.AGENCYIDTYPE';
		create_command := 'CREATE OR REPLACE SYNONYM AGENCYIDTYPE FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.CONTACTPERSONWORKLOCATION';
		create_command := 'CREATE OR REPLACE SYNONYM CONTACTPERSONWORKLOCATION FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.WORKLOCATIONBENEFITSERVICE';
		create_command := 'CREATE OR REPLACE SYNONYM WORKLOCATIONBENEFITSERVICE FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.HIBERNATE_SEQUENCE';
		create_command := 'CREATE OR REPLACE SYNONYM HIBERNATE_SEQUENCE FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    -- Grants
    
  
    	IF abort_run = 0 THEN
    	--
    	-- Apply VPD policies to all Entity synonyms (no need to apply to JOIN synonyms)
    	--
  			BEGIN
    			

		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'HISTPAYCHECKLINEITEM'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'HISTPAYCHECKLINEITEM',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'PAYROLLITEM'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'PAYROLLITEM',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'HISTPAYCHECK'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'HISTPAYCHECK',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'PAYROLLSCHEDULE'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'PAYROLLSCHEDULE',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'CONTACTPERSON'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'CONTACTPERSON',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'PAYROLLITEMDTL'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'PAYROLLITEMDTL',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'DISABILITYINSDOCDTL'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'DISABILITYINSDOCDTL',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'WORKERADJLINEITEM'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'WORKERADJLINEITEM',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'BANKACCOUNT'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'BANKACCOUNT',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'EMPLOYERCOMPLIANCEDOCDTL'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'EMPLOYERCOMPLIANCEDOCDTL',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'EMPLOYMENTPERIOD'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'EMPLOYMENTPERIOD',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'EMPLOYERADJLINEITEM'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'EMPLOYERADJLINEITEM',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'JURISDICTION'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'JURISDICTION',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'COMPLIANCEDOC'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'COMPLIANCEDOC',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'PAYMENT'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'PAYMENT',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'INDUSTRYTYPE'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'INDUSTRYTYPE',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'BENEFITPROVIDER'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'BENEFITPROVIDER',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'PAYCHECKLINEITEM'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'PAYCHECKLINEITEM',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'LEGALSTRUCTURE'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'LEGALSTRUCTURE',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'PAYMENTLINEITEMSPLIT'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'PAYMENTLINEITEMSPLIT',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'PAYCHECK'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'PAYCHECK',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'LAW'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'LAW',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'WORKER'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'WORKER',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'PAYROLLRUN'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'PAYROLLRUN',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'WORKERADJUSTMENT'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'WORKERADJUSTMENT',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'UNEMPLOYMENTINSDOCDTL'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'UNEMPLOYMENTINSDOCDTL',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'EMPLOYERCONTACTPERSON'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'EMPLOYERCONTACTPERSON',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'TASK'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'TASK',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'WORKLOCATION'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'WORKLOCATION',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'PTDDATUM'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'PTDDATUM',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'PAYMENTLINEITEM'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'PAYMENTLINEITEM',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'EMPLOYERADJUSTMENT'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'EMPLOYERADJUSTMENT',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'EMPLOYER'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'EMPLOYER',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'BENEFITSVC'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'BENEFITSVC',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'EMPLOYERID'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'EMPLOYERID',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'AGENCY'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'AGENCY',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'WORKERCOMPLIANCEDOCDTL'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'WORKERCOMPLIANCEDOCDTL',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'AGENCYIDTYPE'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'AGENCYIDTYPE',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;









  
  			END;
  		END IF;
  	END;
  	/
