ALTER TABLE EMPLOYERADJUSTMENT RENAME COLUMN PAYROLLPERIOD_ENDDATE TO PAYROLLPERIOD_ENDDT
/

ALTER TABLE EMPLOYERADJUSTMENT RENAME COLUMN PAYROLLPERIOD_STARTDATE TO PAYROLLPERIOD_STARTDT
/

ALTER TABLE PTDDATUM RENAME COLUMN DATUM_PERIOD_STARTDATE TO DATUM_PERIOD_STARTDT
/

ALTER TABLE PTDDATUM RENAME COLUMN DATUM_PERIOD_ENDDATE TO DATUM_PERIOD_ENDDT
/

ALTER TABLE TASK RENAME COLUMN DATERANGE_STARTDATE TO DATERANGE_STARTDT
/

ALTER TABLE TASK RENAME COLUMN DATERANGE_ENDDATE TO DATERANGE_ENDDT
/

ALTER TABLE WORKERADJUSTMENT RENAME COLUMN PAYROLLPERIOD_STARTDATE TO PAYROLLPERIOD_STARTDT
/

ALTER TABLE WORKERADJUSTMENT RENAME COLUMN PAYROLLPERIOD_ENDDATE TO PAYROLLPERIOD_ENDDT
/

ALTER TABLE PAYROLLRUN RENAME COLUMN PAYPERIOD_ENDDATE TO PAYPERIOD_ENDDT
/

ALTER TABLE PAYROLLRUN RENAME COLUMN PAYPERIOD_STARTDATE TO PAYPERIOD_STARTDT
/

ALTER TABLE WORKER RENAME COLUMN EMPLOYMENTPERIOD_ENDDATE TO EMPLOYMENTPERIOD_ENDDT
/

ALTER TABLE WORKER RENAME COLUMN EMPLOYMENTPERIOD_STARTDATE TO EMPLOYMENTPERIOD_STARTDT
/

ALTER TABLE PAYCHECK RENAME COLUMN PAYPERIOD_ENDDATE TO PAYPERIOD_ENDDT
/

ALTER TABLE PAYCHECK RENAME COLUMN PAYPERIOD_STARTDATE TO PAYPERIOD_STARTDT
/

ALTER TABLE PAYCHECKLINEITEM RENAME COLUMN PAYPERIOD_ENDDATE TO PAYPERIOD_ENDDT
/

ALTER TABLE PAYCHECKLINEITEM RENAME COLUMN PAYPERIOD_STARTDATE TO PAYPERIOD_STARTDT
/

ALTER TABLE PAYMENT RENAME COLUMN PAYROLLPERIOD_STARTDATE TO PAYROLLPERIOD_STARTDT
/

ALTER TABLE PAYMENT RENAME COLUMN PAYROLLPERIOD_ENDDATE TO PAYROLLPERIOD_ENDDT
/

ALTER TABLE EMPLOYMENTPERIOD RENAME COLUMN EMPLOYMENTPERIOD_ENDDATE TO EMPLOYMENTPERIOD_ENDDT
/

ALTER TABLE EMPLOYMENTPERIOD RENAME COLUMN EMPLOYMENTPERIOD_STARTDATE TO EMPLOYMENTPERIOD_STARTDT
/

ALTER TABLE HISTPAYCHECK RENAME COLUMN PAYROLLPERIOD_STARTDATE TO PAYROLLPERIOD_STARTDT
/

ALTER TABLE HISTPAYCHECK RENAME COLUMN PAYROLLPERIOD_ENDDATE TO PAYROLLPERIOD_ENDDT
/

    -- WARNING: UNSUPPORTED OPERATION NOT INCLUDED: Can't change EMPLOYER from NULL to NOT NULL.

    -- WARNING: UNSUPPORTED OPERATION NOT INCLUDED: Can't change WORKER from NULL to NOT NULL.

CREATE TABLE WORKERWORKLOCREL (
    PRIMARY KEY(ID),
    ID NUMBER(20,0) NOT NULL, 
    REALM_ID NUMBER(20,0) DEFAULT -1 NOT NULL, 
    EFFECTIVEPERIOD_DATRNG_STARTDT DATE NULL, 
    EFFECTIVEPERIOD_DATRNG_ENDDT DATE NULL, 
    EFFECTIVEPERIOD_TYP VARCHAR2(100) DEFAULT 'NOTSET' NULL, 
    CREATIONDATE TIMESTAMP NULL, 
    CREATEDBY VARCHAR2(100) NULL, 
    LASTMODIFICATIONDATE TIMESTAMP NULL, 
    LASTMODIFIEDBY VARCHAR2(100) NULL, 
    VERSION NUMBER(20,0) NOT NULL, 
    UUID VARCHAR2(255) NOT NULL, 
    REALMOWNER NUMBER(20,0) NULL, 
    WORKLOCATION NUMBER(20,0) NOT NULL, 
    WORKER NUMBER(20,0) NULL
)
/

CREATE INDEX WORKERWORKLOCREL_RX ON WORKERWORKLOCREL(REALM_ID ASC)
/

CREATE INDEX WORKERWORKLOCREL_FK_REALMOWNER ON WORKERWORKLOCREL(REALMOWNER ASC)
/

CREATE INDEX WORKERWORKLOCREL_FK_WORKER ON WORKERWORKLOCREL(WORKER ASC)
/

ALTER TABLE WORKERWORKLOCREL ADD UNIQUE (WORKLOCATION)
/

ALTER TABLE WORKERWORKLOCREL ADD CONSTRAINT WORKERWORKLOCREL_FK_REALMOWNER
    FOREIGN KEY (REALMOWNER)
    REFERENCES EMPLOYER (ID)
/

ALTER TABLE WORKERWORKLOCREL ADD CONSTRAINT WKRWLOCREL_FK_WKLOC
    FOREIGN KEY (WORKLOCATION)
    REFERENCES WORKLOCATION (ID)
/

ALTER TABLE WORKERWORKLOCREL ADD CONSTRAINT WORKERWORKLOCREL_FK_WORKER
    FOREIGN KEY (WORKER)
    REFERENCES WORKER (ID)
/

CREATE OR REPLACE TRIGGER "WORKERWORKLOCREL_VT" BEFORE INSERT OR UPDATE ON "WORKERWORKLOCREL"
    FOR EACH ROW
    BEGIN
     IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 
    END;
/


ALTER TABLE WORKERCOMPLIANCEDOCDTL ADD (EFFECTIVEPD_TYP VARCHAR2(100) DEFAULT 'NOTSET' NULL)
/

ALTER TABLE WORKERCOMPLIANCEDOCDTL ADD (EFFECTIVEPD_DATRNG_ENDDT DATE NULL)
/

ALTER TABLE WORKERCOMPLIANCEDOCDTL ADD (EFFECTIVEPD_DATRNG_STARTDT DATE NULL)
/

ALTER TABLE EMPLOYERCOMPLIANCEDOCDTL ADD (EFFECTIVEPD_DATRNG_STARTDT DATE NULL)
/

ALTER TABLE EMPLOYERCOMPLIANCEDOCDTL ADD (EFFECTIVEPD_DATRNG_ENDDT DATE NULL)
/

ALTER TABLE EMPLOYERCOMPLIANCEDOCDTL ADD (EFFECTIVEPD_TYP VARCHAR2(100) DEFAULT 'NOTSET' NULL)
/

GRANT SELECT, INSERT, UPDATE, DELETE ON WORKERWORKLOCREL TO &&2
/

UPDATE PROJECT_VERSIONS_TABLE SET SCHEMA_VERSION='1.0.29', TIMESTAMP='2009-07-08 02:55:03.202' WHERE PROJECT_ID='_c4GAoJEkEd2zF5tDuPZkGw'
/

