package com.intuit.sb.payroll.rules;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public class RulesResult implements Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = 8204587067242615645L;

	private List<Object> data = new ArrayList<Object>(); //list of the output data from rules engine
	
	private Map<Long,List<RulesExplanation>> rulesExplanations = new HashMap<Long,List<RulesExplanation>>();

	public List<Object> getData() {
		return data;
	}
	
	//return a list of RulesExplanation objects for the object in 'data' with UniqueId = Id
	public List<RulesExplanation> getRuleExplantions(Long id) throws RulesException {
		
		List<RulesExplanation> lstExplanations = rulesExplanations.get(id);
		if(lstExplanations == null)
		{
			throw new RulesException("No Explantions found for this Entity");
		}
		return lstExplanations;
	}
	
	//initializes the RulesResult object from the outlist from the rules engine
	
	@SuppressWarnings("unchecked")
	public void initialize(List rulesEngineOutput) {
	
		Iterator iter = rulesEngineOutput.iterator();
		while(iter.hasNext())
		{
			Object obj = iter.next();
			if(obj instanceof RulesExplanation)
			{
				RulesExplanation expl = (RulesExplanation)obj;
				List<RulesExplanation> list = rulesExplanations.get(expl.getId());
				if(list == null) //the list for this object is not yet created
				{
					list = new ArrayList<RulesExplanation>();
					rulesExplanations.put(expl.getId(), list);
				}
				list.add(expl); //put the Explanation object in the correct bucket
			}
			else //this is an output object from rules engine
			{
				data.add(obj);
			}
		}
	}
}
