package com.intuit.sb.payroll.capability.employer.impl;

import java.util.List;

import com.intuit.sb.payroll.ValidationException;
import com.intuit.sb.payroll.common.validation.AbstractEntityDataValidator;
import com.intuit.sb.payroll.common.validation.PayrollParamValidator;
import com.intuit.sb.payroll.entity.model.ContactPerson;

/**
 * Validates {@link ContactPerson} entities.
 *
 * $Author$ 
 * $Revision$
 * $DateTime$
 */
@SuppressWarnings("nls")
public class ContactPersonValidator extends AbstractEntityDataValidator<ContactPerson> {
	
	private static ContactPersonValidator sInstance = new ContactPersonValidator();
	
	private ContactPersonValidator() {}
	
	public static ContactPersonValidator getInstance() {
		return sInstance;
	}
	
	@Override
	public void validateEntityCollection(List<ContactPerson> contactPersons) throws ValidationException {
		try {
			PayrollParamValidator.checkIsNotNull(contactPersons, "Contact Persons");
		} catch (IllegalArgumentException iae) {
			throw new ValidationException(iae);
		}
		for (ContactPerson contactPerson : contactPersons) {
			validateEntity(contactPerson);
		}
	}

	@Override
	public void validateEntity(ContactPerson contactPerson) throws ValidationException {
		PayrollParamValidator.checkIsNotNull(contactPerson, "Contact Person");
	}
}
