package com.intuit.sb.payroll.capability.employer.impl.evaluator;

import java.util.Set;

import com.intuit.sb.payroll.ValidationException;
import com.intuit.sb.payroll.common.AbstractPayrollEntityDataEvaluator;
import com.intuit.sb.payroll.common.PayrollEntityDataEvaluator;
import com.intuit.sb.payroll.common.PayrollEntityDataState;
import com.intuit.sb.payroll.entity.model.Employer;
import com.intuit.sb.payroll.entity.model.EmployerId;
import com.intuit.sb.payroll.entity.model.EmployerIdTypeEnum;
import com.intuit.sb.payroll.pts.entity.PTSEmployer;



public class EmployerFEINEvaluator extends AbstractPayrollEntityDataEvaluator<PTSEmployer> {
	
	private static EmployerFEINEvaluator sInstance = new EmployerFEINEvaluator();

	private EmployerFEINEvaluator() {
	}

	public static PayrollEntityDataEvaluator<PTSEmployer> getInstance() {
		return sInstance;
	}

	@Override
	public PayrollEntityDataState evaluateState(PTSEmployer entity) throws ValidationException {
		String fein = null;
		Employer employer = entity.getEmployer();	
		Set<EmployerId> employerIds = employer.getEmployerIds();
		for (EmployerId employerId : employerIds) {
			if (employerId.getAgencyIdType().getIdTypeKey().equals(EmployerIdTypeEnum.EIN)){
				fein = employerId.getValue();
				break;
			}
		}
		
		if ((fein == null) || (fein.length() == 0)){
			return PayrollEntityDataState.Incomplete;
		}else{
			return PayrollEntityDataState.Complete;
		}
	}
}
