package com.intuit.sb.payroll.capability.employer.impl.evaluator;

import com.intuit.sb.payroll.ValidationException;
import com.intuit.sb.payroll.common.AbstractPayrollEntityDataEvaluator;
import com.intuit.sb.payroll.common.PayrollEntityDataEvaluator;
import com.intuit.sb.payroll.common.PayrollEntityDataState;
import com.intuit.sb.payroll.entity.model.Employer;
import com.intuit.sb.payroll.pts.entity.PTSEmployer;

public class EmployerLegalNameEvaluator extends AbstractPayrollEntityDataEvaluator<PTSEmployer>{

	private static EmployerLegalNameEvaluator sInstance = new EmployerLegalNameEvaluator();

	private EmployerLegalNameEvaluator() {
	}
	
	public static PayrollEntityDataEvaluator<PTSEmployer> getInstance() {
		return sInstance;
	}
	
	@Override
	public PayrollEntityDataState evaluateState(PTSEmployer entity)
			throws ValidationException {
		Employer employer = entity.getEmployer();
		String legalName = employer.getLegalName();
		
		if ((legalName == null) || (legalName.length() == 0)){
			return PayrollEntityDataState.Incomplete;
		}else{
			return PayrollEntityDataState.Complete;
		}
			
	}

}
