package com.intuit.sb.payroll.capability.employer.impl.evaluator;

import java.util.Set;

import com.intuit.sb.payroll.ValidationException;
import com.intuit.sb.payroll.common.AbstractPayrollEntityDataEvaluator;
import com.intuit.sb.payroll.common.PayrollEntityDataEvaluator;
import com.intuit.sb.payroll.common.PayrollEntityDataState;
import com.intuit.sb.payroll.pts.entity.PTSContactPerson;
import com.intuit.sb.payroll.pts.entity.PTSContactPersonTypeEnum;
import com.intuit.sb.payroll.pts.entity.PTSEmployer;

public class EmployerPrimaryContactEvaluator extends
		AbstractPayrollEntityDataEvaluator<PTSEmployer> {

	private static EmployerPrimaryContactEvaluator sInstance = new EmployerPrimaryContactEvaluator();

	private EmployerPrimaryContactEvaluator() {
	}

	public static PayrollEntityDataEvaluator<PTSEmployer> getInstance() {
		return sInstance;
	}

	@Override
	public PayrollEntityDataState evaluateState(PTSEmployer entity)
			throws ValidationException {
		Set<PTSContactPerson> ptsContactPerson = entity.getPTSContactPersons();

		for (PTSContactPerson contactPerson : ptsContactPerson) {
			if ((contactPerson.getContactPersonType()
					.equals(PTSContactPersonTypeEnum.PRIMARY_CONTACT))
					|| (contactPerson.getContactPersonType()
							.equals(PTSContactPersonTypeEnum.SECONDARY_CONTACT))
					|| (contactPerson.getContactPersonType()
							.equals(PTSContactPersonTypeEnum.PAYROLLADMIN_CONTACT)))
				return PayrollEntityDataState.Complete;
		}

		return PayrollEntityDataState.Incomplete;
	}

}
