package com.intuit.sb.payroll.capability.pts.adapter.mapper;

import com.intuit.sb.payroll.entity.model.GlobalPostalAddress;
import com.intuit.sb.payroll.intl.capability.address.AddressConvertor;
import com.intuit.sb.payroll.intl.capability.address.USPostalAddress;
import com.intuit.sb.payroll.us.capability.address.impl.USPostalAddressImpl;
import com.intuit.sbd.payroll.psp.adapters.gemini.AddressAdapterDTO;

public class AddressMapper {
	
	public static AddressAdapterDTO mapAddress(GlobalPostalAddress postalAddress){
		USPostalAddress usPostalAddress = new USPostalAddressImpl();
		
		if (postalAddress != null){
			usPostalAddress =  AddressConvertor.getUSFromGlobal(postalAddress, usPostalAddress);
		}
		
		AddressAdapterDTO addrDTO = new AddressAdapterDTO();
		
		addrDTO.setAddressLine1(getValue(usPostalAddress.getAddressLine1()));
		addrDTO.setAddressLine2(getValue(usPostalAddress.getAddressLine2()));
		addrDTO.setAddressLine3(getValue(usPostalAddress.getAddressLine3()));
		addrDTO.setCity(getValue(usPostalAddress.getCity()));
		addrDTO.setCountry(getValue(usPostalAddress.getCountry()));
		addrDTO.setState(getValue(usPostalAddress.getRegionOrState()));
		addrDTO.setZipCode(getValue(usPostalAddress.getZipOrPostalCode()));
		addrDTO.setZipCodeExtension("");
		
		return addrDTO;
	}
	
	public static String getValue(String value){
		if (value == null){
			return "";
		}else{
			return value;
		}
	}
}