package com.intuit.sb.payroll.capability.pts.adapter.mapper;

import java.util.Set;

import com.intuit.sb.payroll.entity.model.PayrollFrequencyEnum;
import com.intuit.sb.payroll.entity.model.PayrollSchedule;
import com.intuit.sbd.payroll.psp.adapters.gemini.PayrollFrequencyAdapterEnum;

public class PayrollFrequencyMapper {

	public static PayrollFrequencyAdapterEnum mapPayrollFrequency(Set<PayrollSchedule> payrollSchedules) {
		
		// TODO what about multiple frequencies
		// For now get the first one
		
		PayrollFrequencyAdapterEnum payFrequencyAdapterEnum = PayrollFrequencyAdapterEnum.BI_WEEKLY;
		if (payrollSchedules.size() > 0){
			PayrollSchedule payrollSchedule = null;
			for (PayrollSchedule paySchedule : payrollSchedules) {
				payrollSchedule = paySchedule;
				break;
			}
			PayrollFrequencyEnum psFrequency = payrollSchedule.getFrequency();
			
			switch (psFrequency) {
			case DAILY:
				payFrequencyAdapterEnum = PayrollFrequencyAdapterEnum.DAILY;
				break;
			case WEEKLY:
				payFrequencyAdapterEnum = PayrollFrequencyAdapterEnum.WEEKLY;
				break;
			case BIWEEKLY:
				payFrequencyAdapterEnum = PayrollFrequencyAdapterEnum.BI_WEEKLY;
				break;
			case SEMIMONTHLY:
				payFrequencyAdapterEnum = PayrollFrequencyAdapterEnum.SEMI_MONTHLY;
				break;
			case MONTHLY:
				payFrequencyAdapterEnum = PayrollFrequencyAdapterEnum.MONTHLY;
				break;
			case QUARTERLY:
				payFrequencyAdapterEnum = PayrollFrequencyAdapterEnum.QUARTERLY;
				break;
			case SEMIANNUALLY:
				payFrequencyAdapterEnum = PayrollFrequencyAdapterEnum.SEMI_ANNUAL;
				break;
			case ANNUALLY:
				payFrequencyAdapterEnum = PayrollFrequencyAdapterEnum.ANNUAL;
				break;
			default:
				break;
			}
		}
		return payFrequencyAdapterEnum;
	}
}
