package com.intuit.sb.payroll.capability.pts.adapter.mapper;

import java.util.List;
import java.util.Set;

import com.intuit.sb.payroll.ServiceFailureException;
import com.intuit.sb.payroll.entity.model.Payment;
import com.intuit.sb.payroll.entity.model.PaymentLineItem;
import com.intuit.sb.payroll.entity.model.PaymentLineItemSplit;
import com.intuit.sb.payroll.pts.entity.PTSEmployer;
import com.intuit.sbd.payroll.psp.adapters.gemini.DateAdapterDTO;
import com.intuit.sbd.payroll.psp.adapters.gemini.TaxPaymentAdapterDTO;
import com.intuit.sbd.payroll.psp.adapters.gemini.TaxPaymentsAdapterDTO;
 

public class TaxPaymentsMapper {
	public static TaxPaymentsAdapterDTO mapToTaxPaymentsAdapterDTO(PTSEmployer ptsEmployer,
			List<Payment> payments) throws ServiceFailureException{
		TaxPaymentsAdapterDTO taxPaymentsDTO = new TaxPaymentsAdapterDTO();
		taxPaymentsDTO.setSourceCompanyId(CompanyMapper.namespaceEmployerId(ptsEmployer.getEmployer()));
		
		for (Payment payment: payments){
			DateAdapterDTO dateDTO = DateMapper.mapDateToDTO(payment.getPaymentDate());
			Set<PaymentLineItem> paymentLineItems = payment.getPaymentLineItems();
			for (PaymentLineItem paymentLineItem:paymentLineItems){
				Set<PaymentLineItemSplit> paymentSplits = paymentLineItem.getPaymentLineItemSplits();
				for (PaymentLineItemSplit paymentLineItemSplit:paymentSplits){
					TaxPaymentAdapterDTO taxPaymentAdapterDTO = new TaxPaymentAdapterDTO();
					// Date
					taxPaymentAdapterDTO.setDate(dateDTO);
					// Amount
					taxPaymentAdapterDTO.setAmount(paymentLineItemSplit.getSplitAmount().getAmount());
					// LawId
					String lawId = paymentLineItemSplit.getPayrollItem().getLawId().getValue();
					taxPaymentAdapterDTO.setLawId(lawId);
					taxPaymentsDTO.getPayments().add(taxPaymentAdapterDTO);
				}
			}
		}
		return taxPaymentsDTO;
	}
	
}
