package com.intuit.sb.payroll.capability.pts.notification;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.intuit.sb.payroll.pts.entity.PTSMessage;

public class PTSNotificationRequest {
	
	private PTSNotificationTypeEnum notificationType;
	private Object notificationStatus;
	private Object oldNotificationStatus;
	private Date timestamp;
	private List<PTSMessage> ptsMessage;
	
	/*	List of attributes and their values - coming from PTS
	 *  Currently available attributes:
	 * 	SourceBankAccountId
	 *  AgencyId
	 *  Details
	 */
	private Map<String, String> notificationAttributes;
	
	public synchronized Map<String, String> getNotificationAttributes() {
		if (notificationAttributes == null) {
			notificationAttributes = new HashMap<String, String>();
		}
		return notificationAttributes;
	}
	
	public synchronized void setNotificationAttributes(Map<String, String> notificationAttributes) {
		if (notificationAttributes == null) {
			notificationAttributes = new HashMap<String, String>();
		}
		this.notificationAttributes = notificationAttributes;
	}
	
	public synchronized void addNotificationAttributes(String attributeName, String attributeValue) {
		if (notificationAttributes == null) {
			notificationAttributes = new HashMap<String, String>();
		}
		notificationAttributes.put(attributeName, attributeValue);
	}
	
	public Object getOldNotificationStatus() {
		return oldNotificationStatus;
	}
	public void setOldNotificationStatus(Object oldNotificationStatus) {
		this.oldNotificationStatus = oldNotificationStatus;
	}

	public Date getTimestamp() {
		return timestamp;
	}
	public void setTimestamp(Date timestamp) {
		this.timestamp = timestamp;
	}
	
	public Object getNotificationStatus() {
		return notificationStatus;
	}
	public void setNotificationStatus(Object employerAssistedState) {
		this.notificationStatus = employerAssistedState;
	}
	
	public List<PTSMessage> getPTSMessage() {
		return ptsMessage;
	}
	public void setPTSMessage(List<PTSMessage> assistedMessage) {
		this.ptsMessage = assistedMessage;
	}
	
	
	public PTSNotificationTypeEnum getNotificationType() {
		return notificationType;
	}
	public void setNotificationType(PTSNotificationTypeEnum notificationType) {
		this.notificationType = notificationType;
	}
}
