package com.intuit.sb.payroll.capability.qa;

import java.util.List;

import javax.ejb.Remote;

import com.intuit.sb.payroll.entity.domain.Identifiable;

/**
 * This interface provides methods for finding EJBs in jndi. The interface is remote so tests can 
 * get EJB references from outside container.
 */
@Remote
public interface QaBootstrap {

	public static final String JNDI_NAME =  "QaBootstrap/remote";
	
	/**
	 * 
	 * @param <T> 
	 * @param ejbName is the full qualified name of the EJB class
	 * @return return an EJB instance
	 */
	public <T> T getEjb(String ejbName);
	
	/**
	 * 
	 * @param <T>
	 * @param cl is the EJB class
	 * @return return an EJB instance
	 */
	@SuppressWarnings("unchecked")
	public <T> T getEjbFromClass(Class cl);
	
	//Methods in EntityService
	public <T> T findById(Class<T> type, Long Id);
	public <T> T findByIdentifiable(Class<T> type, Identifiable identifiable);
	public <T> List<T> findAll(Class<T> type);
    public <T> T makeManaged(T entity);
    public <T> T makePersistent(T entity);
    public <T> boolean notPersistent(T entity);
    public <T> void makeTransient(T entity);
}
