package com.intuit.sb.payroll.capability.worker;

import javax.ejb.Local;

import com.intuit.sb.payroll.ServiceFailureException;
import com.intuit.sb.payroll.ValidationException;
import com.intuit.sb.payroll.common.WorkflowEventType;
import com.intuit.sb.payroll.entity.model.Worker;
import com.intuit.sb.payroll.pts.entity.PTSEmployer;

@Local
public interface WorkerPTSWorkflowComponent {
	@SuppressWarnings("nls")
	public static final String JNDI_NAME =  "WorkerPTSWorkflowComponent/local";
	
	/**
	 * This component is interested in changes to the Worker as it may affect Worker state and Tasks in PTS.
	 * 
	 * @param eventType
	 * @param worker
	 * @throws ServiceFailureException
	 * @throws ValidationException 
	 */
	public void handleWorkerEvent(WorkflowEventType eventType, Worker worker) throws ServiceFailureException;
	
	
	/**
	 * Interested in Any Assisted related event in Employer ( add, updated, removed etc)
	 * @param workflowEventType
	 * @param ptsEmployer
	 * @throws ServiceFailureException 
	 * @throws ServiceFailureException
	 */
	public void handleAssistedSetupEvent(WorkflowEventType workflowEventType,
			PTSEmployer ptsEmployer) throws ServiceFailureException;
}

