package com.intuit.sb.payroll.capability.worker.impl.evaluator;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.intuit.sb.payroll.ValidationException;
import com.intuit.sb.payroll.common.AbstractPayrollEntityDataEvaluator;
import com.intuit.sb.payroll.common.PayrollEntityDataEvaluator;
import com.intuit.sb.payroll.common.PayrollEntityDataState;
import com.intuit.sb.payroll.common.RequiredData;
import com.intuit.sb.payroll.entity.model.Worker;

/**
 * Evaluates the Worker to assess it's completeness.
 * 
 * TODO: this is currently a prototype to see if it can solve for our state management needs.
 * TODO: review required fields with PM/Compliance.
 * TODO: Precondition is that the Validator has run?
 *
 * $Author$
 * $Revision$
 * $DateTime$
 *
 */
public abstract class WorkerEvaluator extends AbstractPayrollEntityDataEvaluator<Worker>
{
    private Map<RequiredData, PayrollEntityDataEvaluator<Worker>> registerMap = new HashMap<RequiredData, 
        PayrollEntityDataEvaluator<Worker>>();
    	
	protected Map<RequiredData, PayrollEntityDataEvaluator<Worker>> getRegisterMap() 
	{
		return registerMap;
	}


	protected void setRegisterMap(Map<RequiredData, PayrollEntityDataEvaluator<Worker>> registerMap) 
	{
		this.registerMap = registerMap;
	}


	/**
     * Evaluate WorkerSetup State
     * @param entity the withholding data.
	 * @throws ValidationException 
     */
    public PayrollEntityDataState evaluateState(Worker entity) throws ValidationException
    {
        return PayrollEntityDataState.Complete;
    }
    

	/**
	 * Keepme
	 * 
	 * @param worker
	 * @param allFields
	 * @return
	 * @throws ValidationException
	 */
	public List<RequiredData> getCompletedFields(Worker worker,	List<RequiredData> allFields) throws ValidationException {
		List<RequiredData> results = new ArrayList<RequiredData>();
		
        for (RequiredData field : allFields)
        {
            PayrollEntityDataState entityState = registerMap.get(field).evaluateState(worker);
            
            if (entityState == PayrollEntityDataState.Complete) {
                results.add(field);
            } 
        }

		return results;
	}
}
