package com.intuit.sb.payroll.capability.workerpayments.impl.calcengine;

import java.util.HashMap;
import java.util.Map;

import com.intuit.payroll.j.NationalRegionIf;
import com.intuit.payroll.types.enumtype.PayrollState;

/**
 * Converts US State abbreviations to QBO PayrollState objects.
 *
 * $Author$ 
 * $Revision$
 * $DateTime$
 */
@SuppressWarnings("nls")
public class PayrollStateMapper extends NationalRegionMapper {
	protected static Map<String, PayrollState> regionMap = new HashMap<String, PayrollState>();
	
	static {
		regionMap.put(CalcEngineResources.getString("US_States.AL"), PayrollState.AL); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.AK"), PayrollState.AK); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.AZ"), PayrollState.AZ); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.AR"), PayrollState.AR); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.CA"), PayrollState.CA); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.CO"), PayrollState.CO); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.CT"), PayrollState.CT); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.DE"), PayrollState.DE); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.DC"), PayrollState.DC); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.FL"), PayrollState.FL); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.GA"), PayrollState.GA); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.HI"), PayrollState.HI); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.ID"), PayrollState.ID); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.IL"), PayrollState.IL); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.IN"), PayrollState.IN); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.IA"), PayrollState.IA); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.KS"), PayrollState.KS); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.KT"), PayrollState.KY); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.LA"), PayrollState.LA); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.ME"), PayrollState.ME); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.MA"), PayrollState.MA); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.MD"), PayrollState.MD); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.MI"), PayrollState.MI); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.MN"), PayrollState.MN); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.MO"), PayrollState.MO); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.MS"), PayrollState.MS); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.MT"), PayrollState.MT); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.NC"), PayrollState.NC); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.ND"), PayrollState.ND); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.NE"), PayrollState.NE); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.NH"), PayrollState.NH); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.NJ"), PayrollState.NJ); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.NM"), PayrollState.NM); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.NV"), PayrollState.NV); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.NY"), PayrollState.NY); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.OH"), PayrollState.OH); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.OK"), PayrollState.OK); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.OR"), PayrollState.OR); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.PA"), PayrollState.PA); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.PR"), PayrollState.PR); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.RI"), PayrollState.RI); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.SC"), PayrollState.SC); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.SD"), PayrollState.SD); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.TN"), PayrollState.TN); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.TX"), PayrollState.TX); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.UT"), PayrollState.UT); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.VA"), PayrollState.VA); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.VT"), PayrollState.VT); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.WA"), PayrollState.WA); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.WI"), PayrollState.WI); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.WV"), PayrollState.WV); //$NON-NLS-1$
		regionMap.put(CalcEngineResources.getString("US_States.WY"), PayrollState.WY); //$NON-NLS-1$
	}
	
	protected Map<String, ? extends NationalRegionIf> getRegionMap()
	{
		return regionMap;
	}
}
