package com.intuit.sb.payroll.us.capability.address.impl;

import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

import com.intuit.sb.payroll.intl.capability.address.USPostalAddress;

/**
 * Implementation of a USPostalAddress
 * @author rmahadevan
 *
 */

public class USPostalAddressImpl implements USPostalAddress 
{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1199236395002065952L;
	private String addressLine1;
	private String addressLine2;
	private String addressLine3;
	private String city;
	private String regionOrState;
	private String zipOrPostalCode;
	private String county;
	private String countyCode;
	private String country;
	private String countryISOCode;
	private String geoCode;
	private Boolean isStandardized;
	private Boolean isStreetAddress;
	private Boolean isNotToBeStandardized;
	
	
	public USPostalAddressImpl()
	{
	}


	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#getAddressLine1()
	 */
	public String getAddressLine1() {
		return addressLine1;
	}

	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#setAddressLine1(java.lang.String)
	 */
	public void setAddressLine1(String addressLine1) {
		this.addressLine1 = addressLine1;
	}

	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#getAddressLine2()
	 */
	public String getAddressLine2() {
		return this.addressLine2;
	}

	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#setAddressLine2(java.lang.String)
	 */
	public void setAddressLine2(String addressLine2) {
		this.addressLine2 = addressLine2;
	}

	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#getAddressLine3()
	 */
	public String getAddressLine3() {
		return this.addressLine3;
	}

	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#setAddressLine3(java.lang.String)
	 */
	public void setAddressLine3(String addressLine3) {
		this.addressLine3 = addressLine3;
	}

	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#getCity()
	 */
	public String getCity() {
		return this.city;
	}

	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#setCity(java.lang.String)
	 */
	public void setCity(String city) {
		this.city = city;
	}

	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#getRegionOrState()
	 */
	public String getRegionOrState() {
		return this.regionOrState;
	}

	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#setRegionOrState(java.lang.String)
	 */
	public void setRegionOrState(String regionOrState) {
		this.regionOrState = regionOrState;
	}

	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#getZipOrPostalCode()
	 */
	public String getZipOrPostalCode() {
		return this.zipOrPostalCode;
	}

	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#setZipOrPostalCode(java.lang.String)
	 */
	public void setZipOrPostalCode(String zipOrPostalCode) {
		this.zipOrPostalCode = zipOrPostalCode;
	}

	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#getCounty()
	 */
	public String getCounty() {
		return this.county;
	}

	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#setCounty(java.lang.String)
	 */
	public void setCounty(String county) {
		this.county = county;
	}

	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#getCountyCode()
	 */
	public String getCountyCode() {
		return this.countyCode;
	}

	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#setCountyCode(java.lang.String)
	 */
	public void setCountyCode(String countyCode) {
		this.countyCode = countyCode;
	}

	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#getCountry()
	 */
	public String getCountry() {
		return this.country;
	}

	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#setCountry(java.lang.String)
	 */
	public void setCountry(String country) {
		this.country = country;
	}

	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#getCountryISOCode()
	 */
	public String getCountryISOCode() {
		return this.countryISOCode;
	}

	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#setCountryISOCode(java.lang.String)
	 */
	public void setCountryISOCode(String countryISOCode) {
		this.countryISOCode = countryISOCode;
	}

	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#getGeoCode()
	 */
	public String getGeoCode() {
		return this.geoCode;
	}

	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#setGeoCode(java.lang.String)
	 */
	public void setGeoCode(String geoCode) {
		this.geoCode = geoCode;
	}

	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#getIsStandardized()
	 */
	public Boolean getIsStandardized() {
		return this.isStandardized;
	}

	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#setIsStandardized(java.lang.Boolean)
	 */
	public void setIsStandardized(Boolean isStandardized) {
		this.isStandardized = isStandardized;
	}

	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#getIsStreetAddress()
	 */
	public Boolean getIsStreetAddress() {
		return this.isStreetAddress;
	}

	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#setIsStreetAddress(java.lang.Boolean)
	 */
	public void setIsStreetAddress(Boolean isStreetAddress) {
		this.isStreetAddress = isStreetAddress;
	}

	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#getIsNotToBeStandardized()
	 */
	public Boolean getIsNotToBeStandardized() {
		return this.isNotToBeStandardized;
	}

	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#setIsNotToBeStandardized(java.lang.Boolean)
	 */
	public void setIsNotToBeStandardized(Boolean isNotToBeStandardized) {
		this.isNotToBeStandardized = isNotToBeStandardized ;
	}


	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#copyUserData(com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress)
	 */
	public USPostalAddress copyUserData(USPostalAddress srcObj) {
		// let the parent copy itself
		//super.copyUserData(srcObj);
		// copy user data for this class here
		//this.<setter>(srcObj.<getter>());
		
		return this;
	}
	
	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.us.capability.address.impl.USPostalAddress#toString()
	 */
	@Override
	public String toString() {
		return ToStringBuilder.reflectionToString(this, ToStringStyle.SIMPLE_STYLE);
	}

}
