package com.intuit.sb.payroll.capability.common;

import org.testng.annotations.AfterMethod;
import org.testng.annotations.Test;

import com.intuit.sb.payroll.capability.worker.WorkerTestUtils;
import com.intuit.sb.payroll.entity.model.Employee;

/**
 * This class has methods to create a worker and employer. This class can be used to check if your environment is set up correctly
 * and data is saved in the database.
 *
 */
public class BasicWorkerEmployerTest extends BasicTestBase {
	private static Employee anEmployee = null;


	@AfterMethod
	public void cleanUpBasicWorkerEmployerTest()
	{
	    if (null != anEmployee)
	    {
	        try
	        {
	            getUserTransaction().begin();
	            anEmployee = entityService.findById(Employee.class, anEmployee.getId());
	            entityService.makeTransient(anEmployee);
	            getUserTransaction().commit();
	        }
	        catch (Exception e)
	        {
	            e.printStackTrace();
	        }
	    }
	}


	/*
	 * Temporary method created to do a quick embedded container testing. will be commented out in the main code
	 */
	@Test
	public void testCreateEmployee()
	{
		try
		{
    		Employee worker = (Employee)WorkerTestUtils.createEmployee();
    		System.out.println(worker.getDateOfBirth().toString());
    		sLogger.debug(worker.getDateOfBirth().toString());
    		getUserTransaction().begin();
    		anEmployee = entityService.makePersistent(worker);
    		getUserTransaction().commit();
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}


}

