package com.intuit.sb.payroll.capability.common;

/**
 *
 * $Author$
 * $Revision$
 * $DateTime$
 *
 */
public class NameValuePair {
	private String name;
	private String value;
	
	public NameValuePair(String name, String value) {
		super();
		this.name = name;
		this.value = value;
	}

	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		this.name = name;
	}
	
	public String getValue() {
		return value;
	}
	
	public void setValue(String value) {
		this.value = value;
	}
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		result = prime * result + ((value == null) ? 0 : value.hashCode());
		return result;
	}
	
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		NameValuePair other = (NameValuePair) obj;
		if (name == null) {
			if (other.name != null)
				return false;
		} else if (!name.equals(other.name))
			return false;
		if (value == null) {
			if (other.value != null)
				return false;
		} else if (!value.equals(other.value))
			return false;
		return true;
	}
	
    /**
     * Default toString method.
     */
    @Override
    public String toString()
    {
        StringBuilder str = new StringBuilder();
        str.append("<" + name + ">");
        str.append(value);
        str.append("</" + name + ">");
        return str.toString();
    }

}
