package com.intuit.sb.payroll.capability.employer;

import org.testng.AssertJUnit;
import org.testng.annotations.Test;

import com.intuit.sb.payroll.capability.common.PayrollTestBase;
import com.intuit.sb.payroll.capability.taxes.TaxComponent;
import com.intuit.sb.payroll.entity.model.Employer;
import com.intuit.sb.payroll.entity.model.LegalStructureEnum;

public class EmployerTaxSetupTest  extends PayrollTestBase
{

	@Test(enabled=false, groups={"broken"})
    public void testSSNAllowedForEIN() throws Exception
    {
		Employer e1 = new Employer();
		e1.setLegalStructure(LegalStructureEnum.SOLEPROPRIETOR);

		TaxComponent taxComponent = qaBootstrap.getEjbFromClass(TaxComponent.class);
		boolean allowed = taxComponent.isSSNAllowedForEIN(e1);
		//TODO - [rj] how do I check whether this company has already some employees
   		AssertJUnit.assertTrue(allowed);
    }
    
	@Test
    public void testSSNNotAllowedForEIN() throws Exception
    {
		Employer e1 = new Employer();
		e1.setLegalStructure(LegalStructureEnum.CCORP);

		TaxComponent taxComponent = qaBootstrap.getEjbFromClass(TaxComponent.class);
		boolean allowed = taxComponent.isSSNAllowedForEIN(e1);
		AssertJUnit.assertFalse(allowed);
    }
}
