package com.intuit.sb.payroll.capability.pts.statehandler;

import org.testng.Assert;
import org.testng.annotations.Test;

import com.intuit.sb.payroll.capability.pts.notification.PTSNotificationException;
import com.intuit.sb.payroll.capability.pts.notification.PTSNotificationRequest;
import com.intuit.sb.payroll.capability.pts.notification.PTSNotificationTypeEnum;
import com.intuit.sb.payroll.pts.entity.ACHEnrollmentStatusEnum;


public class ACHStatusUpdateHandlerTest extends StatusUpdateHandlerTestBase {

	@Test(enabled=true)
	public void testACHStatusUpdateHandler(){

		ACHEnrollmentStatusEnum[] achEnrollementStatus = ACHEnrollmentStatusEnum.values();
		
		for (ACHEnrollmentStatusEnum enrollmentStatusEnum : achEnrollementStatus) {
			if (enrollmentStatusEnum.equals(ACHEnrollmentStatusEnum.NOTSET)){
				// Skip
				continue;
			}
			PTSNotificationRequest ptsNotificationRequest = createPTSNotificationRequest(
					PTSNotificationTypeEnum.ACH_NOTIFICATION, enrollmentStatusEnum);
			try {
				updateNotificationRequest(ptsNotificationRequest);
			} catch (PTSNotificationException e) {
				Assert.fail(e.getLocalizedMessage(), e);
			}
		}
	}
}
