package com.intuit.sb.payroll.capability.pts.statehandler;

import org.testng.Assert;
import org.testng.annotations.Test;

import com.intuit.sb.payroll.capability.pts.notification.PTSNotificationException;
import com.intuit.sb.payroll.capability.pts.notification.PTSNotificationRequest;
import com.intuit.sb.payroll.capability.pts.notification.PTSNotificationTypeEnum;
import com.intuit.sb.payroll.pts.entity.RAAEnrollmentStatusEnum;


public class RAAStatusUpdateHandlerTest extends StatusUpdateHandlerTestBase  {

	@Test(enabled=true)
	public void testRAAStatusUpdateHandler(){
		RAAEnrollmentStatusEnum[] raaEnrollementStatus = RAAEnrollmentStatusEnum.values();
		
		for (RAAEnrollmentStatusEnum enrollmentStatusEnum : raaEnrollementStatus) {
			if (enrollmentStatusEnum.equals(RAAEnrollmentStatusEnum.NOTSET)){
				// Skip
				continue;
			}
			PTSNotificationRequest ptsNotificationRequest = createPTSNotificationRequest(
					PTSNotificationTypeEnum.RAA_NOTIFICATION, enrollmentStatusEnum);
			try {
				updateNotificationRequest(ptsNotificationRequest);
			} catch (PTSNotificationException e) {
				Assert.fail(e.getLocalizedMessage(), e);
			}
		}
	}

}
