package com.intuit.sb.payroll.capability.taxes.withholding;

import org.testng.annotations.Test;

import com.intuit.sb.payroll.ValidationException;
import com.intuit.sb.payroll.entity.model.ComplianceDocIdEnum;
import com.intuit.sb.payroll.entity.model.WorkerComplianceDocDtl;

/**
 * <P>
 * The <CODE>CreateWorkerComplianceDocDtlTest</CODE> class contains tests for testing the Exceptions that can be thrown
 * by createWorkerComplianceDocDtl() in TaxWithholdingsComponent
 * </P>
 * 
 * $Author$ $Revision$ $DateTime$
 * 
 */
public class CreateWorkerComplianceDocDtlExceptionsTest extends TaxWithholdingsComponentTestBase {

	/**
	 * <P>Test calling createWorkerComplianceDocDtl() with a null ComplianceDocIdEnum</P>
	 * 
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Call the TaxWithholdingsComponent.createWorkerComplianceDocDtl() with a null ComplianceDocIdEnum</LI>
	 * </OL>
	 * 
	 * <UL>
	 * <LI>Verify that ValidationException is thrown
	 * </UL>
	 */
	@Test(expectedExceptions = ValidationException.class)
	public void testNullComplianceDocIdEnum() throws Exception {
    	//Exercise
		@SuppressWarnings("unused")
		WorkerComplianceDocDtl workerComplianceDocDtl = sTaxWithholdingsComponent.createWorkerComplianceDocDtl(null);
	}

	/**
	 * <P>Test calling createWorkerComplianceDocDtl() with ComplianceDocIdEnum not set</P>
	 * 
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Call the TaxWithholdingsComponent.createWorkerComplianceDocDtl() with ComplianceDocIdEnum not set</LI>
	 * </OL>
	 * 
	 * <UL>
	 * <LI>Verify that ValidationException is thrown
	 * </UL>
	 */
	@Test(expectedExceptions = ValidationException.class)
	public void testComplianceDocIdEnumNotSet() throws Exception {
    	//Exercise
		sTaxWithholdingsComponent.createWorkerComplianceDocDtl(ComplianceDocIdEnum.NOTSET);
	}

}
