package com.intuit.sb.payroll.notification;

import org.testng.annotations.Test;

import com.intuit.sb.payroll.notification.template.EmailTemplate;
import com.intuit.sb.payroll.notification.template.PayrollNotificationTemplateFactory;
import com.intuit.sb.payroll.notification.template.RunPayrollReminderTemplate;

public class PayrollNotificationServiceBeanTest
{

	@Test(enabled=false, groups={"broken"})
	public void testNotificationService() throws Exception
	{
		/*
		 * During runtime the keystore, truststore, keystorepassword and truststorepassword
		 * are made available within the jboss runtime.
		 * However, to enable the functionality to be available in the tests, we will
		 * hardcode values and set the system variables from within the test
		 */
		final String keyStore = "../CommonEmployeeService/resource/sbdpayrollgemini.test.intuit.com/sbdpayrollgemini.test.intuit.com.jks";
		final String keyStorePassword = "intuit";

		System.setProperty("javax.net.ssl.trustStore", keyStore);
		System.setProperty("javax.net.ssl.trustStorePassword", keyStorePassword);
		System.setProperty("javax.net.ssl.keyStore", keyStore);
		System.setProperty("javax.net.ssl.keyStorePassword", keyStorePassword);

		PayrollNotificationService notificationWSClient = PayrollNotificationService.getInstance();

		EmailRecipient emailRecipient = new EmailRecipient();
		emailRecipient.setEmailAddress("avnish_malik@intuit.com");
		emailRecipient.setFormat(ContentFormatType.HTML);
		emailRecipient.setRecipientId("amalik");
		emailRecipient.setRecipientName("Avnish Malik");

		EmailTemplate emailTemplate =   PayrollNotificationTemplateFactory.getNotificationTemplate(PayrollNotificationTemplateFactory.TEMPLATE_RAYROLL_RUN_REMINDER);
		emailTemplate.setProperty(RunPayrollReminderTemplate.PRIMARY_CONTACT_NAME, "Avnish Malik");
		emailTemplate.setProperty(RunPayrollReminderTemplate.PRIMARY_CONTACT_EMAIL, "avnish_malik@intuit.com");
		emailTemplate.setProperty(RunPayrollReminderTemplate.PAY_PERIOD_STARTDATE, "10th Oct 2008");
		emailTemplate.setProperty(RunPayrollReminderTemplate.PAY_PERIOD_ENDDATE, "17th Oct 2008");
		emailTemplate.setProperty(RunPayrollReminderTemplate.PAYROLL_RUN_DATE_MINUS_1, "16th Oct 2008");
		emailTemplate.setProperty(RunPayrollReminderTemplate.PAYROLL_RUN_DATE_MINUS_2, "15th Oct 2008");
		emailTemplate.setProperty(RunPayrollReminderTemplate.SEND_DATE, "14 Oct 2008");

		notificationWSClient.sendMail(emailRecipient,emailTemplate);
	}
}
