package com.intuit.sb.payroll.reports;

import javax.ejb.Remote;

import com.intuit.sb.payroll.ServiceFailureException;
import com.intuit.sb.payroll.ValidationException;


@Remote
public interface ReportService {
	
	public static final String JNDI_NAME = "ReportService/remote";
	
	/**
	 * Returns XML blob of data that is relevant to the current context.  Context
	 * in this case means the company/user that is logged in.  It will typically include
	 * for the date range specified. The tasks returned will include even the canceled and closed tasks. 
	 * 
	 * @return a Report that meets the requested criteria.
	 */
	public ReportResponse getReport(ReportRequest reportRequest) throws ServiceFailureException, ValidationException;

}
