package com.intuit.sb.payroll.services.benefits;

import java.io.Serializable;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

import com.intuit.sb.payroll.services.worker.Worker;

public class HealthBenefitResponse  implements Serializable
{
	private static final long serialVersionUID = 8223331149732804621L;

	private Worker worker;
	private HealthBenefit[] benefits;

	public HealthBenefitResponse() {} //default constructor

	public HealthBenefitResponse(Worker worker, HealthBenefit[] benefits) {
		this.worker = worker;
		this.benefits = benefits;
	}
	
	public Worker getWorker() {
		return worker;
	}
	
	public void setWorker(Worker value) {
		this.worker = value;
	}

	public HealthBenefit[] getBenefits() {
		return benefits;
	}
	
	public void setBenefits(HealthBenefit[] benefits) {
		this.benefits = benefits;
	}

	public void copy(HealthBenefitResponse response)
	{
		this.worker = response.worker;
		this.benefits = response.benefits;
	}

	/**
	 * @return the serialVersionUID
	 */
	public static long getSerialVersionUID() {
		return serialVersionUID;
	}

    @Override
    public boolean equals(Object other)
    {
        return EqualsBuilder.reflectionEquals(this, other);
    }

    @Override
    public int hashCode()
    {
       return HashCodeBuilder.reflectionHashCode(this);
    }

	@Override
	public String toString()
	{
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}

}
