package com.intuit.sb.payroll.services.common;

import java.io.Serializable;

import com.intuit.sb.payroll.entity.model.BankAccountTypeEnum;

/**
 * Composed BankAccount DTO
 */
public class BankAccount implements Serializable {

	private static final long serialVersionUID = -1163338212436162614L;

	private ObjectHandle objectHandle;
	
	/**
	 * lockStatus of BankAccount 
	 */
	private boolean locked; 
	
	/**
	 * Name (nickname) for a bank account.
	 */
	private String name;
	/**
	 * Account number within the bank
	 */
	private String accountNo;
	/**
	 * Bank routing number
	 */
	private String routingNo;
	/**
	 * Bank name
	 */
	private String bankName;
	/**
	 * Bank account type
	 */
	private BankAccountTypeEnum accountType;
	/**
	 * Bank Account Status 
	 */
	private BankAccountStatusEnum bankAccountStatus;	
	/**
	 * Is BankAccount Already added
	 */
	private boolean addedToPTS;
	
	public BankAccountStatusEnum getBankAccountStatus() {
		return bankAccountStatus;
	}

	public void setBankAccountStatus(BankAccountStatusEnum bankAccountStatus) {
		this.bankAccountStatus = bankAccountStatus;
	}

	public BankAccountTypeEnum getAccountType() {
		return accountType;
	}

	public void setAccountType(BankAccountTypeEnum accountType) {
		this.accountType = accountType;
	}

	public ObjectHandle getObjectHandle() {
		return objectHandle;
	}

	public void setObjectHandle(ObjectHandle objectHandle) {
		this.objectHandle = objectHandle;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getAccountNo() {
		return accountNo;
	}

	public void setAccountNo(String accountNo) {
		this.accountNo = accountNo;
	}

	public String getRoutingNo() {
		return routingNo;
	}

	public void setRoutingNo(String routingNo) {
		this.routingNo = routingNo;
	}

	public String getBankName() {
		return bankName;
	}

	public void setBankName(String bankName) {
		this.bankName = bankName;
	}
	
	public boolean getLocked() {
		return locked;
	}

	public void setLocked(boolean locked) {
		this.locked = locked;
	}

	public void setAddedToPTS(boolean addedToPTS) {
		this.addedToPTS = addedToPTS;
	}

	public boolean isAddedToPTS() {
		return addedToPTS;
	}
}