package com.intuit.sb.payroll.services.employer;

import java.io.Serializable;

import com.intuit.sb.payroll.services.workerpayments.PayrollRunPeriod;

public class CalendarEntry implements Serializable{

	private static final long serialVersionUID = 4218254113515419245L;

	private int month;
	private int day;
	private int year;
	private String description;
	private CalendarEntryType type;
	private long entryId;
	private PayrollRunPeriod payPeriod;
		
	public long getEntryId() {
		return entryId;
	}

	public void setEntryId(long entryId) {
		this.entryId = entryId;
	}

	public void setPayPeriod(PayrollRunPeriod payPeriod) {
		this.payPeriod = payPeriod;
	}

	public PayrollRunPeriod getPayPeriod() {
		return payPeriod;
	}

	public CalendarEntry() {
	}
	
	public CalendarEntry(int month, int day, int year, String description, CalendarEntryType type, long entryId, PayrollRunPeriod payPeriod)
	{
		setType(type);
		setDay(day);
		setYear(year);
		setMonth(month);
		setDescription(description);
		setEntryId(entryId);
		setPayPeriod(payPeriod);
	}
	
	public CalendarEntryType getType() {
		return type;
	}

	public void setType(CalendarEntryType type) {
		this.type = type;
	}
	
	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public int getMonth() {
		return month;
	}

	public void setMonth(int month) {
		this.month = month;
	}

	public int getDay() {
		return day;
	}

	public void setDay(int day) {
		this.day = day;
	}

	public int getYear() {
		return year;
	}

	public void setYear(int year) {
		this.year = year;
	}

}
