package com.intuit.sb.payroll.services.employer;

import java.io.Serializable;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

import com.intuit.sb.payroll.entity.model.IndustryTypeEnum;
import com.intuit.sb.payroll.entity.model.LegalStructureEnum;
import com.intuit.sb.payroll.services.common.PhysicalAddress;

/**
 * DTO representing Legal information about a Company.
 * 
 * $Author$ $Revision$ $DateTime$
 */
public class CompanyLegalTaxFilingInfo implements Serializable {
	
	private static final long serialVersionUID = -7310367480338017012L;

	private LegalStructureEnum companyLegalType;
	private IndustryTypeEnum industryType;
	private String legalName;
	private boolean legalAddressSameAsBusinessAddress;
	private PhysicalAddress legalAddress;
	private String legalPhone;
	private String extn;

	public LegalStructureEnum getCompanyLegalType() {
		return companyLegalType;
	}

	public void setCompanyLegalType(LegalStructureEnum companyLegalType) {
		this.companyLegalType = companyLegalType;
	}

	public IndustryTypeEnum getIndustryType() {
		return industryType;
	}

	public void setIndustryType(IndustryTypeEnum industryType) {
		this.industryType = industryType;
	}

	public String getLegalName() {
		return legalName;
	}

	public void setLegalName(String legalName) {
		this.legalName = legalName;
	}

	public boolean isLegalAddressSameAsBusinessAddress() {
		return legalAddressSameAsBusinessAddress;
	}

	public void setLegalAddressSameAsBusinessAddress(boolean legalAddressSameAsBusinessAddress) {
		this.legalAddressSameAsBusinessAddress = legalAddressSameAsBusinessAddress;
	}

	public PhysicalAddress getLegalAddress() {
		return legalAddress;
	}

	public void setLegalAddress(PhysicalAddress legalAddress) {
		this.legalAddress = legalAddress;
	}

	public String getLegalPhone() {
		return legalPhone;
	}

	public void setLegalPhone(String legalPhone) {
		this.legalPhone = legalPhone;
	}

	public String getExtn() {
		return extn;
	}

	public void setExtn(String extn) {
		this.extn = extn;
	}

	@Override
	public boolean equals(Object other) {
		return EqualsBuilder.reflectionEquals(this, other);
	}

	@Override
	public int hashCode() {
		return HashCodeBuilder.reflectionHashCode(this);
	}

	@Override
	public String toString() {
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}
}
