package com.intuit.sb.payroll.services.employer;

import com.intuit.sb.payroll.services.common.EnumBase;

/**
 * Company types that are supported.
 *
 */
public class CompanyType extends EnumBase {

	private static final long serialVersionUID = 6361919548573178143L;

	public static final CompanyType SOLE_PROPRIETORSHIP = new CompanyType("Sole Proprietorship", 0); 
	public static final CompanyType CORPORATION = new CompanyType("Corporation", 1); 
	public static final CompanyType LLC = new CompanyType("LLC", 2); 
	public static final CompanyType NON_PROFIT = new CompanyType("Non Profit", 3); 
	public static final CompanyType PARTNERSHIP = new CompanyType("Partnership", 4); 

	private CompanyType(String name, int ordinal) {
		super(name, ordinal);
	}
	
	public static CompanyType[] values() {
		CompanyType[] companyType = new CompanyType[5];
		companyType[0] = SOLE_PROPRIETORSHIP;
		companyType[1] = CORPORATION;
		companyType[2] = LLC;
		companyType[3] = NON_PROFIT;
		companyType[4] = PARTNERSHIP;
		return companyType;
	}

	/**
	 * Public no-arg constructor is required by LCDS. Without it, you get an
	 * exception at runtime with the following message: "Types must have a
	 * public, no arguments constructor". This should never be used by
	 * hand-written code.
	 * 
	 * @deprecated
	 */
	public CompanyType() {
		super();
	}
}
