package com.intuit.sb.payroll.services.employer;

import java.util.ArrayList;

import com.intuit.sb.payroll.services.common.EnumBase;

/**
 * IndustryType represents the list of built in IndustryTypes 
 * TODO: Make this not extend EnumBase - use String constants in Flex and Java 5 enums in Java.
 */
public class IndustryType extends EnumBase {
	private static final long serialVersionUID = 2848924813257791430L;

	public final static IndustryType Construction = new IndustryType("Construction", 0);
	public final static IndustryType Manufacturing = new IndustryType("Manufacturing", 1);
	public final static IndustryType TransportWarehousing = new IndustryType("Transportation and Warehousing", 2);
	public final static IndustryType WholesaleTrade = new IndustryType("Wholesale Trade", 3);
	public final static IndustryType RetailTrade = new IndustryType("Retail Trade", 4);
	public final static IndustryType FinanceInsurance = new IndustryType("Finance, Insurance", 5);
	public final static IndustryType RealEstateRentalLeasing = new IndustryType("Real Estate, Rental and Leasing", 6);
	public final static IndustryType PSTServices = new IndustryType("Professional, Scientific, and Technical Services",
			7);
	public final static IndustryType ManagementCE = new IndustryType("Management of Companies and Enterprises", 8);
	public final static IndustryType EducationalServices = new IndustryType("Educational Services", 9);
	public final static IndustryType HealthCareSocialAssist = new IndustryType("Health Care and Social Assistance", 10);
	public final static IndustryType ArtsEntertainRec = new IndustryType("Arts, Entertainment, and Recreation", 11);
	public final static IndustryType Restaurants = new IndustryType("Restaurants", 12);
	public final static IndustryType NonProfit = new IndustryType("Non Profit", 13);
	public final static IndustryType Accommodation = new IndustryType("Accommodation", 14);
	public final static IndustryType PublicAdmin = new IndustryType("Public Administration", 15);
	public final static IndustryType OtherServices = new IndustryType("Other Services", 16);

	private IndustryType(String name, int ordinal) {
		super(name, ordinal);
	}

	static public IndustryType[] getIndustryTypeList()
	{
		ArrayList<IndustryType> industryTypeList = new ArrayList<IndustryType>();
		
		industryTypeList.add(IndustryType.Construction);
		industryTypeList.add(IndustryType.Manufacturing);
		industryTypeList.add(IndustryType.TransportWarehousing);
		industryTypeList.add(IndustryType.WholesaleTrade);
		industryTypeList.add(IndustryType.RetailTrade);
		industryTypeList.add(IndustryType.FinanceInsurance);
		industryTypeList.add(IndustryType.RealEstateRentalLeasing);
		industryTypeList.add(IndustryType.PSTServices);
		industryTypeList.add(IndustryType.ManagementCE);
		industryTypeList.add(IndustryType.EducationalServices);
		industryTypeList.add(IndustryType.HealthCareSocialAssist);
		industryTypeList.add(IndustryType.ArtsEntertainRec);
		industryTypeList.add(IndustryType.Restaurants);
		industryTypeList.add(IndustryType.NonProfit);
		industryTypeList.add(IndustryType.Accommodation);
		industryTypeList.add(IndustryType.PublicAdmin);
		industryTypeList.add(IndustryType.OtherServices);
		
		IndustryType[] industryTypes = new IndustryType[industryTypeList.size()];
		industryTypeList.toArray(industryTypes);
		
		return industryTypes;
	}

	/**
	 * Public no-arg constructor is required by LCDS. Without it, you get an
	 * exception at runtime with the following message: "Types must have a
	 * public, no arguments constructor". This should never be used by
	 * hand-written code.
	 * 
	 * @deprecated
	 */
	public IndustryType() {
		super();
	}

}
