package com.intuit.sb.payroll.services.employer.impl;


import com.intuit.sb.payroll.ServiceFailureException;
import com.intuit.sb.payroll.ValidationException;
import com.intuit.sb.payroll.capability.employer.EmployerComponent;
import com.intuit.sb.payroll.common.DateUtil;
import com.intuit.sb.payroll.common.ServiceLocator;
import com.intuit.sb.payroll.entity.model.Employer;


public class CompanyCreateImpl {
	
	/**
	 * 
	 * @return true if the company was created, otherwise false.
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 */
	public static boolean createCompany() throws ValidationException, ServiceFailureException {
		
		EmployerComponent employerComponent = ServiceLocator.getInstance().getService(EmployerComponent.JNDI_NAME);
		if (employerComponent.getEmployer() != null) {
			return false;
		}
		Employer employer = new Employer();
		employer.setFirstPayrollDate(DateUtil.getNowDate());
		//employer.setCompanyName(" "); //FIXME -[rj] can we get this from the IAM, since this info is already entered in the signup page
		employer = employerComponent.createEmployer(employer);
		return true;
	}
}
