package com.intuit.sb.payroll.services.pto;

import java.io.Serializable;

import com.intuit.sb.payroll.services.worker.Worker;

/**
 * Response returned by PTOService.savePTO(), including the worker with updated version
 * and an array of all the worker's PTOInfos.
 */
public class SavePTOResponse implements Serializable {

    /**
     * Generated by eclipse.
     */
    private static final long serialVersionUID = 6437797298351118070L;
    
    private Worker worker;
    private PTOInfo[] ptoInfos;

    /** No-arg constructor for LCDS */
    public SavePTOResponse() {
	super();
    }
    
    public SavePTOResponse(Worker worker, PTOInfo[] ptoInfos) {
	super();
	this.worker = worker;
	this.ptoInfos = ptoInfos;
    }
    
    public Worker getWorker() {
	return worker;
    }
    
    public void setWorker(Worker worker) {
	this.worker = worker;
    }
    
    public PTOInfo[] getPtoInfos() {
	return ptoInfos;
    }
    
    public void setPtoInfos(PTOInfo[] ptoInfos) {
	this.ptoInfos = ptoInfos;
    }
}
