package com.intuit.sb.payroll.services.taxes;


import java.io.Serializable;

import com.intuit.sb.payroll.services.common.DatePeriod;
import com.intuit.sb.payroll.services.common.ObjectHandle;

/**
 * POJO that represents the Employer SUI setting for a state
 * @author rjohn2
 *
 */
public class EmployerUnemploymentIns implements Serializable  
{
	private static final long serialVersionUID = 1659568456187325010L;

	private String state; // AgencyEnum
	private String effectiveRate;
	private ObjectHandle objectHandle;
	private DatePeriod effectivePeriod;
	
	private boolean rateChangedByIntuit; //flag indicating whether the rate is changed by Intuit or not
	private boolean defaultRate;
	
	private String minRate;
	private String maxRate;

	public String getMinRate() {
		return minRate;
	}

	public void setMinRate(String minRate) {
		this.minRate = minRate;
	}

	public String getMaxRate() {
		return maxRate;
	}

	public void setMaxRate(String maxRate) {
		this.maxRate = maxRate;
	}
	
	/**
	 * @return the defaultRate
	 */
	public boolean isDefaultRate() {
		return defaultRate;
	}

	/**
	 * @param defaultRate the defaultRate to set
	 */
	public void setDefaultRate(boolean defaultRate) {
		this.defaultRate = defaultRate;
	}

	/**
	 * @return the state
	 */
	public String getState() 
	{
		return state;
	}

	/**
	 * @param state the state to set
	 */
	public void setState(String state) 
	{
		this.state = state;
	}


	/**
	 * @return the rateChangedByIntuit
	 */
	public boolean isRateChangedByIntuit() 
	{
		return rateChangedByIntuit;
	}

	/**
	 * @param rateChangedByIntuit the rateChangedByIntuit to set
	 */
	public void setRateChangedByIntuit(boolean rateChangedByIntuit) 
	{
		this.rateChangedByIntuit = rateChangedByIntuit;
	}



	public void setEffectiveRate(String effectiveRate) {
		this.effectiveRate = effectiveRate;
	}

	public String getEffectiveRate() {
		return effectiveRate;
	}

	public void setEffectivePeriod(DatePeriod effectivePeriod) {
		this.effectivePeriod = effectivePeriod;
	}

	public DatePeriod getEffectivePeriod() {
		return effectivePeriod;
	}

	public void setObjectHandle(ObjectHandle objectHandle) {
		this.objectHandle = objectHandle;
	}

	public ObjectHandle getObjectHandle() {
		return objectHandle;
	}

}
