package com.intuit.sb.payroll.services.taxes;

import java.io.Serializable;

/**
 * Class to represent various tax agencies
 * This exists in the impl package so that its constructor can be protected and it
 * can be used by the appropriate service implementation
 * @author riyer
 *
 */
public class TaxAgency implements Serializable {

private static final long serialVersionUID = -5388551927193250626L;
	
	public String name;

	public String taxIdPattern;	//	regexp
	
	public String taxIdGhostText;	//  sample ghost text
	
	public boolean mandatory;	//	is the id mandatory
	
	/**
	 * Create TaxAgency object with required parameters
	 * @param name
	 * @param pattern
	 * @param ghostText
	 * @param mandatory
	 */
	public TaxAgency(String name, String pattern, String ghostText, 
			boolean mandatory) {
		this.name = name;
		this.taxIdGhostText = ghostText;
		this.taxIdPattern = pattern;
		this.mandatory = mandatory;
	}
	
	/**
	 * Public no-arg constructor is required by LCDS. Without it, you get an
	 * exception with the following message: "Types must have a public, no
	 * arguments constructor". This should never be used by hand-written code.
	 * 
	 * @deprecated
	 */
	public TaxAgency() {
	}
}
