package com.intuit.sb.payroll.services.taxes;

import java.io.Serializable;
import java.math.BigDecimal;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import com.intuit.sb.payroll.services.common.ObjectHandle;

public class WithholdingInformation implements Serializable {

	private static final long serialVersionUID = 7168403185219632651L;

	private ObjectHandle objectHandle;
	private FormType formType;
	private WithholdingStatus withholdingStatus;
	private int allowances;
	private int deductions;
	private BigDecimal extraWithholding;
	private boolean exempt;

	public WithholdingInformation() {
		super();
	}

	public WithholdingInformation(ObjectHandle objectHandle, FormType formType,
			WithholdingStatus withholdingStatus, int allowances, int deductions, BigDecimal extraWithholding,
			boolean exempt) {
		this();
		this.objectHandle = objectHandle;
		this.formType = formType;
		this.withholdingStatus = withholdingStatus;
		this.allowances = allowances;
		this.deductions = deductions;
		this.extraWithholding = extraWithholding;
		this.exempt = exempt;
	}

	public ObjectHandle getObjectHandle() {
		return objectHandle;
	}

	public void setObjectHandle(ObjectHandle objectHandle) {
		this.objectHandle = objectHandle;
	}

	public FormType getFormType() {
		return formType;
	}

	public void setFormType(FormType formType) {
		this.formType = formType;
	}

	public WithholdingStatus getWithholdingStatus() {
		return withholdingStatus;
	}

	public void setWithholdingStatus(WithholdingStatus withholdingStatus) {
		this.withholdingStatus = withholdingStatus;
	}

	public int getAllowances() {
		return allowances;
	}

	public void setAllowances(int allowances) {
		this.allowances = allowances;
	}

	public int getDeductions() {
		return deductions;
	}

	public void setDeductions(int deductions) {
		this.deductions = deductions;
	}

	public BigDecimal getExtraWithholding() {
		return extraWithholding;
	}

	public void setExtraWithholding(BigDecimal extraWithholding) {
		this.extraWithholding = extraWithholding;
	}

	public boolean isExempt() {
		return exempt;
	}

	public void setExempt(boolean exempt) {
		this.exempt = exempt;
	}

	@Override
	public boolean equals(Object other) {
		return EqualsBuilder.reflectionEquals(this, other);
	}

	@Override
	public int hashCode() {
		return HashCodeBuilder.reflectionHashCode(this);
	}

	@Override
	public String toString() {
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}
}
