package com.intuit.sb.payroll.services.taxes.impl;

import com.intuit.sb.payroll.capability.employer.EmployerPTSWorkflowComponent;
import com.intuit.sb.payroll.capability.pts.statehandler.StatusUpdateHandlerUtil;
import com.intuit.sb.payroll.common.ServiceLocator;
import com.intuit.sb.payroll.entity.model.EmployerId;
import com.intuit.sb.payroll.pts.entity.PTSEmployer;
import com.intuit.sb.payroll.services.taxes.EmployerTaxIdInfo;
import com.intuit.sb.payroll.services.taxes.TaxAgency;

public class EmployerTaxIdMapper
{
    private static EmployerPTSWorkflowComponent sEmployerPTSWorkflowComponent = ServiceLocator.getInstance().getService(EmployerPTSWorkflowComponent.JNDI_NAME);

    public static EmployerTaxIdInfo mapToEmployerTaxIdInfo(EmployerId employerId)
    {
        PTSEmployer ptsEmployer = sEmployerPTSWorkflowComponent.getPTSEmployer();

        if(employerId == null)
        {
            return null;
        }
        EmployerTaxIdInfo empTaxIdInfo =  new EmployerTaxIdInfo();
        empTaxIdInfo.setTaxId(employerId.getValue());
        empTaxIdInfo.setUniqueId(employerId.getId());

        // Setting up the value of "locked" field in EmployerTaxIdInfo based on the EFTPSEnrollmentStatusEnum and the ActivationStatusEnum
        // TODO - setLockedValue need-not be called for all the employerId, since the value of locked is the same for all
        empTaxIdInfo.setLocked(StatusUpdateHandlerUtil.isEINOrLegalNameUpdateDisabled(ptsEmployer));

        if(employerId.getAgencyIdType() != null) {
            TaxAgency taxAgency = TaxAgencyMapper.mapToService(employerId.getAgencyIdType());
            empTaxIdInfo.setTaxAgency(taxAgency);
        }
        return empTaxIdInfo;
    }
}