package com.intuit.sb.payroll.services.taxpayments;

import java.io.Serializable;
import java.util.Date;

import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;


/**
 * Class representing the complete YtdTaxpayment details for the Employer<br>
 * for the year.<br>
 * <ul>It includes:
 * <li>A {@code List} of {@code TaxPayments} objects, each containing information on when and what payments<br>
 * were done
 * <li>Liability details for each of the ({@code TaxPaymentLiabilities}
 *
 */
public class ToDateTaxPayments implements Serializable {

	private static final long serialVersionUID = -7057656807642673061L;

	private TaxPayments[] taxPayments = {};
	private Date taxPaymentsStartDate;
	private Date taxPaymentsEndDate;
    
	public Date getTaxPaymentsStartDate() {
		return taxPaymentsStartDate;
	}

	public void setTaxPaymentsStartDate(Date taxPaymentsStartDate) {
		this.taxPaymentsStartDate = taxPaymentsStartDate;
	}

	public Date getTaxPaymentsEndDate() {
		return taxPaymentsEndDate;
	}

	public void setTaxPaymentsEndDate(Date taxPaymentsEndDate) {
		this.taxPaymentsEndDate = taxPaymentsEndDate;
	}

	public TaxPayments[] getTaxPayments() {
		return taxPayments;
	}

	public void setTaxPayments(TaxPayments[] taxPayments) {
		if (taxPayments == null) {
			taxPayments = new TaxPayments[]{};	//	empty array - never null
		}
		this.taxPayments = taxPayments;
	}

	public void addTaxPayments(TaxPayments taxPayment) {
		taxPayments[taxPayments.length] = taxPayment;
	}
	@Override
	public String toString() {
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}	
}
