package com.intuit.sb.payroll.services.wages;

import java.io.Serializable;

import com.intuit.sb.payroll.services.worker.Worker;

/**
 * Response container for WageService.saveCompensationItems().  
 * Contains the worker because saving compensation items revs the workers version.
 */
public class SaveCompensationItemResponse implements Serializable{

    /**
     * Generated by eclipse.
     */
    private static final long serialVersionUID = 4360358993983330109L;
    
    private Worker worker;
    private CompensationItem[] compensationItems;

    /**
     * No args constructor required for LCDS.
     */
    public SaveCompensationItemResponse() {
	super();
    }
    
    /**
     * Convenience constructor
     */
    public SaveCompensationItemResponse(Worker worker, CompensationItem[] compensationItems) {
	super();
	this.worker = worker;
	this.compensationItems = compensationItems;
    }
	
    public Worker getWorker() {
	return worker;
    }
    
    public void setWorker(Worker worker) {
	this.worker = worker;
    }
    
    public CompensationItem[] getCompensationItems() {
	return compensationItems;
    }
    
    public void setCompensationItems(CompensationItem[] compensationItems) {
	this.compensationItems = compensationItems;
    }
}
