package com.intuit.sb.payroll.services.wages.impl;

import com.intuit.sb.payroll.ServiceFailureException;
import com.intuit.sb.payroll.ValidationException;
import com.intuit.sb.payroll.services.wages.CompensationItem;
import com.intuit.sb.payroll.services.wages.SaveCompensationItemOperation;

public class CompensationItemParamValidator {

	public static void validateCompensationItem(CompensationItem compensationItem, SaveCompensationItemOperation operation) throws ServiceFailureException, ValidationException
	{
		validateCompensationItem(compensationItem);
		
		if (operation.equals(SaveCompensationItemOperation.ADD)) {
			if (compensationItem.getObjectHandle() != null) {
				//FIXME [I18N] resource translation
				throw new ServiceFailureException("CompensationItem must not have an ObjectHandle for create operations");				
			}
		}
		else {
			if (compensationItem.getObjectHandle() == null) {
				//FIXME [I18N] resource translation
				throw new ServiceFailureException("CompensationItem must have an ObjectHandle for non-create operations");				
			}
		}
	}

	public static void validateCompensationItems(CompensationItem[] compensationItems) throws ServiceFailureException, ValidationException {
		if (null == compensationItems)
		{
			//FIXME [I18N] resource translation
			throw new ServiceFailureException("CompensationItems must not be null");
		}
		for (CompensationItem compensationItem : compensationItems) {
			validateCompensationItem(compensationItem);
		}
	}
	
	public static void validateCompensationItem(CompensationItem compensationItem) throws ServiceFailureException, ValidationException {
		// Validate params
		if (null == compensationItem) {
			//FIXME [I18N] resource translation
			throw new ServiceFailureException("CompensationItem must not be null");
		}
		
		if (null == compensationItem.getCompensationType()) {
			//FIXME [I18N] resource translation
			throw new ServiceFailureException("CompensationType must be set on CompensationItem");				
		}
	}
}
