package com.intuit.sb.payroll.services.workerpayments;

import java.io.Serializable;
import java.math.BigDecimal;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

import com.intuit.sb.payroll.services.common.ObjectHandle;

public class CalcInputs implements Serializable {

	private static final long serialVersionUID = 1634193932153606901L;

	private ObjectHandle payItemObjectHandle;
	private BigDecimal rate;
	private double units;

	public CalcInputs() {
	}

	public ObjectHandle getPayItemObjectHandle() {
		return payItemObjectHandle;
	}

	public void setPayItemObjectHandle(ObjectHandle payItemObjectHandle) {
		this.payItemObjectHandle = payItemObjectHandle;
	}

	public BigDecimal getRate() {
		return rate;
	}

	public void setRate(BigDecimal rate) {
		this.rate = rate;
	}

	public double getUnits() {
		return units;
	}

	public void setUnits(double units) {
		this.units = units;
	}

	@Override
	public boolean equals(Object other) {
		return EqualsBuilder.reflectionEquals(this, other);
	}

	@Override
	public int hashCode() {
		return HashCodeBuilder.reflectionHashCode(this);
	}

	@Override
	public String toString() {
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}
}
