package com.intuit.sb.payroll.services.workerpayments;

import java.io.Serializable;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

public class PaycheckRequest implements Serializable {
	private static final long serialVersionUID = 6876604246113721372L;
	private Long workerId;
	private CalcInputs[] calcInputs;
	private PaycheckDistributionMethod distributionMethod;
	private PayrollRunPeriod payrollRunPeriod;

	/**
	 * Default constructor
	 */
	public PaycheckRequest() {
		super();
	}

	/**
	 * @param workerUniqueId
	 * @param wageItems
	 * @param distributionMethod
	 * @param payPeriod
	 */
	public PaycheckRequest(Long workerUniqueId, CalcInputs[] calcInputs,
			PaycheckDistributionMethod distributionMethod, PayrollRunPeriod payPeriod) {
		this();
		this.workerId = workerUniqueId;
		this.calcInputs = calcInputs;
		this.distributionMethod = distributionMethod;
		this.payrollRunPeriod = payPeriod;
	}

	/**
	 * @return the distributionMethod
	 */
	public PaycheckDistributionMethod getDistributionMethod() {
		return distributionMethod;
	}

	/**
	 * @param distributionMethod
	 *            the distributionMethod to set
	 */
	public void setDistributionMethod(PaycheckDistributionMethod distributionMethod) {
		this.distributionMethod = distributionMethod;
	}

	/**
	 * @return the workerUniqueId
	 */
	public Long getWorkerId() {
		return workerId;
	}

	/**
	 * @param workerUniqueId
	 *            the workerUniqueId to set
	 */
	public void setWorkerId(Long workerUniqueId) {
		this.workerId = workerUniqueId;
	}

	public PayrollRunPeriod getPayrollRunPeriod() {
		return payrollRunPeriod;
	}

	public void setPayrollRunPeriod(PayrollRunPeriod payPeriod) {
		this.payrollRunPeriod = payPeriod;
	}

	public CalcInputs[] getCalcInputs() {
		return calcInputs;
	}

	public void setCalcInputs(CalcInputs[] calcInputs) {
		this.calcInputs = calcInputs;
	}
	
	@Override
	public boolean equals(Object other) {
		return EqualsBuilder.reflectionEquals(this, other);
	}

	@Override
	public int hashCode() {
		return HashCodeBuilder.reflectionHashCode(this);
	}

	@Override
	public String toString() {
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}
}