package com.intuit.sb.payroll.services.workerpayments;

import java.io.Serializable;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

import com.intuit.sb.payroll.entity.model.PayrollRunTypeEnum;

/**
 * Lightweight DTO to return "just enough" PayrollRun info to display in a list. (No paychecks).
 */
public class PayrollRunInfo implements Serializable {

	private static final long serialVersionUID = -509996676291264403L;
	private Long payrollRunId;
	private PayrollRunPeriod payrollRunPeriod;
	private PayrollRunState payrollRunState;
	private PayrollRunTypeEnum payrollRunType;

	/**
	 * @return the payrollRunId
	 */
	public Long getPayrollRunId() {
		return payrollRunId;
	}

	/**
	 * @param payrollRunId the payrollRunId to set
	 */
	public void setPayrollRunId(Long payrollRunId) {
		this.payrollRunId = payrollRunId;
	}

	/**
	 * @return the payrollRunPeriod
	 */
	public PayrollRunPeriod getPayrollRunPeriod() {
		return payrollRunPeriod;
	}

	/**
	 * @param payrollRunPeriod the payrollRunPeriod to set
	 */
	public void setPayrollRunPeriod(PayrollRunPeriod payrollRunPeriod) {
		this.payrollRunPeriod = payrollRunPeriod;
	}

	/**
	 * @return the payrollRunState
	 */
	public PayrollRunState getPayrollRunState() {
		return payrollRunState;
	}

	/**
	 * @param payrollRunState the payrollRunState to set
	 */
	public void setPayrollRunState(PayrollRunState payrollRunState) {
		this.payrollRunState = payrollRunState;
	}
	
	public void setPayrollRunType(PayrollRunTypeEnum payrollRunType) {
		this.payrollRunType = payrollRunType;
	}

	public PayrollRunTypeEnum getPayrollRunType() {
		return payrollRunType;
	}

	@Override
	public boolean equals(Object other) {
		return EqualsBuilder.reflectionEquals(this, other);
	}

	@Override
	public int hashCode() {
		return HashCodeBuilder.reflectionHashCode(this);
	}

	@Override
	public String toString() {
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}


}
