package com.intuit.sb.payroll.services.workerpayments;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

import com.intuit.sb.payroll.task.Task;

/**
 * The task to manage the scheduling of a single payroll run.
 */
public class PayrollRunTask extends Task
{
	private static final long serialVersionUID = 7044926046854221721L;
	
	private String payrollRunId;
	private PayrollRunState state;
	private PayrollRunSummary summary;
	
	public PayrollRunTask() {}

	/**
	 * @return the payrollRunId
	 */
	public String getPayrollRunId() {
		return payrollRunId;
	}

	/**
	 * @param payrollRunId the payrollRunId to set
	 */
	public void setPayrollRunId(String payrollRunId) {
		this.payrollRunId = payrollRunId;
	}

	/**
	 * @return the state
	 */
	public PayrollRunState getState() {
		return state;
	}

	/**
	 * @param state the state to set
	 */
	public void setState(PayrollRunState state) {
		this.state = state;
	}

	/**
	 * @return the summary
	 */
	public PayrollRunSummary getSummary() {
		return summary;
	}

	/**
	 * @param summary the summary to set
	 */
	public void setSummary(PayrollRunSummary summary) {
		this.summary = summary;
	}
	
    @Override
    public boolean equals(Object other)
    {
        return EqualsBuilder.reflectionEquals(this, other);
    }
    
    @Override
    public int hashCode()
    {
       return HashCodeBuilder.reflectionHashCode(this);
    }
    
	@Override
	public String toString()
	{
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}
}
