package com.intuit.sb.payroll.services.workerpayments.impl;

import java.math.BigDecimal;

import com.intuit.sb.payroll.ServiceFailureException;
import com.intuit.sb.payroll.ValidationException;
import com.intuit.sb.payroll.services.workerpayments.CalcInputs;

/**
 * Basic Validation for CalcInputs.
 *
 * $Author: $ 
 * $Revision: $
 * $DateTime: $
 */
public class CalcInputsParamValidator {

	public static void validateCalcInputs(CalcInputs[] inputs) throws ServiceFailureException, ValidationException {
		if (null == inputs)
		{
			//FIXME [I18N] resource translation
			throw new ServiceFailureException("CalcInputs must not be null");
		}
		for (CalcInputs input : inputs) {
			validateCalcInput(input);
		}
	}
	
	public static void validateCalcInput(CalcInputs input) throws ServiceFailureException, ValidationException {
		// Validate params
		if (null == input) {
			//FIXME [I18N] resource translation
			throw new ServiceFailureException("CalcInput must not be null");
		}
		
		//FIXME [Impl] [th] This is business logic validation and should be in capability. Only null param checking should 
		// live here.
		//Validating negative rates
		if (input.getRate()!= null) {
			if (input.getRate().compareTo(new BigDecimal(0)) < 0)
			{
				//FIXME [I18N] resource translation
				throw new ValidationException("Rate must not be negative");
			}
		}
		
		// Validate negative units
		if (input.getUnits() < 0) {
				//FIXME [I18N] resource translation
				throw new ValidationException("Units must not be negative");
		}
		
		if (null == input.getPayItemObjectHandle()) {
			//FIXME [I18N] resource translation
			throw new ServiceFailureException("PayItemObjectHandle must be set on CalcInput");				
		}
	}
}
