package com.intuit.sb.payroll.services.workerpayments.impl;

import com.intuit.sb.payroll.entity.model.PayrollFrequencyEnum;


/**
 * Converts Pojo and Services Payroll Frequencies.
 *
 * Tested by the PayrollFrequencyMapperTest in the same package.
 *
 * $Author$
 * $Revision$
 * $DateTime$
 *
 */
public class PayrollFrequencyMapper {

    private PayrollFrequencyMapper() {
    }

    /**
     * Maps a Data Entity PayrollFrequency to Entity Interface PayrollScheduleFrequency
     *
     * @param prFrequency
     * @return  Entity Interface PayrollScheduleFrequency
     */
    public static com.intuit.sb.payroll.services.workerpayments.PayrollScheduleFrequency mapFromDEntityToEI(
    				PayrollFrequencyEnum prFrequency) {
        if (prFrequency == null) {
            return null;
        }
        if (prFrequency == PayrollFrequencyEnum.NOTSET) {
            return com.intuit.sb.payroll.services.workerpayments.PayrollScheduleFrequency.NOT_SET;
        }
        if (prFrequency == PayrollFrequencyEnum.WEEKLY) {
            return com.intuit.sb.payroll.services.workerpayments.PayrollScheduleFrequency.WEEKLY;
        }
        if (prFrequency == PayrollFrequencyEnum.BIWEEKLY) {
            return com.intuit.sb.payroll.services.workerpayments.PayrollScheduleFrequency.BIWEEKLY;
        }
        if (prFrequency == PayrollFrequencyEnum.MONTHLY) {
            return com.intuit.sb.payroll.services.workerpayments.PayrollScheduleFrequency.MONTHLY;
        }
        if (prFrequency == PayrollFrequencyEnum.SEMIMONTHLY) {
            return com.intuit.sb.payroll.services.workerpayments.PayrollScheduleFrequency.SEMIMONTHLY;
        }
        return com.intuit.sb.payroll.services.workerpayments.PayrollScheduleFrequency.NOT_SET;
    }

    /**
     * Maps Entity Interface PayrollScheduleFrequency to Data Entity PayrollFrequency
     *
     * @param eiFrequency Entity Interface PayrollScheduleFrequency to map from
     * @return PayrollFrequency
     */
    public static PayrollFrequencyEnum mapFromEIToDEntity(
                    com.intuit.sb.payroll.services.workerpayments.PayrollScheduleFrequency eiFrequency) {
        if (null == eiFrequency) {
            return null;
        }
        if (eiFrequency.equals(com.intuit.sb.payroll.services.workerpayments.PayrollScheduleFrequency.BIWEEKLY)) {
            return PayrollFrequencyEnum.BIWEEKLY;
        }
        if (eiFrequency.equals(com.intuit.sb.payroll.services.workerpayments.PayrollScheduleFrequency.MONTHLY)) {
            return PayrollFrequencyEnum.MONTHLY;
        }
        if (eiFrequency.equals(com.intuit.sb.payroll.services.workerpayments.PayrollScheduleFrequency.SEMIMONTHLY)) {
            return PayrollFrequencyEnum.SEMIMONTHLY;
        }
        if (eiFrequency.equals(com.intuit.sb.payroll.services.workerpayments.PayrollScheduleFrequency.WEEKLY)) {
            return PayrollFrequencyEnum.WEEKLY;
        } else {
            return PayrollFrequencyEnum.NOTSET;
        }
    }
}
