package com.intuit.sb.payroll.reports;

/**
 * <P>The <CODE>ReportsServiceTest</CODE> class is the class containing tests against the 
 * Payroll Engine ReportService API. 
 * 
 * $Author$
 * $Revision$
 * $DateTime$
 *
 */

import java.util.Calendar;
import java.util.Date;

import org.testng.AssertJUnit;
import org.testng.annotations.Test;

import com.intuit.sb.payroll.common.DateUtil;


public class ReportServiceTest extends ReportServiceTestBase {
	
	@Test (enabled=true)
    public void testCreateReports() throws Exception
    {
		Date fromDate = DateUtil.createDate(2007, Calendar.DECEMBER, 25);	//25th Dec 2007
		Date toDate = DateUtil.createDate(2009, Calendar.DECEMBER, 21);
		ReportRequest reportRequest = new ReportRequest(ReportType.CA_TAX_LIABILITIES, fromDate, toDate, 
				ReportSubtotals.PER_PAYCHECK, ReportDetail.DETAIL, "12/25/2007 - 12/21/2009");
		ReportResponse response = reportService.getReport(reportRequest);
		AssertJUnit.assertNotNull(response);
		AssertJUnit.assertNotNull(response.getXmlData());
    }

	@Test (enabled=true)
    public void testSql92() throws Exception
    {
		// a number of arg values below are immaterial but are needed to conform to the interface spec
		Date fromDate = DateUtil.createDate(2007, Calendar.DECEMBER, 25);	//25th Dec 2007
		Date toDate = DateUtil.createDate(2009, Calendar.DECEMBER, 21);
		ReportRequest reportRequest = new ReportRequest(ReportType.SQL92TEST, fromDate, toDate, 
				ReportSubtotals.PER_PAYCHECK, ReportDetail.DETAIL, "12/25/2007 - 12/21/2009");
		ReportResponse response = reportService.getReport(reportRequest);
		AssertJUnit.assertNotNull(response);
		AssertJUnit.assertNotNull(response.getXmlData());
    }
}
