package com.intuit.sb.payroll.services.employer;

import org.testng.AssertJUnit;

import org.testng.annotations.BeforeMethod;
import org.testng.annotations.Test;

import com.intuit.sb.payroll.entity.model.LegalStructureEnum;
import com.intuit.sb.payroll.services.employer.impl.CompanyTypeMapper;

/**
 * These tests are for CompanyTypeMapper to test the mapping functionality is working correctly.
 * @author smadduri
 *
 */

@SuppressWarnings("static-access")
public class CompanyTypeMapperTest
{
	private CompanyTypeMapper mock;
	
	@BeforeMethod
	public void setup()
	{
		mock = new CompanyTypeMapper();
	}
	
	@Test
	public void testMapCompanyType()
	{
		AssertJUnit.assertEquals(LegalStructureEnum.CCORP, mock.mapCompanyType(CompanyType.CORPORATION));
		AssertJUnit.assertEquals(LegalStructureEnum.LLC, mock.mapCompanyType(CompanyType.LLC));
		AssertJUnit.assertEquals(LegalStructureEnum.STATUS501C3, mock.mapCompanyType(CompanyType.NON_PROFIT));
		AssertJUnit.assertEquals(LegalStructureEnum.PARTNERSHIP, mock.mapCompanyType(CompanyType.PARTNERSHIP));
		AssertJUnit.assertEquals(LegalStructureEnum.SOLEPROPRIETOR, mock.mapCompanyType(CompanyType.SOLE_PROPRIETORSHIP));
		AssertJUnit.assertEquals(null, mock.mapCompanyType((CompanyType)null));
		
		AssertJUnit.assertEquals(CompanyType.CORPORATION, mock.mapCompanyType(LegalStructureEnum.CCORP));
		AssertJUnit.assertEquals(CompanyType.LLC, mock.mapCompanyType(LegalStructureEnum.LLC));
		AssertJUnit.assertEquals(CompanyType.NON_PROFIT, mock.mapCompanyType(LegalStructureEnum.STATUS501C3));
		AssertJUnit.assertEquals(CompanyType.PARTNERSHIP, mock.mapCompanyType(LegalStructureEnum.PARTNERSHIP));
		AssertJUnit.assertEquals(CompanyType.SOLE_PROPRIETORSHIP, mock.mapCompanyType(LegalStructureEnum.SOLEPROPRIETOR));
		AssertJUnit.assertEquals(null, mock.mapCompanyType(LegalStructureEnum.OTHER));
		AssertJUnit.assertEquals(null, mock.mapCompanyType((LegalStructureEnum)null));
	}
}
