package com.intuit.sb.payroll.services.pto.impl;

import org.testng.annotations.Test;

import com.intuit.sb.payroll.ValidationException;
import com.intuit.sb.payroll.services.pto.AccrualStartType;
import com.intuit.sb.payroll.services.pto.PTOAccrualType;
import com.intuit.sb.payroll.services.pto.PTOInfo;
import com.intuit.sb.payroll.services.pto.PTOType;

public class PTOValidatorTest {

	static private PTOInfo createValidPtoInfo() {
		PTOInfo info = new PTOInfo();
		info.setPtoType(PTOType.SICK_TIME);
		info.setPtoAccrualType(PTOAccrualType.EACH_PAYCHECK);
		info.setAccrualStartType(AccrualStartType.IMMEDIATELY);
		info.setName("1");
		info.setAccrualRate(1.0);
		return info;
	}
	
	@Test(expectedExceptions=ValidationException.class)
	public void testNullInfo() throws Exception {
		PTOParamValidator.validatePto(null);
	}

	@Test(expectedExceptions=ValidationException.class)
	public void testNullPtoType() throws Exception {
		PTOInfo info = createValidPtoInfo();
		info.setPtoType(null);
		PTOParamValidator.validatePto(info);
	}

	@Test(expectedExceptions=ValidationException.class)
	public void testNullAccrualType() throws Exception {
		PTOInfo info = createValidPtoInfo();
		info.setPtoAccrualType(null);
		PTOParamValidator.validatePto(info);
	}

	@Test(expectedExceptions=ValidationException.class)
	public void testNullAccrualStartType() throws Exception {
		PTOInfo info = createValidPtoInfo();
		info.setAccrualStartType(null);
		PTOParamValidator.validatePto(info);
	}

}
