/**
 *
 */
package com.intuit.sb.payroll.services.taxes;

import org.testng.AssertJUnit;
import org.testng.annotations.Test;

import com.intuit.sb.payroll.capability.common.BasicTestBase;
import com.intuit.sb.payroll.entity.model.AgencyEnum;
import com.intuit.sb.payroll.entity.model.AgencyIdType;
import com.intuit.sb.payroll.entity.model.EmployerIdTypeEnum;
import com.intuit.sb.payroll.services.taxes.impl.TaxAgencyMapper;

/**
 * @author dkulkarni
 *
 */
public class TaxAgencyMapperTest extends BasicTestBase
{

	/**
	 * Test method for {@link com.intuit.sb.payroll.services.taxes.impl.TaxAgencyMapper#mapToService(com.intuit.sb.payroll.entity.model.AgencyIdType)}.
	 */
	@Test
	public void testMapToService()
	{
		AgencyIdType agencyIdType = new AgencyIdType();
		agencyIdType.setAgencyKey(AgencyEnum.CA_EDD);
		agencyIdType.setIdTypeKey(EmployerIdTypeEnum.SINGLE_VALUE_AGENCY_SPECIFIC);
		agencyIdType.setAgencyIdValidationPattern("abcd");
		agencyIdType.setGhostText("xx-xxx-xx-xxxx");
		agencyIdType.setMandatory(false);

		TaxAgency taxAgency = TaxAgencyMapper.mapToService(agencyIdType);

		AssertJUnit.assertEquals(taxAgency.taxIdGhostText, agencyIdType.getGhostText());
		AssertJUnit.assertEquals(taxAgency.taxIdPattern, agencyIdType.getAgencyIdValidationPattern());
		AssertJUnit.assertEquals(taxAgency.name, agencyIdType.getAgencyKey().toString());
		AssertJUnit.assertEquals(taxAgency.mandatory, agencyIdType.isMandatory());
	}

}
