package com.intuit.sb.payroll.services.taxpayments;

import java.util.Date;

import org.testng.Assert;
import org.testng.annotations.Test;

import com.intuit.sb.payroll.capability.common.BasicTestBase;
import com.intuit.sb.payroll.entity.model.DateRange;
import com.intuit.sb.payroll.entity.model.Payment;
import com.intuit.sb.payroll.services.taxpayments.impl.DateRangeMapper;
import com.intuit.sb.payroll.services.taxpayments.impl.TaxPaymentsMapper;

public class TaxPaymentsMapperTest extends BasicTestBase {

	@Test
	public void testMapPaymentEntityToTaxPaymentsDto() throws Exception {
		Payment[] payments = TaxPaymentsTestUtil.createPayments(3);
		ToDateTaxPayments todate = TaxPaymentsMapper.mapPaymentEntityToTaxPaymentsDto(payments);
		
		Assert.assertNotNull(todate, "ToDateTaxPayments should not be null");
		Assert.assertEquals(todate.getTaxPayments().length, payments.length,
			"# of Payment objects and # of retrieved objects different");
		
		Date start = todate.getTaxPaymentsStartDate();
		Date end   = todate.getTaxPaymentsEndDate();
		DateRange dr = new DateRange(start, end);
		DateRange range = payments[0].getPayrollPeriod();
		boolean eq = DateRangeMapper.areDateRangesIdentical(dr, range);
		Assert.assertEquals(eq, true, "Payroll Periods do not match");
	}
}
