package com.intuit.sb.payroll.entity;


/**
 * This interface defines the set of synchronous and asynchronous methods should be invoked
 * when an entity in interest is created, updated or deleted.
 * This interface should be used to implement set of external or internal changes that should
 * happen when a Payroll Entity is updated
 *
 */
public interface EntityActivity<E> {
	public void entityCreationSync(E entity);
	public void entityCreationAsync(E entity);
	
	public void entityDeleteSync();
	public void entityDeleteAsync();
	
	public void entityUpdateSync(E entity);
	public void entityUpdateAsync(E entity);
}

