package com.intuit.sb.payroll.entity;

/**
 * Contains the names of the named queries in the orm.xml as well as the parameter names.
 *
 * $Author$ 
 * $Revision$
 * $DateTime$
 */
@SuppressWarnings("nls")
public interface NamedQueryCatalog {
	
	/*
	 * Common
	 */
	public static final String START_DATE_QUERY_PARAM = "startDate";
	public static final String END_DATE_QUERY_PARAM = "endDate";
	public static final String YEAR = "year";
	
	/*
	 * Agency
	 */
	public static final String AGENCY_KEY_QUERY_PARAM = "agencyKey";
	public static final String FIND_AGENCY_BY_KEY = "findAgencyByKey";
		
	/*
	 * Compensation
	 */
	public static final String COMPENSATION_DTL_QUERY_PARAM = "compensationDtl";
	public static final String FIND_LINKED_COMPENSATION_DTLS = "findLinkedCompensationDtls";
	
	public static final String COMPENSATION_TYPE_QUERY_PARAM = "compensationType";
	public static final String FIND_COMPENSATION_BY_TYPE = "findCompensationByType";
	
	/*
	 * Deductions
	 */
	public static final String DEDUCTION_TYPE_QUERY_PARAM = "deductionType";
	public static final String FIND_DEDUCTION_BY_TYPE = "findDeductionByType";
	
	/*
	 * PaidTimeOff
	 */
	public static final String FIND_PAID_TIME_OFF_BY_TYPE = "findPaidTimeOffByType";
	public static final String PAID_TIME_OFF_TYPE_QUERY_PARAM = "paidTimeOffType";
	
	/*
	 * HealthBenefits
	 */
	public static final String FIND_HEALTH_BENEFIT_BY_TYPE = "findHealthBenefitByType";
	public static final String BENEFIT_TYPE_QUERY_PARAM = "benefitType";
	

	/*
	 * Laws
	 */
	public static final String LAW_ID_QUERY_PARAM = "lawId";
	public static final String FIND_LAW_BY_LAW_ID = "findLawByLawId";
	
	/*
	 * Worker
	 */
	public static final String FIND_WORKERS_NOT_READY_FOR_PAYROLL = "findWorkersNotReadyForPayroll";
	public static final String FIND_WORKERS_READY_FOR_PAYROLL = "findWorkersReadyForPayroll";
	public static final String FIND_WORKERS_BY_WORK_LOCATION = "findWorkersByWorkLocation";
	public static final String WORK_LOCATION_ID_QUERY_PARAM = "workLocationId";
	public static final String FIND_ACTIVE_WORKERS = "findActiveWorkers";
	public static final String FIND_INACTIVE_WORKERS = "findInactiveWorkers";
	

	/*
	 * WorkerPayments
	 */
	public static final String PAYROLL_RUN_TYPE_PARAM = "payrollRunType";
	public static final String FIND_RECENT_PAYROLLRUNS = "findRecentPayrollRuns";
	public static final String FIND_RECENT_PAYROLLRUNS_FOR_YEAR = "findRecentPayrollRunsForYear";

	
	/*
	 * PayrollRun
	 */
	public static final String FIND_PAYROLLRUNS_FROM_DATE = "findPayrollRunsFromDate";
	public static final String FIND_LAST_COMPLETED_PAYROLLRUN = "findLastCompletedPayrollRun";
	public static final String FIND_ALL_PAYROLLRUNS_DESC = "findAllPayrollRunsDescending";

	/*
	 * EmployerAdjustment
	 */
	public static final String FIND_EMPLOYER_ADJUSTMENTS_IN_RANGE = "findEmployerAdjustmentsInRange";
}
