package com.intuit.sb.payroll.entity.employer;

import java.util.List;

import javax.ejb.Local;

import com.intuit.sb.payroll.entity.eao.GenericEAO;
import com.intuit.sb.payroll.entity.model.DateRange;
import com.intuit.sb.payroll.entity.model.EmployerAdjustment;

@Local
public interface EmployerAdjustmentEAO extends GenericEAO<EmployerAdjustment> {

	@SuppressWarnings("nls")
	public static final String JNDI_NAME =  "EmployerAdjustmentEAO/local";

	/**
	 * Queries for the adjustements in a given date range.
	 * 
	 * @param dateRange
	 * @return
	 */
	public List<EmployerAdjustment> findEmployerAdjustmentsInRange(DateRange dateRange);
}
