package com.intuit.sb.payroll.entity.employer.impl;

import java.util.List;

import javax.annotation.security.RolesAllowed;
import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;

import org.jboss.annotation.security.SecurityDomain;

import com.intuit.sb.payroll.entity.eao.ejb.GenericEjbEAO;
import com.intuit.sb.payroll.entity.employer.EmployerEAO;
import com.intuit.sb.payroll.entity.model.Employer;

@Stateless(name = "EmployerEAO")
@TransactionManagement(TransactionManagementType.CONTAINER)
// Use CMT
// Clients must start the Txn so multiple EAO calls in a single request are within a single txn
@TransactionAttribute(TransactionAttributeType.MANDATORY)
@SecurityDomain("BHPIAM")
@RolesAllowed( { "Authenticated" })
public final class EmployerEjbEAO extends GenericEjbEAO<Employer> implements EmployerEAO {

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.intuit.sb.payroll.entity.employer.EmployerEAO#findCurrentEmployer()
	 */
	public Employer findCurrentEmployer() {
		// Check the database if there are any employers using the EAOs
		List<Employer> employerList = findAll();

		// If there are no employers in the DB return nothing
		if (employerList == null || employerList.size() == 0) {
			return null;
		}
		// If there are(is) any employer(s) return it. We are dealing only with 1 Employer
		return employerList.get(0);
	}
}
