package com.intuit.sb.payroll.entity.employer.impl;

import java.util.List;

import javax.annotation.security.RolesAllowed;
import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;
import javax.persistence.Query;

import org.jboss.annotation.security.SecurityDomain;

import com.intuit.sb.payroll.entity.eao.ejb.GenericEjbEAO;
import com.intuit.sb.payroll.entity.employer.WorkLocationEAO;
import com.intuit.sb.payroll.entity.model.WorkLocation;

@Stateless(name = "WorkLocationEAO")
@TransactionManagement(TransactionManagementType.CONTAINER)
// Use CMT
@SecurityDomain("BHPIAM")
@RolesAllowed( { "Authenticated" })
// Clients must start the Txn so multiple EAO calls in a single request are within a single txn
@TransactionAttribute(TransactionAttributeType.MANDATORY)
public final class WorkLocationEjbEAO extends GenericEjbEAO<WorkLocation> implements WorkLocationEAO {

	@SuppressWarnings("unchecked")
	public int getWorkLocationCount() {
		String queryString = "SELECT COUNT(wl) " + "FROM com.intuit.sb.payroll.entity.model.WorkLocation wl ";

		Query query = this.getEntityManager().createQuery(queryString);

		List resultList = query.getResultList();
		for (Object object : resultList) {
			Long count = (Long) object;
			return count.intValue();
		}
		return 0;
	}

	@SuppressWarnings("unchecked")
	public int getWorkerCountForWorkLocation(WorkLocation workLocation) {
		String queryString = "SELECT COUNT(w) " + "FROM com.intuit.sb.payroll.entity.model.Worker w "
				+ "WHERE w.workLocation = ?1";

		Query query = this.getEntityManager().createQuery(queryString);
		query.setParameter(1, workLocation);

		List resultList = query.getResultList();
		for (Object object : resultList) {
			Long count = (Long) object;
			return count.intValue();
		}
		return 0;
	}

}
