package com.intuit.sb.payroll.entity.taxauthority.impl;

import java.util.List;
import java.util.Set;

import javax.annotation.security.RolesAllowed;
import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;

import org.jboss.annotation.security.SecurityDomain;

import com.intuit.sb.payroll.entity.eao.ejb.GenericEjbEAO;
import com.intuit.sb.payroll.entity.model.Jurisdiction;
import com.intuit.sb.payroll.entity.model.Law;
import com.intuit.sb.payroll.entity.taxauthority.JurisdictionEAO;

@Stateless(name = "JurisdictionEAO")
@TransactionManagement(TransactionManagementType.CONTAINER)
// Use CMT
// Clients must start the Txn so multiple EAO calls in a single request are within a single txn
@TransactionAttribute(TransactionAttributeType.MANDATORY)
@SecurityDomain("BHPIAM")
@RolesAllowed( { "Authenticated" })
public final class JurisdictionEjbEAO extends GenericEjbEAO<Jurisdiction> implements JurisdictionEAO {

	public Jurisdiction findJurisdictionForLawId(String lawId) {
		if (lawId == null) {
			return null;
		}

		// FIXME: try a multi entity query instead of this.
		List<Jurisdiction> jurisdictioList = findAll();
		for (Jurisdiction jurisdiction : jurisdictioList) {
			Set<Law> lawSet = jurisdiction.getLaws();
			for (Law law : lawSet) {
				if (lawId.equals(law.getLawId())) {
					return jurisdiction;
				}
			}
		}

		return null;
	}
}
