package com.intuit.sb.payroll.entity.taxes.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.security.RolesAllowed;
import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;

import org.jboss.annotation.security.SecurityDomain;

import com.intuit.sb.payroll.entity.eao.ejb.GenericEjbEAO;
import com.intuit.sb.payroll.entity.model.AgencyEnum;
import com.intuit.sb.payroll.entity.model.AgencyIdType;
import com.intuit.sb.payroll.entity.taxes.AgencyIdTypeEAO;

@Stateless(name="AgencyIdTypeEAO")
@TransactionManagement(TransactionManagementType.CONTAINER) // Use CMT
// Clients must start the Txn so multiple EAO calls in a single request are within a single txn
@TransactionAttribute(TransactionAttributeType.MANDATORY)
@SecurityDomain("BHPIAM")
@RolesAllowed({"Authenticated"})
public class AgencyIdTypeEjbEAO extends GenericEjbEAO<AgencyIdType> implements AgencyIdTypeEAO
{

	public List<AgencyIdType> findAgenciesByKey(AgencyEnum agencyKey)
	{
		Map<String, Object> queryParameters = new HashMap<String, Object>();
		queryParameters.put("agencyKey", agencyKey);
		List<AgencyIdType> agenyIdList = null;
		try
		{
			agenyIdList = findByNamedQuery("findAgenciesByKey", queryParameters);
		}
		catch (RuntimeException re)
		{
		}

		return agenyIdList;
	}

}
