package com.intuit.sb.payroll.entity.taxes.withholding;

import javax.ejb.Local;

import com.intuit.sb.payroll.entity.eao.GenericEAO;
import com.intuit.sb.payroll.entity.model.UnemploymentInsDocDtl;

/**
 * EAO operations for {@link UnemploymentInsDocDtl UnemploymentInsDocDtl} entities.
 * This class isolates all persistence concerns for UnemploymentInsDocDtl entities from
 * business logic. It provides all the CRUD operations on {@code UnemploymentInsDocDtl}
 * and its related entities.
 * 
 * $Author: jzhong $
 * $Revision: #1 $
 * $DateTime: 2008/08/15 17:27:47 $
 *
 */
@Local
public interface UnemploymentInsDtlEAO extends GenericEAO<UnemploymentInsDocDtl> {

	public static final String JNDI_NAME =  "UnemploymentInsDtlEAO/local";
	
	/**
	 * returns the one and only UnemploymentInsDocDtl corresponding to the lawId
	 * @param lawId
	 * @return
	 */
	public UnemploymentInsDocDtl getUnemploymentInsDtl(String lawId);
	
}
