package com.intuit.sb.payroll.entity.taxes.withholding.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.security.RolesAllowed;
import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;

import org.jboss.annotation.security.SecurityDomain;

import com.intuit.sb.payroll.entity.eao.ejb.GenericEjbEAO;
import com.intuit.sb.payroll.entity.model.ComplianceDoc;
import com.intuit.sb.payroll.entity.model.ComplianceDocIdEnum;
import com.intuit.sb.payroll.entity.taxes.withholding.ComplianceDocEAO;

@Stateless(name="ComplianceDocEAO")
@TransactionManagement(TransactionManagementType.CONTAINER) // Use CMT
// Clients must start the Txn so multiple EAO calls in a single request are within a single txn
@TransactionAttribute(TransactionAttributeType.MANDATORY) 
@SecurityDomain("BHPIAM")
@RolesAllowed({"Authenticated"})
public final class ComplianceDocEjbEAO extends GenericEjbEAO<ComplianceDoc>
	implements ComplianceDocEAO {

    public ComplianceDoc findComplianceDocByDocId(ComplianceDocIdEnum docId)
    {
        Map<String, Object> queryParameters = new HashMap<String, Object>();
        queryParameters.put("docId", docId);
        
        List<ComplianceDoc> results = null;
        try
        {
            // named query is in orm.xml
            results = findByNamedQuery("findComplianceDocByDocId", queryParameters);
        }
        catch(RuntimeException ex) {
            handleExceptionMightBeOLE(ex);
        }
        if (results == null)
        {
            return null;
        }
        switch (results.size())
        {
            case 0:
                return null;
            case 1:
                return results.get(0);
            default:
                throw new IllegalStateException("Found multiple ComplianceDoc's with docId '" + docId);
        }
    }
}
