package com.intuit.sb.payroll.entity.taxes.withholding.impl;

import java.util.List;

import javax.annotation.security.RolesAllowed;
import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;
import javax.persistence.Query;

import org.jboss.annotation.security.SecurityDomain;

import com.intuit.sb.payroll.entity.eao.ejb.GenericEjbEAO;
import com.intuit.sb.payroll.entity.model.UnemploymentInsDocDtl;
import com.intuit.sb.payroll.entity.taxes.withholding.UnemploymentInsDtlEAO;

/**
 * The EJB3 implementation of the {@link UnemploymentInsDtlEAO UnemploymentInsDtlEAO} interface.
 * As required by the superclass, this concrete EAO implementation
 * is an EJB3 SSB. It publishes itself in JNDI under its interface,
 * not implementation, name.
 * 
 * $Author: oblackburn $
 * $Revision: #2 $
 * $DateTime: 2008/08/19 11:31:02 $
 *
 */
@Stateless(name="UnemploymentInsDtlEAO")
@TransactionManagement(TransactionManagementType.CONTAINER) // Use CMT
// Clients must start the Txn so multiple EAO calls in a single request are within a single txn
@TransactionAttribute(TransactionAttributeType.MANDATORY) 
@SecurityDomain("BHPIAM")
@RolesAllowed({"Authenticated"})
public final class UnemploymentInsDtlEjbEAO extends GenericEjbEAO<UnemploymentInsDocDtl>
	implements UnemploymentInsDtlEAO {

	@SuppressWarnings("unchecked")
	public UnemploymentInsDocDtl getUnemploymentInsDtl(String lawId) 
	{
		String queryString = "SELECT * " +
							"FROM com.intuit.sb.payroll.entity.model.UnemploymentInsDocDtl ui " +
							"WHERE ui.lawId = ?1";
		
		Query query = this.getEntityManager().createQuery(queryString);
		query.setParameter(1, lawId);
		
		List resultList = query.getResultList();
		if(resultList == null || resultList.size() == 0)
		{
			return null;
		}
		else //there should not be case where we have more than one SUI returned for this query
		{
			return (UnemploymentInsDocDtl)resultList.get(0);
		}
	}

}
