package com.intuit.sb.payroll.entity.wages;

import javax.ejb.Local;

import com.intuit.sb.payroll.entity.eao.GenericEAO;
import com.intuit.sb.payroll.entity.model.Compensation;
import com.intuit.sb.payroll.entity.model.CompensationTypeEnum;

@Local
public interface CompensationEAO extends GenericEAO<Compensation> {
	
	public static final String JNDI_NAME =  "CompensationEAO/local";

	/**
	 * Find a Compensation by its Id.
	 * @param uniqueId the PK of the entity.
	 * @return the compensation entity.
	 * @throws PayrollException if the Compensation doesn't exist.
	 */
	public Compensation findCompensation(Long uniqueId);
	/**
	 * Find a Compensation of a specific compensation type.
	 * @param compensationType the type of the compensation to find.
	 * @return the compensation entity.
	 */
	public Compensation findCompensation(CompensationTypeEnum compensationType);
}
