package com.intuit.sb.payroll.entity.wages.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.security.RolesAllowed;
import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;

import org.jboss.annotation.security.SecurityDomain;

import com.intuit.sb.payroll.entity.NamedQueryCatalog;
import com.intuit.sb.payroll.entity.eao.ejb.GenericEjbEAO;
import com.intuit.sb.payroll.entity.model.CompensationDtl;
import com.intuit.sb.payroll.entity.wages.CompensationDtlEAO;

@Stateless(name="CompensationDtlEAO")
@TransactionManagement(TransactionManagementType.CONTAINER) // Use CMT
// Clients must start the Txn so multiple EAO calls in a single request are within a single txn
@TransactionAttribute(TransactionAttributeType.MANDATORY) 
@SecurityDomain("BHPIAM")
@RolesAllowed({"Authenticated"})
public final class CompensationDtlEjbEAO extends GenericEjbEAO<CompensationDtl>
	implements CompensationDtlEAO {

	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.entity.wages.CompensationDtlEAO#findLinkedCompensationDtls(com.intuit.sb.payroll.entity.model.CompensationDtl)
	 */
	public List<CompensationDtl> findLinkedCompensationDtls(CompensationDtl compensationDtl) {		
        Map<String, Object> queryParameters = new HashMap<String, Object>();
        queryParameters.put(NamedQueryCatalog.COMPENSATION_DTL_QUERY_PARAM, compensationDtl);
        List<CompensationDtl> results = null;
       
		try	{
			// named query is in orm.xml
			results = this.findByNamedQuery(NamedQueryCatalog.FIND_LINKED_COMPENSATION_DTLS, queryParameters);
		} catch(RuntimeException ex) {
			handleExceptionMightBeOLE(ex);
		}
        return results; 		
	}

}
