package com.intuit.sb.payroll.entity.workerpayments.impl;

import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.annotation.Resource;
import javax.annotation.security.RolesAllowed;
import javax.ejb.SessionContext;
import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

import org.jboss.annotation.security.SecurityDomain;

import com.intuit.sb.payroll.InfrastructureException;
import com.intuit.sb.payroll.entity.model.DateRange;
import com.intuit.sb.payroll.entity.model.Worker;
import com.intuit.sb.payroll.entity.workerpayments.WorkerPaymentsDataService;
import com.intuit.sb.payroll.entity.workerpayments.WorkerTotals;

/**
 * Implementation of the WorkerPaymentsDataService.
 * 
 * $Author$ $Revision$ $DateTime$
 * 
 */
@Stateless(name = "WorkerPaymentsDataService")
@TransactionAttribute(TransactionAttributeType.MANDATORY)
@SecurityDomain("BHPIAM")
@RolesAllowed( { "Authenticated" })
public class WorkerPaymentsDataServiceBean implements WorkerPaymentsDataService {

	@Resource
	// Inject the EJB session bean context
	private SessionContext mEJBSessionContext;

	// Inject an entity manager instance for our data source
	@PersistenceContext(unitName = "payrollDB")
	private EntityManager mEntityManager;

	public Worker updatePtdsForWorker(Worker worker, DateRange period) {
		
		//FIXME [AS] here's the pseudo-code
		/* 
		 * //Run the magic query to get the totals
		 * //each totals instance will have the WB, ISTT and TotalAmt for each Pay item dtl, for each Qtr in the range
		 * List<PayrollItemTotals> totalsForWorker = getTotalsForWorkerForPeriod(worker, period);
		 * 
		 * //Create a map to find totals quickly by PayrollItemDtl PK.
		 * Map<long, PayrollItemTotals> idToTotalMap = new HashMap<long, PayrollItemTotals>();
		 * for (PayrollItemTotals totals : totalsForWorker) {
		 * 	
		 * 		idtoTotalMap.put(totals.getPayrollItemDtlId(), totals);
		 * }
		 *	
		 * //Now iterate through the worker's PayrollItemDtls, and map the totals into the right slots.
		 * for (PayrollItemDtl detail : worker.getPayrollItemDtls()) {
		 * 		PayrollItemTotals totals = idToTotalMap.get(detail.getId());
		 * 		//Put all the totals in the right Qtr slots etc...
		 * }
		 * 
		 */
		
		return worker;
	}
	
	public Set<WorkerTotals> getEmployeeTotalsForCompany() {
		return null;
	}
	
	
	/***FIXME Stealing methods from GenericEJBEAO for now, we'll factor out common later into base class    ***/

	protected List<?> findByQuery(String queryString) {
		return findByQuery(queryString, Collections.<String, Object>emptyMap());
	}

	private List<?> findByQuery(String queryString, Map<String, Object> parameters) {
		Query query = mEntityManager.createQuery(queryString);
		return findByQuery(query, parameters);
	}

	public List<?> findByNamedQuery(String queryName) {
		return findByNamedQuery(queryName, Collections.<String, Object>emptyMap());
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.intuit.sb.payroll.component.dao.IGenericEAO#findByNamedQuery(java.lang.String, java.util.Map)
	 */
	public List<?> findByNamedQuery(String queryName, Map<String, Object> parameters) {
		Query query = mEntityManager.createNamedQuery(queryName);
		return findByQuery(query, parameters);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.intuit.sb.payroll.entity.eao.GenericEAO#findByNamedQuery(java.lang.String, java.util.Map, int, int)
	 */
	public List<?> findByNamedQuery(String queryName, Map<String, Object> parameters, int firstResult, int maxResults) {
		Query query = mEntityManager.createNamedQuery(queryName);
		query.setFirstResult(firstResult);
		query.setMaxResults(maxResults);
		return findByQuery(query, parameters);
	}

	private List<?> findByQuery(Query query, Map<String, Object> parameters) {
		List<?> result = null;
		try {
			for (String parameterName : parameters.keySet()) {
				query.setParameter(parameterName, parameters.get(parameterName));
			}
			result = query.getResultList();
		} catch (Exception ex) {
			throw new InfrastructureException(ex);
		}
		return result;
	}

}
