package com.intuit.sb.payroll.pts.entity;

import java.util.List;

import com.intuit.sb.payroll.entity.domain.Identifiable;
import com.intuit.sb.payroll.entity.eao.ejb.GenericEjbEAO;

public abstract class GenericStateEjbEAO<E extends Identifiable>  extends GenericEjbEAO<E>{
	
	private String mFindAllStateQueryStringDescending;
	private String mFindAllActiveStateQueryStringDescending;
	
	
	protected GenericStateEjbEAO()
    {
    	super();
    	String fqn = getEntityClass().getName();
    	int lastDot = fqn.lastIndexOf('.');
    	String basename = fqn.substring(lastDot == 0 ? 0 : lastDot + 1);
    	mFindAllStateQueryStringDescending = "Select " + basename + " from " + fqn + " as " + basename 
    	  + " order by " +  basename+".statusDate DESC";
    	
    	mFindAllActiveStateQueryStringDescending = "Select " + basename + " from " + fqn + " as " + basename 
  	      + " where " + basename+".active = true "      
  	      + "order by " +  basename+".statusDate DESC";
    	
    }
	
	/**
	 * Return the list of Notification rcvd in descending order based on the status date
	 * @return
	 */
	public List<E> findAllInSortedOrder(){
		return findByQuery(mFindAllStateQueryStringDescending);
	}
	
	public E getMostRecentState(){
		List<E> lists = findAllInSortedOrder();
		if (lists.size() > 0){
			return lists.get(0);
		}
		return null;
		
	}
	
	public List<E> findAllActiveInSortedOrder(){
		return findByQuery(mFindAllActiveStateQueryStringDescending);
	}
	
	public E getMostRecentActiveState(){
		List<E> lists = findAllActiveInSortedOrder();
		if (lists.size() > 0){
			return lists.get(0);
		}
		return null;
		
	}
	
	
	
}
