/**
 * 
 */
package com.intuit.sb.payroll.pts.entity.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.security.RolesAllowed;
import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;

import org.jboss.annotation.security.SecurityDomain;

import com.intuit.sb.payroll.pts.entity.GenericStateEjbEAO;
import com.intuit.sb.payroll.pts.entity.PPSPTSInteraction;
import com.intuit.sb.payroll.pts.entity.PPSPTSInteractionEAO;

/**
 * @author amalik
 *
 */

@Stateless(name = "PPSPTSInteractionEAO")
@TransactionManagement(TransactionManagementType.CONTAINER)
@TransactionAttribute(TransactionAttributeType.MANDATORY)
@SecurityDomain("BHPIAM")
@RolesAllowed( { "Authenticated" })
public class PPSPTSInteractionEjbEAO extends GenericStateEjbEAO<PPSPTSInteraction> implements PPSPTSInteractionEAO {
	
	public List<PPSPTSInteraction> findAll(String name, Long identifier){
		Map<String, Object> queryParameters = new HashMap<String, Object>();
        queryParameters.put("entity", name);
        queryParameters.put("identifier", identifier);
        
        List<PPSPTSInteraction> results = null;
		try
		{
			// named query is in orm.xml
			results = findByNamedQuery("findPPSPTSInteractionByNameAndIdentifier", queryParameters);
		}
		catch(RuntimeException ex)
		{
			handleExceptionMightBeOLE(ex);
		}     
		return results;
	}
}
