
    
    --
    -- VPD Twin-schema deployment - "&&1" schema
    -- 
    
	--
    -- Generated using Intuit's Oracle VPD DDL Xpand template
    --
    -- Create sequences
    
DECLARE 
	SEQUENCE_EXISTS PLS_INTEGER :=0;
BEGIN
	SELECT COUNT(*) INTO SEQUENCE_EXISTS
	FROM USER_SEQUENCES
	WHERE SEQUENCE_NAME = 'HIBERNATE_SEQUENCE';
	IF SEQUENCE_EXISTS = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE "HIBERNATE_SEQUENCE" MINVALUE 0 MAXVALUE 999999999999999999999999999 INCREMENT BY 1 START WITH 21 CACHE 20 NOORDER NOCYCLE';
	END IF;
END;
/

    -- Create tables 
    
    
    
	CREATE TABLE PTSEMPLOYER (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		EMPLOYER NUMBER(20,0) NULL
,UNIQUE(EMPLOYER),
		PTSWORKFLOWSTATE NUMBER(20,0) NOT NULL
,UNIQUE(PTSWORKFLOWSTATE)	)
/
    
    CREATE INDEX "PTSEMPLOYER_RX" ON PTSEMPLOYER (REALM_ID ASC)
/	



	CREATE TABLE EFTPSENROLLMENTSTATE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		EFTPSENROLLMENTSTATUS VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		STATUSDATE TIMESTAMP NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		TAXSERVICESTATE NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "EFTPSENROLLMENTSTATE_RX" ON EFTPSENROLLMENTSTATE (REALM_ID ASC)
/	
    CREATE INDEX "EFTPSENRST_FK_PTSASSISTEDST" ON EFTPSENROLLMENTSTATE (TAXSERVICESTATE ASC)
/	



	CREATE TABLE BANKACCOUNTSTATE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		STATUS VARCHAR2(100) NULL,
		STATUSDATE TIMESTAMP NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		BANKACCOUNT NUMBER(20,0) NOT NULL
,UNIQUE(BANKACCOUNT),
		PTSEMPLOYER NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "BANKACCOUNTSTATE_RX" ON BANKACCOUNTSTATE (REALM_ID ASC)
/	
    CREATE INDEX "PTSEMP_FK_BANKACTSTATE" ON BANKACCOUNTSTATE (PTSEMPLOYER ASC)
/	



	CREATE TABLE TAKEHOMEWORKER (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		PAYROLLWORKERID NUMBER(20,0) NULL,
		AVATAR VARCHAR2(100) NULL,
		WORKERIMAGE BLOB NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL	)
/
    
    CREATE INDEX "TAKEHOMEWORKER_RX" ON TAKEHOMEWORKER (REALM_ID ASC)
/	



	CREATE TABLE PTSCONTACTPERSON (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		CONTACTPERSONTYPE VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		PAYROLLEMPLOYERCONTACTPERSONID NUMBER(20,0) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		EMPLOYERCONTACT NUMBER(20,0) NOT NULL
,UNIQUE(EMPLOYERCONTACT),
		PTSEMPLOYER NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "PTSCONTACTPERSON_RX" ON PTSCONTACTPERSON (REALM_ID ASC)
/	
    CREATE INDEX "PTSEMP_FK_PTSCONTACT" ON PTSCONTACTPERSON (PTSEMPLOYER ASC)
/	



	CREATE TABLE PTSWORKFLOWSTATE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		TAXSERVICESTATE NUMBER(20,0) NULL
,UNIQUE(TAXSERVICESTATE)	)
/
    
    CREATE INDEX "PTSWORKFLOWSTATE_RX" ON PTSWORKFLOWSTATE (REALM_ID ASC)
/	



	CREATE TABLE ACHENROLLMENTSTATE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		ACHENROLLMENTSTATUS VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		STATUSDATE TIMESTAMP NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		TAXSERVICESTATE NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "ACHENROLLMENTSTATE_RX" ON ACHENROLLMENTSTATE (REALM_ID ASC)
/	
    CREATE INDEX "ACHSTATE_FK_PTSASSISTEDST" ON ACHENROLLMENTSTATE (TAXSERVICESTATE ASC)
/	



	CREATE TABLE TAKEHOMECOMPANY (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		PAYROLLEMPLOYERID NUMBER(20,0) NULL,
		PRINTPREFERENCES_XALIGNMENT NUMBER(10,0) NULL,
		PRINTPREFERENCES_YALIGNMENT NUMBER(10,0) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL	)
/
    
    CREATE INDEX "TAKEHOMECOMPANY_RX" ON TAKEHOMECOMPANY (REALM_ID ASC)
/	



	CREATE TABLE EMPPTSSTATE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		STATUSDATE TIMESTAMP NULL,
		EMPLOYEEID NUMBER(20,0) NULL,
		PTSSTATE VARCHAR2(100) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		TAXSERVICESTATE NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "EMPPTSSTATE_RX" ON EMPPTSSTATE (REALM_ID ASC)
/	
    CREATE INDEX "EMPPTSSTATE_FK_TAXSERVICESTATE" ON EMPPTSSTATE (TAXSERVICESTATE ASC)
/	



	CREATE TABLE RAAENROLLMENTSTATE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		RAAENROLLMENTSTATUS VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		STATUSDATE TIMESTAMP NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		TAXSERVICESTATE NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "RAAENROLLMENTSTATE_RX" ON RAAENROLLMENTSTATE (REALM_ID ASC)
/	
    CREATE INDEX "RAASTATE_FK_PTSASSISTEDST" ON RAAENROLLMENTSTATE (TAXSERVICESTATE ASC)
/	



	CREATE TABLE ACTIVATIONSTATE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		AGENCY VARCHAR2(100) NULL,
		ACTIVATIONSTATUS VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		STATUSDATE TIMESTAMP NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		TAXSERVICESTATE NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "ACTIVATIONSTATE_RX" ON ACTIVATIONSTATE (REALM_ID ASC)
/	
    CREATE INDEX "TAXSVCSTATE_FK_ACTIVSTATE" ON ACTIVATIONSTATE (TAXSERVICESTATE ASC)
/	



	CREATE TABLE TAXSERVICESTATE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL	)
/
    
    CREATE INDEX "TAXSERVICESTATE_RX" ON TAXSERVICESTATE (REALM_ID ASC)
/	



	CREATE TABLE RAFENROLLMENTSTATE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		RAFENROLLMENTSTATUS VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		STATUSDATE TIMESTAMP NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		TAXSERVICESTATE NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "RAFENROLLMENTSTATE_RX" ON RAFENROLLMENTSTATE (REALM_ID ASC)
/	
    CREATE INDEX "RAFSTATE_FK_PTSASSISTEDST" ON RAFENROLLMENTSTATE (TAXSERVICESTATE ASC)
/	



	CREATE TABLE PTSMESSAGE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		MESSAGECODE VARCHAR2(100) NULL,
		MESSAGEDESCRIPTION VARCHAR2(100) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		RAAENROLLMENTSTATE NUMBER(20,0) NULL,
		BANKACCOUNTSTATE NUMBER(20,0) NULL,
		RAFENROLLMENTSTATE NUMBER(20,0) NULL,
		ACTIVATIONSTATE NUMBER(20,0) NULL,
		ACHENROLLMENTSTATE NUMBER(20,0) NULL,
		EFTPSENROLLMENTSTATE NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "PTSMESSAGE_RX" ON PTSMESSAGE (REALM_ID ASC)
/	
    CREATE INDEX "RAASTATE_FK_PTSMESSAGE" ON PTSMESSAGE (RAAENROLLMENTSTATE ASC)
/	
    CREATE INDEX "PTSMESSAGE_FK_RAFSTATE" ON PTSMESSAGE (RAFENROLLMENTSTATE ASC)
/	
    CREATE INDEX "PTSMESSAGE_FK_ACTIVATIONSTATE" ON PTSMESSAGE (ACTIVATIONSTATE ASC)
/	
    CREATE INDEX "PTSMESSAGE_FK_EFTPSSTATE" ON PTSMESSAGE (EFTPSENROLLMENTSTATE ASC)
/	
    CREATE INDEX "PTSMESSAGE_FK_BANKACCSTATE" ON PTSMESSAGE (BANKACCOUNTSTATE ASC)
/	
    CREATE INDEX "PTSMESSAGE_FK_ACHSTATE" ON PTSMESSAGE (ACHENROLLMENTSTATE ASC)
/	


    

    
	ALTER TABLE EMPLOYERADJUSTMENT ADD (
		USPAYROLLRUN NUMBER(20,0) NULL		)
	/

	ALTER TABLE WORKERCOMPLIANCEDOCDTL ADD (
		DE4ISINCOMETAXEMEMPT CHAR(1) NULL	,
		DE4NOOFALLOWANCES NUMBER(10,0) NULL	,
		DE4NOOFDEDUCTIONS NUMBER(10,0) NULL	,
		DE4ADDTLAMOUNT_CUR VARCHAR2(100) NULL	,
		DE4ADDTLAMOUNT_AMT NUMBER(19,4) NULL	,
		DE4WITHHOLDINGSTATUS VARCHAR2(100)  DEFAULT 'NOTSET' NULL	,
		ISBACKUPWITHHOLDINGEXEMPT CHAR(1) NULL	,
		PERCENTAGERATE_CUR VARCHAR2(100) NULL	,
		PERCENTAGERATE_AMT NUMBER(19,4) NULL	,
		W4ISINCOMETAXEMEMPT CHAR(1) NULL	,
		W4NOOFALLOWANCES NUMBER(10,0) NULL	,
		W4ADDTLAMOUNT_CUR VARCHAR2(100) NULL	,
		W4ADDTLAMOUNT_AMT NUMBER(19,4) NULL	,
		W4WITHHOLDINGSTATUS VARCHAR2(100)  DEFAULT 'NOTSET' NULL	,
		VALUE VARCHAR2(100) NULL		)
	/





    
    
ALTER TABLE EMPLOYERADJUSTMENT 
	ADD CONSTRAINT USEMPADJ_FK_USPRUN 
	FOREIGN KEY (USPAYROLLRUN) 
	REFERENCES PAYROLLRUN (ID)
/

    
    
    
    
    
    
    
    
    
    
    
    -- Functions
    
    
    




ALTER TABLE PTSEMPLOYER 
	ADD CONSTRAINT PTSEMPLOYER_FK_EMPLOYER 
	FOREIGN KEY (EMPLOYER) 
	REFERENCES EMPLOYER (ID)
/

ALTER TABLE PTSEMPLOYER 
	ADD CONSTRAINT PTSWFSTATE_FK_PTSEMP 
	FOREIGN KEY (PTSWORKFLOWSTATE) 
	REFERENCES PTSWORKFLOWSTATE (ID)
/

    
    CREATE or REPLACE TRIGGER "PTSEMPLOYER_VT" 
    BEFORE INSERT OR UPDATE ON "PTSEMPLOYER" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE EFTPSENROLLMENTSTATE 
	ADD CONSTRAINT EFTPSENRST_FK_PTSASSISTEDST 
	FOREIGN KEY (TAXSERVICESTATE) 
	REFERENCES TAXSERVICESTATE (ID)
/

    
    CREATE or REPLACE TRIGGER "EFTPSENROLLMENTSTATE_VT" 
    BEFORE INSERT OR UPDATE ON "EFTPSENROLLMENTSTATE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    


ALTER TABLE BANKACCOUNTSTATE 
	ADD CONSTRAINT BANKACT_FK_PTSBANKSTATE 
	FOREIGN KEY (BANKACCOUNT) 
	REFERENCES BANKACCOUNT (ID)
/

ALTER TABLE BANKACCOUNTSTATE 
	ADD CONSTRAINT PTSEMP_FK_BANKACTSTATE 
	FOREIGN KEY (PTSEMPLOYER) 
	REFERENCES PTSEMPLOYER (ID)
/

    
    CREATE or REPLACE TRIGGER "BANKACCOUNTSTATE_VT" 
    BEFORE INSERT OR UPDATE ON "BANKACCOUNTSTATE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "TAKEHOMEWORKER_VT" 
    BEFORE INSERT OR UPDATE ON "TAKEHOMEWORKER" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    


ALTER TABLE PTSCONTACTPERSON 
	ADD CONSTRAINT PTSEMP_FK_PTSCONTACT 
	FOREIGN KEY (PTSEMPLOYER) 
	REFERENCES PTSEMPLOYER (ID)
/

ALTER TABLE PTSCONTACTPERSON 
	ADD CONSTRAINT PTSCONTACT_FK_EMPCONTACT 
	FOREIGN KEY (EMPLOYERCONTACT) 
	REFERENCES CONTACTPERSON (ID)
/

    
    CREATE or REPLACE TRIGGER "PTSCONTACTPERSON_VT" 
    BEFORE INSERT OR UPDATE ON "PTSCONTACTPERSON" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    


ALTER TABLE PTSWORKFLOWSTATE 
	ADD CONSTRAINT PTSWFSTATE_FK_PTSASSISTEDSTATE 
	FOREIGN KEY (TAXSERVICESTATE) 
	REFERENCES TAXSERVICESTATE (ID)
/

    
    CREATE or REPLACE TRIGGER "PTSWORKFLOWSTATE_VT" 
    BEFORE INSERT OR UPDATE ON "PTSWORKFLOWSTATE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE ACHENROLLMENTSTATE 
	ADD CONSTRAINT ACHSTATE_FK_PTSASSISTEDST 
	FOREIGN KEY (TAXSERVICESTATE) 
	REFERENCES TAXSERVICESTATE (ID)
/

    
    CREATE or REPLACE TRIGGER "ACHENROLLMENTSTATE_VT" 
    BEFORE INSERT OR UPDATE ON "ACHENROLLMENTSTATE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "TAKEHOMECOMPANY_VT" 
    BEFORE INSERT OR UPDATE ON "TAKEHOMECOMPANY" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE EMPPTSSTATE 
	ADD CONSTRAINT EMPPTSSTATE_FK_TAXSERVICESTATE 
	FOREIGN KEY (TAXSERVICESTATE) 
	REFERENCES TAXSERVICESTATE (ID)
/

    
    CREATE or REPLACE TRIGGER "EMPPTSSTATE_VT" 
    BEFORE INSERT OR UPDATE ON "EMPPTSSTATE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE RAAENROLLMENTSTATE 
	ADD CONSTRAINT RAASTATE_FK_PTSASSISTEDST 
	FOREIGN KEY (TAXSERVICESTATE) 
	REFERENCES TAXSERVICESTATE (ID)
/

    
    CREATE or REPLACE TRIGGER "RAAENROLLMENTSTATE_VT" 
    BEFORE INSERT OR UPDATE ON "RAAENROLLMENTSTATE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE ACTIVATIONSTATE 
	ADD CONSTRAINT TAXSVCSTATE_FK_ACTIVSTATE 
	FOREIGN KEY (TAXSERVICESTATE) 
	REFERENCES TAXSERVICESTATE (ID)
/

    
    CREATE or REPLACE TRIGGER "ACTIVATIONSTATE_VT" 
    BEFORE INSERT OR UPDATE ON "ACTIVATIONSTATE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "TAXSERVICESTATE_VT" 
    BEFORE INSERT OR UPDATE ON "TAXSERVICESTATE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE RAFENROLLMENTSTATE 
	ADD CONSTRAINT RAFSTATE_FK_PTSASSISTEDST 
	FOREIGN KEY (TAXSERVICESTATE) 
	REFERENCES TAXSERVICESTATE (ID)
/

    
    CREATE or REPLACE TRIGGER "RAFENROLLMENTSTATE_VT" 
    BEFORE INSERT OR UPDATE ON "RAFENROLLMENTSTATE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE PTSMESSAGE 
	ADD CONSTRAINT RAASTATE_FK_PTSMESSAGE 
	FOREIGN KEY (RAAENROLLMENTSTATE) 
	REFERENCES RAAENROLLMENTSTATE (ID)
/

ALTER TABLE PTSMESSAGE 
	ADD CONSTRAINT PTSMESSAGE_FK_RAFSTATE 
	FOREIGN KEY (RAFENROLLMENTSTATE) 
	REFERENCES RAFENROLLMENTSTATE (ID)
/

ALTER TABLE PTSMESSAGE 
	ADD CONSTRAINT PTSMESSAGE_FK_ACTIVATIONSTATE 
	FOREIGN KEY (ACTIVATIONSTATE) 
	REFERENCES ACTIVATIONSTATE (ID)
/

ALTER TABLE PTSMESSAGE 
	ADD CONSTRAINT PTSMESSAGE_FK_EFTPSSTATE 
	FOREIGN KEY (EFTPSENROLLMENTSTATE) 
	REFERENCES EFTPSENROLLMENTSTATE (ID)
/

ALTER TABLE PTSMESSAGE 
	ADD CONSTRAINT PTSMESSAGE_FK_BANKACCSTATE 
	FOREIGN KEY (BANKACCOUNTSTATE) 
	REFERENCES BANKACCOUNTSTATE (ID)
/

ALTER TABLE PTSMESSAGE 
	ADD CONSTRAINT PTSMESSAGE_FK_ACHSTATE 
	FOREIGN KEY (ACHENROLLMENTSTATE) 
	REFERENCES ACHENROLLMENTSTATE (ID)
/

    
    CREATE or REPLACE TRIGGER "PTSMESSAGE_VT" 
    BEFORE INSERT OR UPDATE ON "PTSMESSAGE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    

    -- Synonyms
    
    -- Grants
    
	GRANT SELECT, INSERT, UPDATE, DELETE ON PTSEMPLOYER TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON EFTPSENROLLMENTSTATE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON BANKACCOUNTSTATE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON TAKEHOMEWORKER TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PTSCONTACTPERSON TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PTSWORKFLOWSTATE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON ACHENROLLMENTSTATE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON TAKEHOMECOMPANY TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON EMPPTSSTATE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON RAAENROLLMENTSTATE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON ACTIVATIONSTATE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON TAXSERVICESTATE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON RAFENROLLMENTSTATE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PTSMESSAGE TO &&2
	/


	GRANT SELECT ON HIBERNATE_SEQUENCE TO &&2
	/

  
    
	--
    -- Table permissions for the VPD internal-to-external mapping table
    --
    GRANT SELECT,INSERT,UPDATE ON SBCORE_VPD_TABLE TO &&2
    /
    --
    -- Permission for VPD SEQ
    --
    GRANT SELECT ON SBCORE_VPD_SEQ TO &&2
    /
        
 

    
DECLARE
  table_exists PLS_INTEGER;
  row_exists PLS_INTEGER;

  INSERT_CMD VARCHAR2(255);
  ROWCHECK_CMD VARCHAR2(255);
  UPDATE_CMD VARCHAR2(255);

BEGIN
  SELECT COUNT(*) INTO table_exists
  FROM "USER_TABLES"
  WHERE TABLE_NAME = 'PROJECT_VERSIONS_TABLE';
  IF table_exists = 1 THEN 
  
    SELECT 'SELECT COUNT(*)  FROM PROJECT_VERSIONS_TABLE WHERE PROJECT_ID=''_FY5ioOECEd2RxJXjYkjWBw'''   
    INTO ROWCHECK_CMD
    FROM DUAL;
    EXECUTE IMMEDIATE ROWCHECK_CMD INTO row_exists;   
   
    IF row_exists = 1 THEN    
        SELECT 'UPDATE PROJECT_VERSIONS_TABLE SET MODEL_VERSION='''',SCHEMA_VERSION=''1.0.24'',TIMESTAMP=''2009-05-12 14:11:49.649'' WHERE PROJECT_ID=''_FY5ioOECEd2RxJXjYkjWBw'''
        INTO UPDATE_CMD
        FROM DUAL;
        EXECUTE IMMEDIATE UPDATE_CMD;
    ELSE
        SELECT 'INSERT INTO PROJECT_VERSIONS_TABLE (PROJECT_NAME,PROJECT_ID,MODEL_VERSION,SCHEMA_VERSION,TIMESTAMP) VALUES (''geminius'',''_FY5ioOECEd2RxJXjYkjWBw'','''',''1.0.24'',''2009-05-12 14:11:49.649'')' 
        INTO INSERT_CMD
        FROM DUAL;
        EXECUTE IMMEDIATE INSERT_CMD;
    END IF;   
  END IF;
END;
/

    