CREATE TABLE PTSCANCELLEDPAYCHECK (
    PRIMARY KEY(ID),
    ID NUMBER(20,0) NOT NULL, 
    REALM_ID NUMBER(20,0) DEFAULT -1 NOT NULL, 
    AMOUNT NUMBER(19,4) NULL, 
    PAYCHECKID NUMBER(20,0) NULL, 
    CREATIONDATE TIMESTAMP NULL, 
    CREATEDBY VARCHAR2(100) NULL, 
    LASTMODIFICATIONDATE TIMESTAMP NULL, 
    LASTMODIFIEDBY VARCHAR2(100) NULL, 
    VERSION NUMBER(20,0) NOT NULL, 
    UUID VARCHAR2(255) NOT NULL, 
    PTSVOIDPAYROLLRESULT NUMBER(20,0) NULL
)
/

CREATE TABLE PTSVOIDPAYROLLRESULT (
    PRIMARY KEY(ID),
    ID NUMBER(20,0) NOT NULL, 
    REALM_ID NUMBER(20,0) DEFAULT -1 NOT NULL, 
    DDDEBITAMOUNT NUMBER(19,4) NULL, 
    DEBITAMOUNT NUMBER(19,4) NULL, 
    TAXDEBITAMOUNT NUMBER(19,4) NULL, 
    SETTLEMENTDATE TIMESTAMP NULL, 
    APPLIEDFORWARDREFUND NUMBER(19,4) NULL, 
    CANCELLEDAMOUNT NUMBER(19,4) NULL, 
    IMMEDIATEREFUND NUMBER(19,4) NULL, 
    TAKEONRETURNREFUND NUMBER(19,4) NULL, 
    CREATIONDATE TIMESTAMP NULL, 
    CREATEDBY VARCHAR2(100) NULL, 
    LASTMODIFICATIONDATE TIMESTAMP NULL, 
    LASTMODIFIEDBY VARCHAR2(100) NULL, 
    VERSION NUMBER(20,0) NOT NULL, 
    UUID VARCHAR2(255) NOT NULL
)
/

CREATE INDEX PTSCANCELLEDPAYCHECK_RX ON PTSCANCELLEDPAYCHECK(REALM_ID ASC)
/

CREATE INDEX VOIDPROLLRSLT_VOIDPAYCHECK_FK ON PTSCANCELLEDPAYCHECK(PTSVOIDPAYROLLRESULT ASC)
/

ALTER TABLE PTSCANCELLEDPAYCHECK ADD CONSTRAINT VOIDPROLLRSLT_VOIDPAYCHECK_FK
    FOREIGN KEY (PTSVOIDPAYROLLRESULT)
    REFERENCES PTSVOIDPAYROLLRESULT (ID)
/

CREATE OR REPLACE TRIGGER "PTSCANCELLEDPAYCHECK_VT" BEFORE INSERT OR UPDATE ON "PTSCANCELLEDPAYCHECK"
    FOR EACH ROW
    BEGIN
     IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 
    END;
/


CREATE INDEX PTSVOIDPAYROLLRESULT_RX ON PTSVOIDPAYROLLRESULT(REALM_ID ASC)
/

CREATE OR REPLACE TRIGGER "PTSVOIDPAYROLLRESULT_VT" BEFORE INSERT OR UPDATE ON "PTSVOIDPAYROLLRESULT"
    FOR EACH ROW
    BEGIN
     IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 
    END;
/


ALTER TABLE TAKEHOMECOMPANY ADD (COMPANYLOGO BLOB NULL)
/

GRANT SELECT, INSERT, UPDATE, DELETE ON PTSCANCELLEDPAYCHECK TO &&2
/

GRANT SELECT, INSERT, UPDATE, DELETE ON PTSVOIDPAYROLLRESULT TO &&2
/

UPDATE PROJECT_VERSIONS_TABLE SET SCHEMA_VERSION='1.0.28', TIMESTAMP='2009-07-02 10:41:24.165' WHERE PROJECT_ID='_FY5ioOECEd2RxJXjYkjWBw'
/

