package com.intuit.sb.payroll.psp.testws;

import java.net.MalformedURLException;
import java.net.URL;

import javax.xml.namespace.QName;

import com.intuit.sbd.payroll.psp.webservices.BatchJobsWS;
import com.intuit.sbd.payroll.psp.webservices.BatchJobsWSService;
import com.intuit.sbd.payroll.psp.webservices.Exception_Exception;


public class BatchJobTestWSRequestWraper {
	
	private static final String BATCHJOB_TESTWS_WSDL      = "/test-ws/services/BatchJobsWS?wsdl";
	private String host = null ;
	
	public BatchJobTestWSRequestWraper(String host){
		this.host = host;
	}
	
	public void runEFTPSBatchProcessor() throws Exception_Exception{
		BatchJobsWS batchJobsWS = getBatchJobsWS();
		batchJobsWS.runEftpsEnrollmentBatchProcessor();
	}
	
	public  void runACH() throws Exception_Exception{
		
		BatchJobsWS batchJobsWS = getBatchJobsWS();
		batchJobsWS.generateNACHAFiles("STD", null, true);
	}
	
	public  void runACHTransactionProcessor() throws Exception_Exception{
		BatchJobsWS batchJobsWS = getBatchJobsWS();
		batchJobsWS.runAchTransactionProcessor(null);
	}
	
	public  void runEFPTSEnrollmentBatchProcessor() throws Exception_Exception{
		BatchJobsWS batchJobsWS = getBatchJobsWS();
		batchJobsWS.runEftpsEnrollmentBatchProcessor();
	}

	
	private  BatchJobsWS getBatchJobsWS(){
		
		BatchJobsWSService batchJobsWSService = null;
	
	
		String wsdlUrlStr = host+BATCHJOB_TESTWS_WSDL;
		URL url = null;
        try {
            URL baseUrl = BatchJobsWSService.class.getResource(".");
            url = new URL(baseUrl, wsdlUrlStr);
        } catch (MalformedURLException e) {
        	
        	
        }
        QName qname = new QName("http://webservices.psp.payroll.sbd.intuit.com/", "BatchJobsWSService");
        batchJobsWSService = new BatchJobsWSService(url,qname);
        BatchJobsWS batchJobsWS = batchJobsWSService.getBatchJobsWSPort();
        
        return batchJobsWS;

	}

}
