package com.intuit.sb.payroll.psp.testws;

import java.net.MalformedURLException;
import java.net.URL;
import java.text.Format;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

import javax.xml.datatype.XMLGregorianCalendar;
import javax.xml.namespace.QName;
import com.intuit.sbd.payroll.psp.webservices.Exception_Exception;
import com.intuit.sbd.payroll.psp.webservices.PSPDateWS;
import com.intuit.sbd.payroll.psp.webservices.PSPDateWSService;



public class PSPDateTestWSRequestWrapper {
	
	private static final String PSPDATE_TESTWS_WSDL  = "/test-ws/services/PSPDateWS?wsdl";
	private String host = null;
	
	public PSPDateTestWSRequestWrapper(String host){
		this.host = host;
	}
	
	
	public  void setPSPDate(String date) throws Exception_Exception{
		
		PSPDateWS pspDateWS = getPSPDateWS();
		pspDateWS.set(date);
		
	}
	
	public  XMLGregorianCalendar getPSPDate() throws Exception_Exception{
		PSPDateWS pspDateWS = getPSPDateWS();
		return pspDateWS.get();
	}
	
	
	public  void adjustPSPDateForBankActivation() throws Exception_Exception{
		
		XMLGregorianCalendar xmlcal = getPSPDate();

		Format format = new SimpleDateFormat("yyyyMMddHHmmss");
		
		Calendar cal = Calendar.getInstance();
		cal.set(Calendar.DAY_OF_MONTH, xmlcal.getDay());
		cal.set(Calendar.MONTH ,xmlcal.getMonth()- 1);
		cal.set(Calendar.YEAR , xmlcal.getYear());
		cal.set(Calendar.HOUR_OF_DAY, 13);

		int day_of_week = cal.get(Calendar.DAY_OF_WEEK);
		
		if(day_of_week == Calendar.MONDAY){
			cal.add(Calendar.DAY_OF_MONTH, 7);
		}
		else if (day_of_week == Calendar.TUESDAY){
			cal.add(Calendar.DAY_OF_MONTH, 6);
		}
		else{
			cal.add(Calendar.DAY_OF_MONTH, 5);
		}
		
		Date date = cal.getTime();
		String pspDate = format.format(date);
		setPSPDate(pspDate);
		
		
	}
	
	public  void adjustPSPDateToOffloadTransaction() throws Exception_Exception{
		
		XMLGregorianCalendar xmlcal = getPSPDate();
		
		
		if(xmlcal.getHour()<17){ // 5 PM
			return;
		}
		
		Format format = new SimpleDateFormat("yyyyMMddHHmmss");
		
		Calendar cal = Calendar.getInstance();
		cal.set(Calendar.DAY_OF_MONTH, xmlcal.getDay());
		cal.set(Calendar.MONTH, xmlcal.getMonth()- 1);
		cal.set(Calendar.YEAR, xmlcal.getYear());
		cal.set(Calendar.HOUR_OF_DAY, 13);
		
		int day_of_week = cal.get(Calendar.DAY_OF_WEEK);
		
		if(day_of_week == Calendar.FRIDAY ){
			cal.add(Calendar.DAY_OF_MONTH, 3);
		}
		else if(day_of_week == Calendar.SATURDAY){
			cal.add(Calendar.DAY_OF_MONTH, 2);
			
		}
		else{
			cal.add(Calendar.DAY_OF_MONTH, 1);
		}
		
		Date date = cal.getTime();
		
		String pspDate = format.format(date);
		
		setPSPDate(pspDate);
		
		
	}
	
	
	private PSPDateWS getPSPDateWS(){
		
			PSPDateWSService psDateWSService = null;
		
		
			String wsdlUrlStr = host +PSPDATE_TESTWS_WSDL;
			URL url = null;
	        try {
	            URL baseUrl = PSPDateWSService.class.getResource(".");
	            url = new URL(baseUrl, wsdlUrlStr);
	        } catch (MalformedURLException e) {
	        	
	        	
	        }
	        QName qname = new QName("http://webservices.psp.payroll.sbd.intuit.com/", "PSPDateWSService");
	        psDateWSService = new PSPDateWSService(url,qname);
		
		 
		//CompanyAdapter companyAdapter = companyAdapterService.getCompanyAdapterPort();
	      PSPDateWS pspDateWS = psDateWSService.getPSPDateWSPort();  
		return pspDateWS;

	}

}
