package com.intuit.sb.payroll.qa.services.employee;

import java.util.Date;

import org.testng.AssertJUnit;
import org.testng.annotations.Test;

import com.intuit.sb.payroll.capability.common.PTSEmployerServiceTestBase;
import com.intuit.sb.payroll.capability.common.PTSWorkerPaymentServiceTestBase;
import com.intuit.sb.payroll.capability.pts.statehandler.StatusUpdateHandlerUtil;
import com.intuit.sb.payroll.common.DateUtil;
import com.intuit.sb.payroll.entity.model.Worker;
import com.intuit.sb.payroll.pts.entity.InteractionEnum;
import com.intuit.sb.payroll.pts.entity.PPSPTSInteraction;
import com.intuit.sb.payroll.services.employer.AssistedStateType;

public class AddEmployeeTest extends PTSEmployerServiceTestBase {
	
	@Test(enabled=false)
	public void testAddEmployeeToPSP() throws Exception{
		prepareCurrentEmployerForAssisted(null,null);
		sEmployerService.updateAssistedState(AssistedStateType.INPROCESS_OF_ONBOARDING);
		
		Worker worker = new Worker();
		Date hireDate = DateUtil.getNowDate(); 
		worker = PTSWorkerPaymentServiceTestBase.createAssistedReadyEmployee(worker, hireDate);
		//Verify
		PPSPTSInteraction ppsPTSInteraction = StatusUpdateHandlerUtil.getPPSPTSInteraction(Worker.class.getName(), worker.getId(), InteractionEnum.ADDED);
		AssertJUnit.assertNotNull("Add employee call not made to PSP",ppsPTSInteraction);		
	}

}
