package com.intuit.sb.payroll.qa.services.employer;

import org.testng.annotations.Test;

/**
 * <P>The <CODE>PTSActivationsActiveTests</CODE> class contains test methods for verifying the Task system based on Activations Notification : 
 * Active and subsequent change in tasks based on front-end interaction
 * $Author: kvenkatraman $
 */

public class PTSActivationsActiveTests {
	
	 /**
	 * <P>
	 * Test getting the Tasks from Gemini , when PTS sends Activations - Active Notification to Gemini
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Delete current employer 
	 * <LI>Create new Employer with random EIN</LI>
	 * <LI>Add current Employer to PTS
	 * <LI>Construct PTSNotificationDTO based on add Employer detail</LI>
	 * <LI>call updateCompanyActivationStatus() of PTSNotificationAdapter passing above PTSNotificationDTO</LI> // mock Activations-Active Event
	 * <LI>Get the current tasks listing of Gemini</LI>
	 * </OL>
	 * <H3>
	 * <OL>
	 * <LI>Verify that "Activate your TaxPayment Service" task is obtained
	 * </LI>
	 * </OL>
	 */
	@Test(enabled=false)
	public void testGetTaskOnPTSActivationsActive(){
		
	}
	
	 /**
	 * <P>
	 * Test getting the Tasks from Gemini , when PTS sends Activations - Active Notification to Gemini and Activation is Cancelled
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Delete current employer 
	 * <LI>Create new Employer with random EIN</LI>
	 * <LI>Add current Employer to PTS
	 * <LI>Construct PTSNotificationDTO based on added Employer detail</LI>
	 * <LI>call updateCompanyActivationStatus() of PTSNotificationAdapter passing above PTSNotificationDTO</LI>  // mock Activations-Active Event
	 * <LI>Get the current tasks listing of Gemini</LI>
	 * <LI>Verify that "Activate your TaxPayment Service" task is obtained
	 * <LI>Set the activation state to Cancelled</LI>
	 * </OL>
	 * <H3>
	 * <OL>
	 * <LI>Verify that "Pay Quarterly Taxes" task is obtained
	 * </LI>
	 * </OL>
	 */
	@Test(enabled=false)
	public void testGetTaskOnActivationServiceCancel(){
		
	}

	/**
	 * <P>
	 * Test getting the Tasks from Gemini , when PTS sends Activations - Active Notification to Gemini and Activation is Incomplete
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Delete current employer 
	 * <LI>Create new Employer with random EIN</LI>
	 * <LI>Add current Employer to PTS
	 * <LI>Construct PTSNotificationDTO based on added Employer detail</LI>
	 * <LI>call updateCompanyActivationStatus() of PTSNotificationAdapter passing above PTSNotificationDTO</LI>  // mock Activations-Active Event
	 * <LI>Get the current tasks listing of Gemini</LI>
	 * <LI>Verify that "Activate your TaxPayment Service" task is obtained
	 * <LI>Set the activation state to incomplete</LI>
	 * </OL>
	 * <H3>
	 * <OL>
	 * <LI>Verify that "Activate your TaxPayment Service" task is obtained 
	 * </LI>
	 * </OL>
	 */

	@Test(enabled=false)
	public void testGetTaskOnActivationServiceIncomplete(){
		
	}
	
	/**
	 * <P>
	 * Test getting the Tasks from Gemini , when PTS sends Activations - Active Notification to Gemini and Activation is Completed
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Delete current employer 
	 * <LI>Create new Employer with random EIN</LI>
	 * <LI>Add current Employer to PTS
	 * <LI>Construct PTSNotificationDTO based on added Employer detail</LI>
	 * <LI>call updateCompanyActivationStatus() of PTSNotificationAdapter passing above PTSNotificationDTO</LI>  // mock Activations-Active Event
	 * <LI>Get the current tasks listing of Gemini</LI>
	 * <LI>Verify that "Activate your TaxPayment Service" task is obtained
	 * <LI>Set the activation state to complete</LI>
	 * </OL>
	 * <H3>
	 * <OL>
	 * <LI>Verify that "Your Tax Payment Service is Activated" Task
	 * <LI>Verify that "Intuit will file your Qx filing" Task
	 * </LI>
	 * </OL>
	 */

	@Test(enabled=false)
	public void testGetTaskOnActivationServiceComplete(){
		
	}

}
