package com.intuit.sb.payroll.qa.services.employer;



import java.util.Calendar;
import java.util.Date;
import java.util.List;

import org.testng.AssertJUnit;
import org.testng.annotations.Test;

import com.intuit.sb.payroll.capability.common.PTSWorkerPaymentServiceTestBase;
import com.intuit.sb.payroll.common.DateUtil;
import com.intuit.sb.payroll.entity.model.PayrollRun;
import com.intuit.sb.payroll.entity.model.Worker;
import com.intuit.sb.payroll.pts.entity.PPSPTSInteraction;
import com.intuit.sb.payroll.pts.entity.PTSPayrollRun;
import com.intuit.sb.payroll.services.workerpayments.PayrollRunSaveRequest;
import com.intuit.sb.payroll.services.workerpayments.PayrollRunSummary;



public class PTSVoidPaycheckTest extends PTSWorkerPaymentServiceTestBase{
	
	private static Worker worker;
	private static PayrollRunSummary payrollRunSummary;
	
	@Test(enabled=false)
	public void testSubmitPayrollOfAssistedReadyEmployerWithAssistedReadyEmployee()throws Exception{
		
		
		prepareCurrentEmployerForAssistedWithBank();		
		
		worker = new Worker();
		Date hireDate = DateUtil.createDate(2009, Calendar.MAY, 8);
		worker = createAssistedReadyEmployee(worker, hireDate);
				
		Long[] workerIds = new Long[1];
		workerIds[0] = worker.getId();
		Date payPeriodEndDate = DateUtil.createDate(2009, Calendar.JULY, 8);
		PayrollRunSaveRequest payrollRunSaveRequest = setUpPayrollRunSaveRequest(workerIds, payPeriodEndDate);
		
		//Exercise
		payrollRunSummary = sWorkerPayService.commitPayrollRun(payrollRunSaveRequest).getPayrollRunSummary();
    	
    	// Restore the Payroll system date to the current date
     	resetPayrollSystemDate();
     	
     	//Assert that no call for Submit Payroll is made by Gemini
     	List<PPSPTSInteraction> ppsPTSInteractions = ppsPTSInteractionEAO.findAll(PayrollRun.class.getName(), payrollRunSummary.getPayrollRunId());
    	AssertJUnit.assertEquals("Submit Payroll should not be called", 0, ppsPTSInteractions.size());
    	
    	//Assert that SubmitPayroll response from PSP is null
     	PTSPayrollRun ptsPayrollRun = ptsPayrollRunEAO.findPTSPayrollRunByPayrollRunId(payrollRunSummary.getPayrollRunId());
     	AssertJUnit.assertNull("Submit Payroll response for DIY Employer should be null",ptsPayrollRun);
     	
	}
	
}
