package com.intuit.sb.payroll.qa.webservice.client;

import java.io.BufferedInputStream;
import java.io.InputStreamReader;
import java.io.LineNumberReader;
import java.io.StringReader;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.CharacterData;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;

@SuppressWarnings("unused")
public class PTSNotificationAdapterServiceResponse {
	
	
	private String messageDescription = "";
	private String sourceCompanyId = "";
	private String status = "";
	
	
	public PTSNotificationAdapterServiceResponse(String soapResponse) {
		mapResponse(soapResponse);
	}
	
	
	public void mapResponse(String soapResponse){
		
		
		NodeList nodes = null;
		Element element = null;
		
		try {
	        DocumentBuilderFactory dbf =
	        DocumentBuilderFactory.newInstance();
	        DocumentBuilder db = dbf.newDocumentBuilder();
	        InputSource is = new InputSource();
	        is.setCharacterStream(new StringReader(soapResponse));

	        Document doc = db.parse(is);
	        
	        nodes = doc.getElementsByTagName("messageDescription");
	        element = (Element) nodes.item(0);
	        this.messageDescription = getCharacterDataFromElement(element);
	        
	        
/*	        nodes = doc.getElementsByTagName("messageId");
	        element = (Element) nodes.item(0);
	        resp.setMessageID(getCharacterDataFromElement(element));*/
	      
	        nodes = doc.getElementsByTagName("sourceCompanyId");
	        element = (Element) nodes.item(0);
	        this.sourceCompanyId = getCharacterDataFromElement(element);
	        
	        nodes = doc.getElementsByTagName("status");
	        element = (Element) nodes.item(0);
	        this.status = getCharacterDataFromElement(element);
	    }
	    catch (Exception e) {
	        e.printStackTrace();
	    }
	
	}
	
	private String getCharacterDataFromElement(Element e) {
	    Node child = e.getFirstChild();
	    if (child instanceof CharacterData) {
	       CharacterData cd = (CharacterData) child;
	       return cd.getData();
	    }
	    return "?";
	  }

	private  String parseInputStreamToString(java.io.InputStream is){
		
		LineNumberReader reader = new LineNumberReader(new InputStreamReader(new BufferedInputStream(is)));
		StringBuffer sb = new StringBuffer();
		
	try{
		String line = null ;
	
	while((line=reader.readLine()) != null){
			sb.append(line+"\n");
	}
	}catch(Exception ex){
		ex.getMessage();
	}finally{
	try{
		is.close();
	}catch(Exception ex){}
	}
	return sb.toString();
	}
	
	public String getMessageDescription() {
		return messageDescription;
	}


	public String getSourceCompanyId() {
		return sourceCompanyId;
	}


	public String getStatus() {
		return status;
	}



}
