/*package com.intuit.sb.payroll.qa.services.employer;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import org.testng.AssertJUnit;
import org.testng.annotations.Test;

import com.intuit.sb.payroll.ServiceFailureException;
import com.intuit.sb.payroll.ValidationException;
import com.intuit.sb.payroll.pts.entity.PTSContactPerson;
import com.intuit.sb.payroll.pts.entity.PTSEmployer;
import com.intuit.sb.payroll.services.common.ObjectHandle;
import com.intuit.sb.payroll.services.common.impl.EmployerContactMapper;
import com.intuit.sb.payroll.services.employer.EmployerContact;
import com.intuit.sb.payroll.services.employer.EmployerContactType;
import com.intuit.sb.payroll.services.employer.EmployerServiceTestBase;

*//**
 * Tests the EmployerContacts related operations of the EmployerService.
 *
 * $Author: amalik $
 * $Revision: #5 $
 * $DateTime: 2009/03/20 01:00:13 $
 *
 *//*
public class EmployerContactsTest extends EmployerServiceTestBase {
 
	
    *//**
     * <P>Test getting Employer Contacts</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Add a primary contact</LI>
     * <LI>Set up the expected list of primary contacts</LI>
     * <LI>Call EmployerService's getEmployerContacts() to get the list of primary contacts</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that list returned matches expected result
     * </UL>
     *//*
    @Test
    public void testGetEmployerContacts() throws Exception {
        EmployerContact addedEmployerContact = null;
        
        // Setup
        addedEmployerContact = addAEmployerContact("Jack", "Smith", "650-944-7632", EmployerContactType.SecondaryContact);
        
        EmployerContact[] employerContact = new EmployerContact[1];
        employerContact[0]=addedEmployerContact;
        
        // Exercise
        EmployerContact[] computedEmployerContacts = sEmployerService.getEmployerContacts();
        // Verify
        AssertJUnit.assertTrue("EmployerContact mismatch!", verifyEmployerContacts(employerContact, computedEmployerContacts,true));

    }

    *//**
     * <P>Test getting multiple Employer Contacts</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Add multiple primary contacts</LI>
     * <LI>Set up the expected list of primary contacts</LI>
     * <LI>Call EmployerService's getEmployerContacts() to get the list of primary contacts</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that list returned matches expected result
     * </UL>
     *//*
    @Test
    public void testGetMultipleEmployerContacts() throws Exception {
    	
        List<EmployerContact> empcontactList = new ArrayList<EmployerContact>();
        EmployerContact[] availableContacts = sEmployerService.getEmployerContacts();
        
        empcontactList.addAll(Arrays.asList(availableContacts));
        EmployerContact[] addedEmployerContacts= new EmployerContact[3];
        
        // Setup
        addedEmployerContacts[0] = addAEmployerContact("Boby", "Smith", "650-944-7675", EmployerContactType.SecondaryContact);
        addedEmployerContacts[1] = addAEmployerContact("Mary", "Smith", "650-944-7667", EmployerContactType.SecondaryContact);
        addedEmployerContacts[2] = addAEmployerContact("Tom", "Cat", "950-844-7676", EmployerContactType.SecondaryContact);
            
  
            // Exercise
        EmployerContact[] computedEmployerContacts = sEmployerService.getEmployerContacts();
        // Verify
 
        AssertJUnit.assertTrue("EmployerContact mismatch!", verifyEmployerContacts(addedEmployerContacts, computedEmployerContacts,true));
            
    }

    *//**
     * <P>Test find Employer Contacts with null Id</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Call EmployerService's findEmployerContact() with null Id</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that ValidationException is thrown
     * </UL>
     *//*
    @Test(expectedExceptions=ValidationException.class)
    public void testFindEmployerContactsWithNull() throws Exception {
        // Exercise
        sEmployerService.findEmployerContact(null);
    }

    *//**
     * <P>Test find Employer Contacts with non-existent Id</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Call EmployerService's findEmployerContact() with non-existent Id</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that ValidationException is thrown
     * </UL>
     *//*
    @Test(expectedExceptions=ServiceFailureException.class)
    public void testFindEmployerContactsWithNonExistentId() throws Exception {
        // Exercise
        sEmployerService.findEmployerContact(new Long("83785472"));
    }

    *//**
     * <P>Test find a Employer Contact</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Add a primary contact</LI>
     * <LI>Set up the expected list of primary contacts</LI>
     * <LI>Call EmployerService's findEmployerContact() to get the list of primary contacts</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that list returned matches expected result
     * </UL>
     *//*
    @Test(enabled=false)
    public void testFindAEmployerContact() throws Exception {
    	// Cleanup
    	sEmployerService.deleteAllEmployerContacts();
    	
        EmployerContact addedEmployerContact = null;
       
        // Setup
        addedEmployerContact = addAEmployerContact("Bob", "Smith", "650-944-7632", EmployerContactType.SecondaryContact);
        // FIXME amalik the above method does not return the right added EmployerContact  
        
        // Exercise
        EmployerContact primaryContact = sEmployerService.findEmployerContact(addedEmployerContact.getObjectHandle().getId());
        // Verify
        EmployerContact[] expectedEmployerContact = new EmployerContact[1];
        expectedEmployerContact[0] = addedEmployerContact;
        EmployerContact[] returnedEmployerContacts = new EmployerContact[1];
        returnedEmployerContacts[0] = primaryContact;
        AssertJUnit.assertTrue("EmployerContact mismatch!", verifyEmployerContacts(expectedEmployerContact, returnedEmployerContacts,true));
        
        // Cleanup
    	sEmployerService.deleteAllEmployerContacts();
 
    }

 
    *//**
     * <P>Test deleting all Employer Contacts</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Add multiple primary contacts</LI>
     * <LI>Call EmployerService's deleteAllEmployerContacts() to delete all primary contacts</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that calling getEmployerContacts() afterwards should return an empty array
     * </UL>
     *//*
    @Test
    public void testDeleteAllEmployerContacts() throws Exception {
        EmployerContact[] addedEmployerContacts = new EmployerContact[3];
        boolean needToCleanup = true;
        try {
            // Setup
            addedEmployerContacts[0] = addAEmployerContact("Bob", "Smith", "650-944-7630", EmployerContactType.SecondaryContact);
            addedEmployerContacts[1] = addAEmployerContact("Mary", "Ellen", "650-944-7631", EmployerContactType.SecondaryContact);
            addedEmployerContacts[2] = addAEmployerContact("Tom", "Sawyer", "650-944-7632", EmployerContactType.SecondaryContact);
            // Exercise
            
        
            sEmployerService.deleteAllEmployerContacts();
            // Verify
            EmployerContact[] returnedEmployerContacts = sEmployerService.getEmployerContacts();
            
            AssertJUnit.assertEquals("EmployerContact not deleted!", 0, returnedEmployerContacts.length);
            
            needToCleanup = false;
        } finally {
            // Clean up
            if (needToCleanup) {
                for (EmployerContact addedEmployerContact : addedEmployerContacts) {
                    if (null != addedEmployerContact) {
                        deleteAEmployerContact(addedEmployerContact);
                    }
                }
            }
        }
    }

    *//**
     * <P>Test delete Employer Contacts with null array</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Call EmployerService's deleteEmployerContacts() with null array</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that ValidationException is thrown
     * </UL>
     *//*
    @Test(expectedExceptions=ValidationException.class)
    public void testDeleteEmployerContactsWithNull() throws Exception {
        // Exercise
        sEmployerService.deleteEmployerContacts(null);
    }

    *//**
     * <P>Test delete Employer Contacts with empty array</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Call EmployerService's deleteEmployerContacts() with empty array</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that ValidationException is thrown
     * </UL>
     *//*
    @Test(expectedExceptions=ValidationException.class)
    public void testDeleteEmployerContactsWithEmptyArray() throws Exception {
        // Exercise
        sEmployerService.deleteEmployerContacts(new EmployerContact[0]);
    }

    *//**
     * <P>Test delete Employer Contacts with null array element</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Call EmployerService's deleteEmployerContacts() with null array element</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that ValidationException is thrown
     * </UL>
     *//*
    @Test(expectedExceptions=ValidationException.class)
    public void testDeleteEmployerContactsWithNullElement() throws Exception {
        // Setup
    	EmployerContact[] empContacts = new EmployerContact[1];
        empContacts[0] = null;
        // Exercise
        sEmployerService.deleteEmployerContacts(empContacts);
    }

    *//**
     * <P>Test delete Employer Contacts with a valid and a null array element</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Add a primary contact</LI>
     * <LI>Set up the expected list of primary contacts</LI>
     * <LI>Call EmployerService's deleteEmployerContacts() with a valid and a null array element</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that ValidationException is thrown
     * </UL>
     *//*
    @Test(expectedExceptions=ValidationException.class)   
    public void testDeleteEmployerContactsWithAValidAndNullElement() throws Exception {
       
    	EmployerContact[] availableEmployerContacts = sEmployerService.getEmployerContacts();
        
        for(int i = 0 ; i< availableEmployerContacts.length ; i++){
        	if(availableEmployerContacts[i].getEmployerContactType().equals(EmployerContactType.PrimaryContact)){
        		availableEmployerContacts[i].setEmployerContactType(EmployerContactType.SecondaryContact);
        	}
        }
        
        EmployerContact addedEmployerContact = addAEmployerContact("Bob", "Smith", "650-944-7632", EmployerContactType.SecondaryContact);
        
        EmployerContact[] employerContacts = new EmployerContact[2];
        employerContacts[0] = addedEmployerContact;
        employerContacts[1] = null;
        
        sEmployerService.deleteEmployerContacts(employerContacts);
        
     }


    *//**
     * <P>Test delete Employer Contacts with a valid and a non-existent array element</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Add a primary contact</LI>
     * <LI>Set up the expected list of primary contacts</LI>
     * <LI>Call EmployerService's deleteEmployerContacts() with a valid and a non-existent array element</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that ServiceFailureException is thrown
     * </UL>
     *//*
    @Test(expectedExceptions=ValidationException.class)
    public void testDeleteEmployerContactsWithAValidAndNonExistentElement() throws Exception {
        // Commit to close the transaction that was started in BasicTestBase
        getUserTransaction().commit();
        // Setup - Add 2 Employer contact
        EmployerContact addedEmployerContact = addAEmployerContact("Bob", "Smith", "650-944-7632", EmployerContactType.SecondaryContact);
        EmployerContact addedEmployerContact2 = addAEmployerContact("Jane", "Smith", "650-944-7633", EmployerContactType.SecondaryContact);
        getUserTransaction().begin();
        PTSEmployer employer = sEmpPTSWFComponent.getPTSEmployer();
        Set<PTSContactPerson> employerContactPersons = employer.getPTSContactPersons();
        EmployerContact[] expectedEmployerContact = new EmployerContact[employerContactPersons.size()];
        int i = 0;
        Iterator<PTSContactPerson> iterator = employerContactPersons.iterator();
        while (iterator.hasNext()) {
        	PTSContactPerson employerContactPerson = iterator.next();
            expectedEmployerContact[i++] = EmployerContactMapper.mapEmployerContact(employerContactPerson);
        }
        // Set 1 valid element and 1 non-existent element
        EmployerContact[] empContacts = new EmployerContact[2];
        empContacts[0] = addedEmployerContact;
        empContacts[1] = new EmployerContact();
        getUserTransaction().commit();
        try {
            // Exercise
            sEmployerService.deleteEmployerContacts(empContacts);
        } finally {
            // Verify - The valid element shouldn't be deleted
            EmployerContact[] returnedEmployerContacts = sEmployerService.getEmployerContacts();
            boolean compareResult = expectedEmployerContact.length == returnedEmployerContacts.length;
            if (null != addedEmployerContact) {
                deleteAEmployerContact(addedEmployerContact);
            }
            if (null != addedEmployerContact2) {
                deleteAEmployerContact(addedEmployerContact2);
            }
            // Begin a transaction for clean up
            getUserTransaction().begin();
            AssertJUnit.assertTrue("EmployerContact should not have been deleted!", compareResult);
        }
    }

    *//**
     * <P>Test delete Employer Contacts with all valid array elements</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Add a primary contact</LI>
     * <LI>Set up the expected list of primary contacts</LI>
     * <LI>Call EmployerService's deleteEmployerContacts() with all valid array elements</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that Employer Contacts are deleted
     * </UL>
     *//*
    @Test
    public void testDeleteEmployerContactsWithAllValidArrayElements() throws Exception {
        getUserTransaction().commit();
        EmployerContact[] availableEmployerContacts = sEmployerService.getEmployerContacts();
        
        for(int i = 0 ; i< availableEmployerContacts.length ; i++){
        	if(availableEmployerContacts[i].getEmployerContactType().equals(EmployerContactType.PrimaryContact)){
        		availableEmployerContacts[i].setEmployerContactType(EmployerContactType.SecondaryContact);
        	}
        }
        
        EmployerContact addedEmployerContact = addAEmployerContact("Bob", "Smith", "650-944-7632", EmployerContactType.SecondaryContact);
        EmployerContact addedEmployerContact2 = addAEmployerContact("Jane", "Smith", "650-944-7633", EmployerContactType.SecondaryContact);
        AssertJUnit.assertTrue(sEmployerService.getEmployerContacts().length == availableEmployerContacts.length+2);
        
        EmployerContact[] empContacts = new EmployerContact[2];
        
        empContacts[0] = addedEmployerContact;
        empContacts[1] = addedEmployerContact2;
        
        try {
            // Exercise
            sEmployerService.deleteEmployerContacts(empContacts);
        } 
        finally{
            EmployerContact[] returnedEmployerContacts = sEmployerService.getEmployerContacts();
            
            // reset
           	empContacts[0].setObjectHandle(null);
        	sEmployerService.addEmployerContacts(empContacts);
            AssertJUnit.assertEquals("EmployerContacts not deleted!", availableEmployerContacts.length, returnedEmployerContacts.length);
        }
    }

    *//**
     * <P>Test add Employer Contacts with null</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Call EmployerService's addEmployerContacts() with null</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that ValidationException is thrown
     * </UL>
     *//*
    @Test(expectedExceptions=ValidationException.class)
    public void testAddEmployerContactsWithNull() throws Exception {
        // Exercise
        sEmployerService.addEmployerContacts(null);
    }

    *//**
     * <P>Test add Employer Contacts with an empty array</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Call EmployerService's addEmployerContacts() with an empty array</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that ValidationException is thrown
     * </UL>
     *//*
    @Test(expectedExceptions=ValidationException.class)
    public void testAddEmployerContactsWithEmptyArray() throws Exception {
        // Exercise
        sEmployerService.addEmployerContacts(new EmployerContact[0]);
    }

    *//**
     * <P>Test add Employer Contacts with a valid and a null array element</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Set up an array of primary contacts with 1 valid and 1 null element</LI>
     * <LI>Call EmployerService's addEmployerContacts() with a valid and a null array element</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that ValidationException is thrown
     * </UL>
     *//*
    @Test
     public void testAddEmployerContactsWithAValidAndNullElement() throws Exception {
    	getUserTransaction().commit();
    	 
        // Setup - Add a Employer contact
        EmployerContact primaryContactToAdd = createEmployerContact("Bob", "Smith", "650-944-7632", EmployerContactType.SecondaryContact);
        
        // Set 1 valid element and 1 null element
        EmployerContact[] primaryContacts = new EmployerContact[2];
        primaryContacts[0] = primaryContactToAdd;
        primaryContacts[1] = null;
        try {
            // Exercise
            sEmployerService.addEmployerContacts(primaryContacts);
            AssertJUnit.fail("Expected ValidatationException is not thrown in testAddEmployerContactsWithAValidAndNullElement");
        } 
        catch(ValidationException e){
        	
        }
    }

    *//**
     * <P>Test add multiple Employer Contacts</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Set up the expected list of primary contacts</LI>
     * <LI>Call EmployerService's addEmployerContacts() to add the list of primary contacts</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that list returned matches expected result
     * </UL>
     *//*
    @Test
    // can there be clean up for this test as deletion of all contacts is not possible
    public void testAddMultipleEmployerContacts() throws Exception {
        EmployerContact[] expectedEmployerContacts = new EmployerContact[3];
        EmployerContact[] returnedEmployerContacts = null;
       
            // Setup
            expectedEmployerContacts[0] = createEmployerContact("Bob", "Smith", "650-944-7630", EmployerContactType.SecondaryContact);
            expectedEmployerContacts[1] = createEmployerContact("Mary", "Ellen", "650-944-7631", EmployerContactType.SecondaryContact);
            expectedEmployerContacts[2] = createEmployerContact("Tom", "Sawyer", "650-944-7632", EmployerContactType.SecondaryContact);
            // Exercise
            returnedEmployerContacts = sEmployerService.addEmployerContacts(expectedEmployerContacts);
            fixUpUniqueIdAndVersion(expectedEmployerContacts);
            // Verify
            AssertJUnit.assertTrue("EmployerContacts mismatch!", verifyEmployerContacts(expectedEmployerContacts, returnedEmployerContacts,true));
        
    }
    
    *//**
     * <P>Test update Employer Contacts with null</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Call EmployerService's updateEmployerContacts() with null</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that ValidationException is thrown
     * </UL>
     *//*
    @Test(expectedExceptions=ValidationException.class)
    public void testUpdateEmployerContactsWithNull() throws Exception {
        // Exercise
        sEmployerService.updateEmployerContacts(null);
    }

    *//**
     * <P>Test update Employer Contacts with an empty array</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Call EmployerService's updateEmployerContacts() with an empty array</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that ValidationException is thrown
     * </UL>
     *//*
    @Test(expectedExceptions=ValidationException.class)
    public void testUpdateEmployerContactsWithEmptyArray() throws Exception {
        // Exercise
        sEmployerService.updateEmployerContacts(new EmployerContact[0]);
    }

    *//**
     * <P>Test update Employer Contacts with a valid and a null array element</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Add a primary contact</LI>
     * <LI>Set up an array with 1 valid EmployerContact and 1 null element</LI>
     * <LI>Call EmployerService's updateEmployerContacts() with a valid and a null array element</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that ValidationException is thrown
     * </UL>
     *//*
    @Test(expectedExceptions=ValidationException.class)
    public void testUpdateEmployerContactsWithAValidAndNullElement() throws Exception {
        // Commit to close the transaction that was started in BasicTestBase
        getUserTransaction().commit();
        // Setup - Add a Employer contact
        EmployerContact addedEmployerContact = addAEmployerContact("Bob", "Smith", "650-944-7632", EmployerContactType.SecondaryContact);
        EmployerContact[] primaryContacts = sEmployerService.getEmployerContacts();
        addedEmployerContact = primaryContacts[0];
        EmployerContact[] expectedEmployerContact = new EmployerContact[1];
        expectedEmployerContact[0] = addedEmployerContact;
        // Make a copy of the saved EmployerContact and then make some minor changes
        EmployerContact changedContact = new EmployerContact();
        changedContact.copy(addedEmployerContact);
        changedContact.setFirstName("Daryl");
        // Set 1 valid element and 1 null element
        primaryContacts = new EmployerContact[2];
        primaryContacts[0] = changedContact;
        primaryContacts[1] = null;
        try {
            // Exercise
            sEmployerService.updateEmployerContacts(primaryContacts);
        } finally {
            // Verify - The valid element shouldn't be deleted
            EmployerContact[] returnedEmployerContacts = sEmployerService.getEmployerContacts();
            boolean compareResult = verifyEmployerContacts(expectedEmployerContact, returnedEmployerContacts,true);
            // Clean up
            if (null != addedEmployerContact) {
                deleteAEmployerContact(addedEmployerContact);
            }
            getUserTransaction().begin();
            AssertJUnit.assertTrue("EmployerContact should not have been updated!", compareResult);
        }
    }

    *//**
     * <P>Test update Employer Contacts with a valid and a non-existent id array element</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Add a primary contact</LI>
     * <LI>Set up an array with 1 valid EmployerContact and 1 non-existent id element</LI>
     * <LI>Call EmployerService's updateEmployerContacts() with a valid and a non-existent id array element</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that ServiceFailureException is thrown
     * </UL>
     *//*
    @Test(expectedExceptions=ServiceFailureException.class)
    public void testUpdateEmployerContactsWithAValidAndNonExistentElement() throws Exception {
        // Commit to close the transaction that was started in BasicTestBase
        getUserTransaction().commit();
        // Setup - Add a Employer contact
        EmployerContact addedEmployerContact = addAEmployerContact("Bob", "Smith", "650-944-7632", EmployerContactType.SecondaryContact);
        EmployerContact[] primaryContacts = sEmployerService.getEmployerContacts();
        int numOfContacts = primaryContacts.length;
        addedEmployerContact = primaryContacts[0];
        EmployerContact[] expectedEmployerContact = new EmployerContact[1];
        expectedEmployerContact[0] = addedEmployerContact;
        // Make a copy of the saved EmployerContact and then make some minor changes
        EmployerContact changedContact = new EmployerContact();
        changedContact.copy(addedEmployerContact);
        changedContact.setFirstName("Daryl");
        // Set 1 valid element and 1 non-existent element
        primaryContacts = new EmployerContact[2];
        primaryContacts[0] = changedContact;
        primaryContacts[1] = createEmployerContact("Jane", "Smith", "650-944-7633", EmployerContactType.SecondaryContact);
        primaryContacts[1].setObjectHandle(new ObjectHandle(98348384L, 0));
        try {
            // Exercise
            sEmployerService.updateEmployerContacts(primaryContacts);
        } finally {
            // Verify - The valid element shouldn't be deleted
            EmployerContact[] returnedEmployerContacts = sEmployerService.getEmployerContacts();
            boolean compareResult = verifyEmployerContacts(expectedEmployerContact, returnedEmployerContacts,true);
            // Clean up
            //if we start with a clean DB, there should be only one contact associated with the employer
            //don't delete contact if there is only one contact person (because it will fail)
            if (null != addedEmployerContact && numOfContacts > 1) {
                deleteAEmployerContact(addedEmployerContact);
            }
            getUserTransaction().begin();
            AssertJUnit.assertTrue("EmployerContact should not have been updated!", compareResult);
        }
    }

    *//**
     * <P>Test update Employer Contacts with all valid array elements</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Add 2 primary contacts</LI>
     * <LI>Make some changes to the 2 primary contacts</LI>
     * <LI>Set up the expected list of primary contacts</LI>
     * <LI>Call EmployerService's updateEmployerContacts() with all valid array elements</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that Employer Contacts are updated
     * </UL>
     *//*
    @Test
    public void testUpdateEmployerContactsWithAllValidArrayElements() throws Exception {
        // Commit to close the transaction that was started in BasicTestBase
        getUserTransaction().commit();
        // Setup - Add 2 Employer contact
        EmployerContact addedEmployerContact = addAEmployerContact("Bob", "Smith", "650-944-7632", EmployerContactType.SecondaryContact);
        EmployerContact addedEmployerContact2 = addAEmployerContact("Jane", "Smith", "650-944-7633", EmployerContactType.SecondaryContact);
        // Set all valid elements
        EmployerContact[] primaryContacts = new EmployerContact[2];
        addedEmployerContact.setLastName("Doe");
        primaryContacts[0] = addedEmployerContact;
        addedEmployerContact2.setLastName("Doe");
        primaryContacts[1] = addedEmployerContact2;
        try {
            // Exercise
            sEmployerService.updateEmployerContacts(primaryContacts);
        } finally {
            // Verify - The valid element shouldn't be deleted
            EmployerContact[] expectedEmployerContacts = new EmployerContact[2];
            expectedEmployerContacts[0] = addedEmployerContact;
            expectedEmployerContacts[1] = addedEmployerContact2;
            getUserTransaction().begin();
            fixUpUniqueIdAndVersion(expectedEmployerContacts);
            getUserTransaction().commit();
            EmployerContact[] returnedEmployerContacts = sEmployerService.getEmployerContacts();
            boolean compareResult = verifyEmployerContacts(expectedEmployerContacts, returnedEmployerContacts,true);
            // Clean up
            if (null != addedEmployerContact) {
                deleteAEmployerContact(addedEmployerContact);
            }
            if (null != addedEmployerContact2) {
                deleteAEmployerContact(addedEmployerContact2);
            }
            getUserTransaction().begin();
            AssertJUnit.assertTrue("EmployerContact should not have been updated!", compareResult);
        }
    }

    *//**
     * Utility method to fix up the uniqueId and version fields with the actual values returned from the DB
     * 
     * @param primaryContacts the array of EmployerContacts to fix up the uniqueId and version values
     *//*
    private void fixUpUniqueIdAndVersion(EmployerContact[] primaryContacts) {
        PTSEmployer ptsEmployer = sEmpPTSWFComponent.getPTSEmployer();
        Set<PTSContactPerson> employerContactPersons = ptsEmployer.getPTSContactPersons();
        for (EmployerContact primaryContact : primaryContacts) {
            boolean found = false;
	        for (PTSContactPerson contactPerson : employerContactPersons) {
	        	if (primaryContact.getFirstName().equals(contactPerson.getEmployerContact().getPersonName().getFirstName()) &&
	                    primaryContact.getLastName().equals(contactPerson.getEmployerContact().getPersonName().getLastName()) &&
	                    primaryContact.getPhone().equals(contactPerson.getEmployerContact().getWorkPhone().getFreeFormNumber())) {
	        		primaryContact.setObjectHandle(new ObjectHandle(contactPerson.getId(), contactPerson.getVersion()));
	        		found = true;
	                break;
	        	}
	        }
	        AssertJUnit.assertTrue("Could not find matching EmployerContact!", found);
		}
    }

    *//**
     * Utility method to add a EmployerContact to the Employer
     * 
     * @param firstName The EmployerContact's first name
     * @param lastName The EmployerContact's last name
     * @param phone The EmployerContact's phone number
     * @param isOwner Whether or not the EmployerContact is the Owner
     * @return The EmployerContact that was added to the Employer
     *//*
    private EmployerContact addAEmployerContact(String firstName, String lastName, String phone, EmployerContactType empType) {
        EmployerContact addedContact = null;
        EmployerContact[] contacts = new EmployerContact[1];
        contacts[0] = createEmployerContact(firstName, lastName, phone, empType);
        contacts[0].setOwner(true);
        try {
            EmployerContact[] addedContacts = sEmployerService.addEmployerContacts(contacts);
            for (EmployerContact primaryContact : addedContacts) {
                if (firstName.equals(primaryContact.getFirstName()) && lastName.equals(primaryContact.getLastName()) &&
                    phone.equals(primaryContact.getPhone())) {
                    addedContact = primaryContact;
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
            AssertJUnit.fail("Error in addAEmployerContact: " + e.getMessage());
        }
        return addedContact;
    }
    
    private void deleteAEmployerContact(EmployerContact primaryContact) throws ServiceFailureException, ValidationException {
    	EmployerContact[] contacts = new EmployerContact[1];
        contacts[0] = primaryContact;
        sEmployerService.deleteEmployerContacts(contacts);
    }
    
 ////////////////////////////////////////////////////////////////////
    
	*//**
	 * <P>
	 * Test Save Primary contact of the Assisted Employer
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create a Primary Contact</LI>
	 * <LI>Save the Primary Contact by calling addEmployerContact of Employer
	 * Service</LI>
	 * <LI>Compare the saved and passed EmployerContact for equality</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that Primary contact gets saved as expected</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*
	@Test
	public void testSaveEmployerPrimaryContact()
			throws ServiceFailureException, ValidationException {

		
		
		EmployerContact[] contacts = new EmployerContact[] { createEmployerContact(
									"Bob", "Smith", "415-999-1212",
									EmployerContactType.PrimaryContact) };
		EmployerContact[] saveContacts = sEmployerService
				.addEmployerContacts(contacts);
		verifyEmployerContacts(contacts,saveContacts, true);
		
	}
	
	*//**
	 * <P>
	 * Test Save Primary Principal of Assisted Employer
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create a Primary Principal</LI>
	 * <LI>Save the Primary Principal by calling addEmployerContact of Employer
	 * Service</LI>
	 * <LI>Compare the saved and passed EmployerContact for equality</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that Primary Principal gets saved as expected</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*
	@Test
	public void testSaveEmployerPrimaryPrincipal()
			throws ServiceFailureException, ValidationException {

		EmployerContact[] contacts = new EmployerContact[] { createEmployerContact(
									"Bob", "Smith", "415-999-1212",
									EmployerContactType.PrimaryPrincipal) };
		EmployerContact[] saveContacts = sEmployerService
				.addEmployerContacts(contacts);
		verifyEmployerContacts(contacts,saveContacts, true);
		
	}
	

	*//**
	 * <P>
	 * Test delete Primary Contact for Assisted Worker
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Add a Primary Contact to Delete</LI>
	 * <LI>Get the Contact Ids of Saved Primary Contact to Delete</LI>
	 * <LI>Delete the Primary Contact by calling the deleteEmployerContacts()
	 * passing the contact ids</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that test thows an Exception , that primary contact cannot be
	 * deleted</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*

	@Test(expectedExceptions=ValidationException.class)
	public void testDeleteEmployerPrimaryContact()
			throws ServiceFailureException, ValidationException {

		EmployerContact[] contacts = new EmployerContact[1];
		EmployerContact contact = createEmployerContact("James", "Bond",
				"1135468700", EmployerContactType.PrimaryContact);
		contacts[0] = contact;
		// Add a Primary Contact
		EmployerContact[] saveContacts = sEmployerService.addEmployerContacts(contacts);
		verifyEmployerContacts(contacts,saveContacts, true);

		ArrayList<EmployerContact> idList = new ArrayList<EmployerContact>();

		for (EmployerContact contact1 : contacts) {
			for (EmployerContact contact2 : saveContacts) {
				if (contact1.getFirstName().equals(contact2.getFirstName())
						&& contact1.getLastName()
								.equals(contact2.getLastName())
						&& contact1.getPhone().equals(contact2.getPhone())) {
					idList.add(contact2);
				}
			}

		}
		EmployerContact[] empContacts = (EmployerContact[]) idList.toArray(new EmployerContact[0]);
		sEmployerService.deleteEmployerContacts(empContacts);
	}
	
	
	*//**
	 * <P>
	 * Test delete Primary Principal for Assisted Worker
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Add a Primary Principal to Delete</LI>
	 * <LI>Get the Contact Ids of Saved Primary Principal to Delete</LI>
	 * <LI>Delete the Primary Principal by calling the deleteEmployerContacts()
	 * passing the contact ids</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that test thows an Exception , that primary principal cannot be
	 * deleted</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*

	@Test (expectedExceptions = ValidationException.class) 
	public void testDeleteEmployerPrimaryPrincipal()
			throws ServiceFailureException, ValidationException {

		EmployerContact[] contacts = new EmployerContact[1];
		EmployerContact contact = createEmployerContact("James", "Bond",
				"1135468700", EmployerContactType.PrimaryPrincipal);
		contacts[0] = contact;
		// Add a Primary Contact
		EmployerContact[] saveContacts = sEmployerService.addEmployerContacts(contacts);
		verifyEmployerContacts(contacts,saveContacts, true);

		ArrayList<EmployerContact> idList = new ArrayList<EmployerContact>();

		for (EmployerContact contact1 : contacts) {
			for (EmployerContact contact2 : saveContacts) {
				if (contact1.getFirstName().equals(contact2.getFirstName())
						&& contact1.getLastName()
								.equals(contact2.getLastName())
						&& contact1.getPhone().equals(contact2.getPhone())) {
					idList.add(contact2);
				}
			}

		}
		EmployerContact[] empContacts = (EmployerContact[]) idList.toArray(new EmployerContact[0]);
		sEmployerService.deleteEmployerContacts(empContacts);
	}
	
	
	*//**
	 * <P>
	 * Test Add 2nd Primary Principal for Assisted Worker
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Add a Primary Principal</LI>
	 * <LI>Add 2nd  Primary Principal</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that test thows an Exception , that 2nd primary principal cannot be
	 * added</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*

	@Test (expectedExceptions = ValidationException.class)
	public void testAddSecondEmployerPrimaryPrincipal()
			throws ServiceFailureException, ValidationException {

		EmployerContact[] contacts = new EmployerContact[1];
		EmployerContact contact = createEmployerContact("James", "Bond",
				"1135468700", EmployerContactType.PrimaryPrincipal);
		contacts[0] = contact;
		// Add a Primary Contact
		EmployerContact[] saveContacts = sEmployerService.addEmployerContacts(contacts);
		verifyEmployerContacts(contacts,saveContacts, true);
		
		EmployerContact[] contacts1 = new EmployerContact[1];
		EmployerContact contact1 = createEmployerContact("Peter", "Parker",
				"1135468711", EmployerContactType.PrimaryPrincipal);
		contacts1[0] = contact1;
		// Add a Primary Contact
		sEmployerService.addEmployerContacts(contacts1);
		
		}




	*//**
	 * <P>
	 * Test Save Secondary Contact
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create Employer Contact with owner set to false ( Secondary Contact )
	 * </LI>
	 * <LI>Create the array of Employer Contact</LI>
	 * <LI>Call addEmployerContact() of EmployerService</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that Saved secondary contact is same as the one passed in
	 * addEmployerContact by calling verifyEmployerContacts</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*

	@Test
	public void testSaveEmployerSecondaryContact()
			throws ServiceFailureException, ValidationException {

		EmployerContact[] contacts = new EmployerContact[1];
		EmployerContact contact = createEmployerContact("Quincy", "Jones",
				"1234567890", EmployerContactType.SecondaryContact);
		contact.setOwner(false);
		contacts[0] = contact;
		EmployerContact[] saveContacts = sEmployerService
				.addEmployerContacts(contacts);
		verifyEmployerContacts(contacts,saveContacts, true);
		
		}

	*//**
	 * <P>
	 * Test delete Secondary Contact for Assisted Worker
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Add a Secondary Contact to Delete</LI>
	 * <LI>Get the Contact Ids of Saved Secondary Contact to Delete</LI>
	 * <LI>Delete the Secondary Contact by calling the deleteEmployerContacts()
	 * passing the contact ids</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that secondary contact gets deleted</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*

	@Test
	public void testDeleteEmployerSecondaryContact()
			throws ServiceFailureException, ValidationException {

		EmployerContact[] contacts = new EmployerContact[2];
		EmployerContact contact_1 = createEmployerContact("Al", "Pacino",
				"1112223456", EmployerContactType.SecondaryContact); // to delete
		EmployerContact contact_2= createEmployerContact("Albert", "Einstein",
				"872-897-8798", EmployerContactType.SecondaryContact);
		
		contacts[0] = contact_1;
		contacts[1] = contact_2;
		
		EmployerContact[] saveContacts = sEmployerService
				.addEmployerContacts(contacts);
		
		verifyEmployerContacts(contacts,saveContacts, true);
		
		ArrayList<EmployerContact> idList = new ArrayList<EmployerContact>();

		for (EmployerContact contact1 : saveContacts) {
			
				if (contact1.getFirstName().equals("Al")
						&& contact1.getLastName()
								.equals("Pacino")
						&& contact1.getPhone().equals("1112223456")) {
					idList.add(contact1);
				}
			

		}
		EmployerContact[] empContacts = (EmployerContact[]) idList.toArray(new EmployerContact[0]);
		sEmployerService.deleteEmployerContacts(empContacts);
		verifyEmployerContactsDelete(empContacts);
		
	}
	
	
	*//**
	 * <P>
	 * Test delete Secondary Contact for Assisted Worker
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Add a Secondary Contact to Delete</LI>
	 * <LI>Get the Contact Ids of Saved Secondary Contact to Delete</LI>
	 * <LI>Delete the Secondary Contact by calling the deleteEmployerContacts()
	 * passing the contact ids</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that secondary contact gets deleted</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*

	@Test(enabled=false,expectedExceptions = ValidationException.class) // IP001103
	public void testDeleteEmployerContactNullUniqueId()
			throws ServiceFailureException, ValidationException {

		EmployerContact[] contacts = new EmployerContact[1];
		EmployerContact contact = createEmployerContact("Al", "Pacino",
				"1112223456", EmployerContactType.SecondaryContact);
		contacts[0] = contact;
		EmployerContact[] saveContacts = sEmployerService
				.addEmployerContacts(contacts);
		verifyEmployerContacts(contacts,saveContacts, true);
		
		ArrayList<EmployerContact> idList = new ArrayList<EmployerContact>();

		for (EmployerContact contact1 : contacts) {
			for (EmployerContact contact2 : saveContacts) {
				if (contact1.getFirstName().equals(contact2.getFirstName())
						&& contact1.getLastName()
								.equals(contact2.getLastName())
						&& contact1.getPhone().equals(contact2.getPhone())) {
					contact2.setObjectHandle(null);
					idList.add(contact2);
				}
			}

		}
		EmployerContact[] empContacts = (EmployerContact[]) idList.toArray(new EmployerContact[0]);
		sEmployerService.deleteEmployerContacts(empContacts);
		
		
	}



	*//**
	 * <P>
	 * Test Save Primary Contact with empty First Name
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create Employer Contact with owner set to true and First Name set to
	 * ""</LI>
	 * <LI>Create the array of Employer Contact with above employer contact as
	 * the element</LI>
	 * <LI>Call addEmployerContact() of EmployerService</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that ValidationException is thrown</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*

	@Test(expectedExceptions = ValidationException.class)
	public void testSaveEmployerPrimaryContactWithoutFName()
			throws ServiceFailureException, ValidationException {
		
		EmployerContact contact = createEmployerContact("Bob", "Smith", "415-999-1212",	EmployerContactType.PrimaryContact);

		EmployerContact[] contacts = new EmployerContact[1];
		contact.setFirstName("");
		contacts[0] = contact;
		sEmployerService.addEmployerContacts(contacts);

	}

	*//**
	 * <P>
	 * Test Save Primary Contact with Null First Name
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create Employer Contact with owner set to true and First Name set to
	 * null</LI>
	 * <LI>Create the array of Employer Contact with above employer contact as
	 * the element</LI>
	 * <LI>Call addEmployerContact() of EmployerService</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that ValidationException is thrown</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*

	@Test(expectedExceptions = ValidationException.class)
	public void testSaveEmployerPrimaryContactWithNullFName()
			throws ServiceFailureException, ValidationException {
		EmployerContact contact = createEmployerContact("Bob", "Smith", "415-999-1212",	EmployerContactType.PrimaryContact);

		EmployerContact[] contacts = new EmployerContact[1];
		contact.setFirstName(null);
		contacts[0] = contact;
		sEmployerService.addEmployerContacts(contacts);

	}

	*//**
	 * <P>
	 * Test Save Primary Contact with empty Last Name
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create Employer Contact with owner set to true and Last Name set to
	 * empty</LI>
	 * <LI>Create the array of Employer Contact with above employer contact as
	 * the element</LI>
	 * <LI>Call addEmployerContact() of EmployerService</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that ValidationException is thrown</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*

	@Test(expectedExceptions = ValidationException.class)
	public void testSaveEmployerPrimaryContactWithoutLName()
			throws ServiceFailureException, ValidationException {

		EmployerContact contact = createEmployerContact("Bob", "Smith", "415-999-1212",	EmployerContactType.PrimaryContact);
		EmployerContact[] contacts = new EmployerContact[1];
		contact.setLastName("");
		contacts[0] = contact;
		sEmployerService.addEmployerContacts(contacts);

	}

	*//**
	 * <P>
	 * Test Save Primary Contact with empty Last Name
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create Employer Contact with owner set to true and Last Name set to
	 * null</LI>
	 * <LI>Create the array of Employer Contact with above employer contact as
	 * the element</LI>
	 * <LI>Call addEmployerContact() of EmployerService</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that ValidationException is thrown</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*

	@Test(expectedExceptions = ValidationException.class)
	public void testSaveEmployerPrimaryContactWithNullLName()
			throws ServiceFailureException, ValidationException {
		
		EmployerContact contact = createEmployerContact("Bob", "Smith", "415-999-1212",	EmployerContactType.PrimaryContact);
		EmployerContact[] contacts = new EmployerContact[1];
		contact.setLastName(null);
		contacts[0] = contact;
		sEmployerService.addEmployerContacts(contacts);

	}

	*//**
	 * <P>
	 * Test Save Primary Contact with empty Title
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create Employer Contact with owner set to true and Title set to empty
	 * </LI>
	 * <LI>Create the array of Employer Contact with above employer contact as
	 * the element</LI>
	 * <LI>Call addEmployerContact() of EmployerService</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that ValidationException is thrown</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*

	@Test(expectedExceptions = ValidationException.class)
	public void testSaveEmployerPrimaryContactWithoutTitle()
			throws ServiceFailureException, ValidationException {
		
		EmployerContact contact = createEmployerContact("Bob", "Smith", "415-999-1212",	EmployerContactType.PrimaryContact);
		EmployerContact[] contacts = new EmployerContact[1];
		contact.setTitle("");
		contacts[0] = contact;
		sEmployerService.addEmployerContacts(contacts);

	}

	*//**
	 * <P>
	 * Test Save Primary Contact with null Title
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create Employer Contact with owner set to true and Title set to null</LI>
	 * <LI>Create the array of Employer Contact with above employer contact as
	 * the element</LI>
	 * <LI>Call addEmployerContact() of EmployerService</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that ValidationException is thrown</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*

	@Test(expectedExceptions = ValidationException.class)
	public void testSaveEmployerPrimaryContactWithNullTitle()
			throws ServiceFailureException, ValidationException {
		EmployerContact contact = createEmployerContact("Bob", "Smith", "415-999-1212",	EmployerContactType.PrimaryContact);
		EmployerContact[] contacts = new EmployerContact[1];
		contact.setTitle(null);
		contacts[0] = contact;
		sEmployerService.addEmployerContacts(contacts);

	}

	*//**
	 * <P>
	 * Test Save Primary Contact with empty Phone
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create Employer Contact with owner set to true and Phone set to empty
	 * string</LI>
	 * <LI>Create the array of Employer Contact with above employer contact as
	 * the element</LI>
	 * <LI>Call addEmployerContact() of EmployerService</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that ValidationException is thrown</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*

	@Test(expectedExceptions = ValidationException.class)
	public void testSaveEmployerPrimaryContactWithoutPhone()
			throws ServiceFailureException, ValidationException {
		EmployerContact contact = createEmployerContact("Bob", "Smith", "415-999-1212",	EmployerContactType.PrimaryContact);
		EmployerContact[] contacts = new EmployerContact[1];
		contact.setPhone("");
		contacts[0] = contact;
		sEmployerService.addEmployerContacts(contacts);
	}

	*//**
	 * <P>
	 * Test Save Primary Contact with null Phone number
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create Employer Contact with owner set to true and Phone set to null</LI>
	 * <LI>Create the array of Employer Contact with above employer contact as
	 * the element</LI>
	 * <LI>Call addEmployerContact() of EmployerService</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that ValidationException is thrown</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*

	@Test(expectedExceptions = ValidationException.class)
	public void testSaveEmployerPrimaryContactWithNullPhone()
			throws ServiceFailureException, ValidationException {
		EmployerContact contact = createEmployerContact("Bob", "Smith", "415-999-1212",	EmployerContactType.PrimaryContact);
		EmployerContact[] contacts = new EmployerContact[1];
		contact.setPhone(null);
		contacts[0] = contact;
		sEmployerService.addEmployerContacts(contacts);
	}

	*//**
	 * <P>
	 * Test Save Primary Contact with invalid Phone number
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create Employer Contact with owner set to true and Phone with invalid
	 * format</LI>
	 * <LI>Create the array of Employer Contact with above employer contact as
	 * the element</LI>
	 * <LI>Call addEmployerContact() of EmployerService</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that ValidationException is thrown</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*

	@Test(expectedExceptions = ValidationException.class)
	public void testSaveEmployerPrimaryContactWithInvalidPhone()
			throws ServiceFailureException, ValidationException {
		EmployerContact contact = createEmployerContact("Bob", "Smith", "415-999-1212",	EmployerContactType.PrimaryContact);
		EmployerContact[] contacts = new EmployerContact[1];
		contact.setPhone("1234");
		contacts[0] = contact;
		sEmployerService.addEmployerContacts(contacts);

	}

	*//**
	 * <P>
	 * Test Save Primary Contact with email as empty string
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create Employer Contact with owner set to true and email with empty
	 * string</LI>
	 * <LI>Create the array of Employer Contact with above employer contact as
	 * the element</LI>
	 * <LI>Call addEmployerContact() of EmployerService</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that ValidationException is thrown</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*

	@Test(expectedExceptions = ValidationException.class)
	public void testSaveEmployerPrimaryContactWithoutEmail()
			throws ServiceFailureException, ValidationException {
		EmployerContact contact = createEmployerContact("Bob", "Smith", "415-999-1212",	EmployerContactType.PrimaryContact);
		EmployerContact[] contacts = new EmployerContact[1];
		contact.setEmail("");
		contacts[0] = contact;
		sEmployerService.addEmployerContacts(contacts);
	}

	*//**
	 * <P>
	 * Test Save Primary Contact with email as null
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create Employer Contact with owner set to true and email as null</LI>
	 * <LI>Create the array of Employer Contact with above employer contact as
	 * the element</LI>
	 * <LI>Call addEmployerContact() of EmployerService</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that ValidationException is thrown</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*

	@Test(expectedExceptions = ValidationException.class)
	public void testSaveEmployerPrimaryContactWithNullEmail()
			throws ServiceFailureException, ValidationException {
		EmployerContact contact = createEmployerContact("Bob", "Smith", "415-999-1212",	EmployerContactType.PrimaryContact);
		EmployerContact[] contacts = new EmployerContact[1];
		contact.setEmail(null);
		contacts[0] = contact;
		sEmployerService.addEmployerContacts(contacts);
	}

	*//**
	 * <P>
	 * Test Save Primary Contact with invalid email format
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create Employer Contact with owner set to true and invalid email
	 * format</LI>
	 * <LI>Create the array of Employer Contact with above employer contact as
	 * the element</LI>
	 * <LI>Call addEmployerContact() of EmployerService</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that ValidationException is thrown</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*

	@Test(expectedExceptions = ValidationException.class)
	public void testSaveEmployerPrimaryContactWithInvalidEmail()
			throws ServiceFailureException, ValidationException {
		EmployerContact contact = createEmployerContact("Bob", "Smith", "415-999-1212",	EmployerContactType.PrimaryContact);
		EmployerContact[] contacts = new EmployerContact[1];
		contact.setEmail("bobsmithatsmithdotcom");
		contacts[0] = contact;
		sEmployerService.addEmployerContacts(contacts);

	}

    
	 *//**
	    * <P>Test Update Primary contact of the Assisted Employer</P>
	    * <H3>Steps:</H3>
	    * <OL>
	    * <LI>Create a Primary Contact </LI>
	    * <LI>Save the Primary Contact</LI>
	    * <LI>Verify that Primary Contact is saved properly</LI>
	    * <LI>Fetch the saved Primary Contact</LI>
	    * <LI>Update the fetched Primary Contact with new values for FName , LName Phone and Title</LI>
	    * <LI>Call addEmployerContacts passing modified employer contact as parameter</LI>
	    * </OL>
	    * <UL>
	    * <LI>Verify that Primary contact gets saved(updated) as expected</LI>
	    * </UL>
	    * @throws ValidationException 
		 * @throws ServiceFailureException
	    *//*

		
		@Test
		public void testUpdateEmployerPrimaryContact() throws ServiceFailureException, ValidationException{
			
			int contactLength = sEmployerService.getEmployerContacts().length;
		
			
			EmployerContact [] empcontacts = new EmployerContact[]{createEmployerContact("Dany", "Boyle", "415-999-1212", 
								EmployerContactType.PrimaryContact)};
			EmployerContact [] savedcontacts = sEmployerService.addEmployerContacts(empcontacts);
			AssertJUnit.assertTrue(sEmployerService.getEmployerContacts().length == contactLength+1);
			verifyEmployerContacts(empcontacts,savedcontacts,true);
			

			EmployerContact[] empcontactToUpdate = new EmployerContact[1];


			for(int i = 0;i < savedcontacts.length ;i++){
				if(savedcontacts[i].getFirstName().equals("Dany") &&savedcontacts[i].getLastName().equals("Boyle") && savedcontacts[i].getPhone().equals("415-999-1212")){
					empcontactToUpdate[0] = savedcontacts[i];
					break;
				}
			}

			empcontactToUpdate[0].setFirstName("New Dany");
			empcontactToUpdate[0].setLastName("New Boyle");
			empcontactToUpdate[0].setPhone("1234567781");
			empcontactToUpdate[0].setTitle("New Mr");
			
			EmployerContact[] contactsFromDB = sEmployerService.updateEmployerContacts(empcontactToUpdate);
			verifyEmployerContacts(empcontactToUpdate,contactsFromDB,false);
			
		}
		
		
		
		 *//**
		    * <P>Test Update Primary contact of the Assisted Employer with First Name as empty string</P>
		    * <H3>Steps:</H3>
		    * <OL>
		    * <LI>Create a Primary Contact </LI>
		    * <LI>Save the Primary Contact</LI>
		    * <LI>Verify that Primary Contact is saved properly</LI>
		    * <LI>Fetch the saved Primary Contact</LI>
		    * <LI>Update the fetched Primary Contact with empty string as First Name</LI>
		    * <LI>Call addEmployerContacts passing modified employer contact as parameter</LI>
		    * </OL>
		    * <UL>
		    * <LI>Verify that ValidationException is thrown</LI>
		    * </UL>
		    * @throws ValidationException 
			 * @throws ServiceFailureException
		 *//*
		
		@Test
		public void testUpdateEmployerPrimaryContactWithoutFName() throws ServiceFailureException, ValidationException{
			
			int contactLength = sEmployerService.getEmployerContacts().length;
			
			EmployerContact [] empcontacts = new EmployerContact[]{createEmployerContact("Benjamin", "Button", "212-888-5412",
					EmployerContactType.PrimaryContact)};
			EmployerContact [] savedcontacts = sEmployerService.addEmployerContacts(empcontacts);
			AssertJUnit.assertTrue(sEmployerService.getEmployerContacts().length == contactLength+1);
			verifyEmployerContacts(empcontacts,savedcontacts,true);
			
			EmployerContact[] empcontactToUpdate = new EmployerContact[1];

			for(int i = 0;i < savedcontacts.length ;i++){
				if(savedcontacts[i].getEmployerContactType().equals(EmployerContactType.PrimaryContact) && savedcontacts[i].getPhone().equals("212-888-5412")){
					empcontactToUpdate[0] = savedcontacts[i];
					break;
				}
			}

			empcontactToUpdate[0].setFirstName("");
			
			try{
			
				sEmployerService.updateEmployerContacts(empcontactToUpdate);
				sEmployerService.deleteEmployerContacts(empcontactToUpdate);
				AssertJUnit.fail("Expected ValidationException is not thrown for empty First Name");
			}
			catch(ValidationException e){
				
			}
			
		}
		
		 *//**
		    * <P>Test Update Primary contact of the Assisted Employer with null First Name </P>
		    * <H3>Steps:</H3>
		    * <OL>
		    * <LI>Create a Primary Contact </LI>
		    * <LI>Save the Primary Contact</LI>
		    * <LI>Verify that Primary Contact is saved properly</LI>
		    * <LI>Fetch the saved Primary Contact</LI>
		    * <LI>Update the fetched Primary Contact with null as First Name</LI>
		    * <LI>Call addEmployerContacts passing modified employer contact as parameter</LI>
		    * </OL>
		    * <UL>
		    * <LI>Verify that ValidationException is thrown</LI>
		    * </UL>
		    * @throws ValidationException 
			 * @throws ServiceFailureException
		 *//*

		@Test
		public void testUpdateEmployerPrimaryContactWithNullFName() throws ServiceFailureException, ValidationException{
			
			int contactLength = sEmployerService.getEmployerContacts().length;
			
			EmployerContact [] empcontacts = new EmployerContact[]{createEmployerContact("Benjamin", "Button", "212-888-5412",
									EmployerContactType.PrimaryContact)};
			EmployerContact [] savedcontacts = sEmployerService.addEmployerContacts(empcontacts);
			AssertJUnit.assertTrue(sEmployerService.getEmployerContacts().length == contactLength+1);
			verifyEmployerContacts(empcontacts,savedcontacts,true);
			
			EmployerContact[] empcontactToUpdate = new EmployerContact[1];

			for(int i = 0;i < savedcontacts.length ;i++){
				if(savedcontacts[i].getEmployerContactType().equals(EmployerContactType.PrimaryContact) && savedcontacts[i].getPhone().equals("212-888-5412")){
					empcontactToUpdate[0] = savedcontacts[i];
					break;
				}
			}

			empcontactToUpdate[0].setFirstName(null);
			
			try{
			
				sEmployerService.updateEmployerContacts(empcontactToUpdate);
				sEmployerService.deleteEmployerContacts(empcontactToUpdate);
				AssertJUnit.fail("Expected ValidationException is not thrown for Null First Name");
			}
			catch(ValidationException e){
				
			}

		}
		
		 *//**
		    * <P>Test Update Primary contact of the Assisted Employer with Last Name as empty string</P>
		    * <H3>Steps:</H3>
		    * <OL>
		    * <LI>Create a Primary Contact </LI>
		    * <LI>Save the Primary Contact</LI>
		    * <LI>Verify that Primary Contact is saved properly</LI>
		    * <LI>Fetch the saved Primary Contact</LI>
		    * <LI>Update the fetched Primary Contact with Last Name  empty string</LI>
		    * <LI>Call addEmployerContacts passing modified employer contact as parameter</LI>
		    * </OL>
		    * <UL>
		    * <LI>Verify that ValidationException is thrown</LI>
		    * </UL>
		    * @throws ValidationException 
			 * @throws ServiceFailureException
		 *//*

		
		@Test
		public void testUpdateEmployerPrimaryContactWithoutLName() throws ServiceFailureException, ValidationException{

			int contactLength = sEmployerService.getEmployerContacts().length;
			
			EmployerContact [] empcontacts = new EmployerContact[]{createEmployerContact("Benjamin", "Button", "212-888-5241",
					EmployerContactType.PrimaryContact)};
			EmployerContact [] savedcontacts = sEmployerService.addEmployerContacts(empcontacts);
			AssertJUnit.assertTrue(sEmployerService.getEmployerContacts().length == contactLength+1);
			verifyEmployerContacts(empcontacts,savedcontacts,true);
			
			EmployerContact[] empcontactToUpdate = new EmployerContact[1];

			for(int i = 0;i < savedcontacts.length ;i++){
				if(savedcontacts[i].getEmployerContactType().equals(EmployerContactType.PrimaryContact) && savedcontacts[i].getPhone().equals("212-888-5241")){
					empcontactToUpdate[0] = savedcontacts[i];
					break;
				}
			}

			empcontactToUpdate[0].setLastName("");
			
			try{
			
				sEmployerService.updateEmployerContacts(empcontactToUpdate);
				sEmployerService.deleteEmployerContacts(empcontactToUpdate);
				AssertJUnit.fail("Expected ValidationException is not thrown for empty Last Name");
			}
			catch(ValidationException e){
				
			}
		}
		
		 *//**
		    * <P>Test Update Primary contact of the Assisted Employer with null  Last Name</P>
		    * <H3>Steps:</H3>
		    * <OL>
		    * <LI>Create a Primary Contact </LI>
		    * <LI>Save the Primary Contact</LI>
		    * <LI>Verify that Primary Contact is saved properly</LI>
		    * <LI>Fetch the saved Primary Contact</LI>
		    * <LI>Update the fetched Primary Contact with null Last Name</LI>
		    * <LI>Call addEmployerContacts passing modified employer contact as parameter</LI>
		    * </OL>
		    * <UL>
		    * <LI>Verify that ValidationException is thrown</LI>
		    * </UL>
		    * @throws ValidationException 
			 * @throws ServiceFailureException
		 *//*

		@Test
		public void testUpdateEmployerPrimaryContactWithNullLName() throws ServiceFailureException, ValidationException{

			int contactLength = sEmployerService.getEmployerContacts().length;
			EmployerContact [] empcontacts = new EmployerContact[]{createEmployerContact("Benjamin", "Button", "212-888-2541",
									EmployerContactType.PrimaryContact)};
			EmployerContact [] savedcontacts = sEmployerService.addEmployerContacts(empcontacts);
			AssertJUnit.assertTrue(sEmployerService.getEmployerContacts().length == contactLength+1);
			verifyEmployerContacts(empcontacts,savedcontacts,true);
			
			EmployerContact[] empcontactToUpdate = new EmployerContact[1];

			for(int i = 0;i < savedcontacts.length ;i++){
				if(savedcontacts[i].getEmployerContactType().equals(EmployerContactType.PrimaryContact) && savedcontacts[i].getPhone().equals("212-888-2541")){
					empcontactToUpdate[0] = savedcontacts[i];
					break;
				}
			}

			empcontactToUpdate[0].setLastName(null);
			
			try{
			
				sEmployerService.updateEmployerContacts(empcontactToUpdate);
				sEmployerService.deleteEmployerContacts(empcontactToUpdate);
				AssertJUnit.fail("Expected ValidationException is not thrown for Null Last Name");
			}
			catch(ValidationException e){
				
			}
			
		}
		
		 *//**
		    * <P>Test Update Primary contact of the Assisted Employer with Title as empty string</P>
		    * <H3>Steps:</H3>
		    * <OL>
		    * <LI>Create a Primary Contact </LI>
		    * <LI>Save the Primary Contact</LI>
		    * <LI>Verify that Primary Contact is saved properly</LI>
		    * <LI>Fetch the saved Primary Contact</LI>
		    * <LI>Update the fetched Primary Contact with Title as empty string</LI>
		    * <LI>Call addEmployerContacts passing modified employer contact as parameter</LI>
		    * </OL>
		    * <UL>
		    * <LI>Verify that ValidationException is thrown</LI>
		    * </UL>
		    * @throws ValidationException 
			 * @throws ServiceFailureException
		 *//*

		@Test
		public void testUpdateEmployerPrimaryContactWithoutTitle() throws ServiceFailureException, ValidationException{

			int contactLength = sEmployerService.getEmployerContacts().length;
			EmployerContact [] empcontacts = new EmployerContact[]{createEmployerContact("Benjamin", "Button", "212-888-3541",
											EmployerContactType.PrimaryContact)};
			EmployerContact [] savedcontacts = sEmployerService.addEmployerContacts(empcontacts);
			AssertJUnit.assertTrue(sEmployerService.getEmployerContacts().length == contactLength+1);
			verifyEmployerContacts(empcontacts,savedcontacts,true);
			
			EmployerContact[] empcontactToUpdate = new EmployerContact[1];

			for(int i = 0;i < savedcontacts.length ;i++){
				if(savedcontacts[i].getEmployerContactType().equals(EmployerContactType.PrimaryContact) && savedcontacts[i].getPhone().equals("212-888-3541")){
					empcontactToUpdate[0] = savedcontacts[i];
					break;
				}
			}

			empcontactToUpdate[0].setTitle("");
			
			try{
			
				sEmployerService.updateEmployerContacts(empcontactToUpdate);
				sEmployerService.deleteEmployerContacts(empcontactToUpdate);
				AssertJUnit.fail("Expected ValidationException is not thrown for empty Title ");
			}
			catch(ValidationException e){
				
			}

		}
		
		 *//**
		    * <P>Test Update Primary contact of the Assisted Employer with null Title</P>
		    * <H3>Steps:</H3>
		    * <OL>
		    * <LI>Create a Primary Contact </LI>
		    * <LI>Save the Primary Contact</LI>
		    * <LI>Verify that Primary Contact is saved properly</LI>
		    * <LI>Fetch the saved Primary Contact</LI>
		    * <LI>Update the fetched Primary Contact with null Title</LI>
		    * <LI>Call addEmployerContacts passing modified employer contact as parameter</LI>
		    * </OL>
		    * <UL>
		    * <LI>Verify that ValidationException is thrown</LI>
		    * </UL>
		    * @throws ValidationException 
			 * @throws ServiceFailureException
		 *//*

		
		@Test
		public void testUpdateEmployerPrimaryContactWithNullTitle() throws ServiceFailureException, ValidationException{
			
			int contactLength = sEmployerService.getEmployerContacts().length;
			EmployerContact [] empcontacts = new EmployerContact[]{createEmployerContact("Benjamin", "Button", "212-888-5341",
									EmployerContactType.PrimaryContact)};
			EmployerContact [] savedcontacts = sEmployerService.addEmployerContacts(empcontacts);
			AssertJUnit.assertTrue(sEmployerService.getEmployerContacts().length == contactLength+1);
			verifyEmployerContacts(empcontacts,savedcontacts,true);
			
			EmployerContact[] empcontactToUpdate = new EmployerContact[1];

			for(int i = 0;i < savedcontacts.length ;i++){
				if(savedcontacts[i].getEmployerContactType().equals(EmployerContactType.PrimaryContact) && savedcontacts[i].getPhone().equals("212-888-5341")){
					empcontactToUpdate[0] = savedcontacts[i];
					break;
				}
			}

			empcontactToUpdate[0].setTitle(null);
			
			try{
			
				sEmployerService.updateEmployerContacts(empcontactToUpdate);
				sEmployerService.deleteEmployerContacts(empcontactToUpdate);
				AssertJUnit.fail("Expected ValidationException is not thrown for Null Title");
			}
			catch(ValidationException e){
				
			}
		}
		
		 *//**
		    * <P>Test Update Primary contact of the Assisted Employer with Phone number as empty string</P>
		    * <H3>Steps:</H3>
		    * <OL>
		    * <LI>Create a Primary Contact </LI>
		    * <LI>Save the Primary Contact</LI>
		    * <LI>Verify that Primary Contact is saved properly</LI>
		    * <LI>Fetch the saved Primary Contact</LI>
		    * <LI>Update the fetched Primary Contact with Phonenumber as empty string</LI>
		    * <LI>Call addEmployerContacts passing modified employer contact as parameter</LI>
		    * </OL>
		    * <UL>
		    * <LI>Verify that ValidationException is thrown</LI>
		    * </UL>
		    * @throws ValidationException 
			 * @throws ServiceFailureException
		 *//*


		@Test
		public void testUpdateEmployerPrimaryContactWithoutPhone() throws ServiceFailureException, ValidationException{

			int contactLength = sEmployerService.getEmployerContacts().length;
			EmployerContact [] empcontacts = new EmployerContact[]{createEmployerContact("Benjamin", "Button", "212-888-5441",
					EmployerContactType.PrimaryContact)};
			EmployerContact [] savedcontacts = sEmployerService.addEmployerContacts(empcontacts);
			AssertJUnit.assertTrue(sEmployerService.getEmployerContacts().length == contactLength+1);
			verifyEmployerContacts(empcontacts,savedcontacts,true);
			
			EmployerContact[] empcontactToUpdate = new EmployerContact[1];

			for(int i = 0;i < savedcontacts.length ;i++){
				if(savedcontacts[i].getEmployerContactType().equals(EmployerContactType.PrimaryContact) && savedcontacts[i].getPhone().equals("212-888-5441")){
					empcontactToUpdate[0] = savedcontacts[i];
					break;
				}
			}

			empcontactToUpdate[0].setPhone("");
			
			try{
			
				sEmployerService.updateEmployerContacts(empcontactToUpdate);
				sEmployerService.deleteEmployerContacts(empcontactToUpdate);
				AssertJUnit.fail("Expected ValidationException is not thrown for empty Phone");
			}
			catch(ValidationException e){
				
			}
		}
		
		
		 *//**
		    * <P>Test Update Primary contact of the Assisted Employer with null Phone Number</P>
		    * <H3>Steps:</H3>
		    * <OL>
		    * <LI>Create a Primary Contact </LI>
		    * <LI>Save the Primary Contact</LI>
		    * <LI>Verify that Primary Contact is saved properly</LI>
		    * <LI>Fetch the saved Primary Contact</LI>
		    * <LI>Update the fetched Primary Contact with Null Phone number</LI>
		    * <LI>Call addEmployerContacts passing modified employer contact as parameter</LI>
		    * </OL>
		    * <UL>
		    * <LI>Verify that ValidationException is thrown</LI>
		    * </UL>
		    * @throws ValidationException 
			 * @throws ServiceFailureException
		 *//*

		@Test
		public void testUpdateEmployerPrimaryContactWithNullPhone() throws ServiceFailureException, ValidationException{
			
			int contactLength = sEmployerService.getEmployerContacts().length;
			EmployerContact [] empcontacts = new EmployerContact[]{createEmployerContact("Benjamin", "Button", "212-888-5441",
					EmployerContactType.PrimaryContact)};
			EmployerContact [] savedcontacts = sEmployerService.addEmployerContacts(empcontacts);
			AssertJUnit.assertTrue(sEmployerService.getEmployerContacts().length == contactLength+1);
			verifyEmployerContacts(empcontacts,savedcontacts,true);
			
			EmployerContact[] empcontactToUpdate = new EmployerContact[1];

			for(int i = 0;i < savedcontacts.length ;i++){
				if(savedcontacts[i].getEmployerContactType().equals(EmployerContactType.PrimaryContact) && savedcontacts[i].getPhone().equals("212-888-5441")){
					empcontactToUpdate[0] = savedcontacts[i];
					break;
				}
			}

			empcontactToUpdate[0].setPhone(null);
			
			try{
			
				sEmployerService.updateEmployerContacts(empcontactToUpdate);
				sEmployerService.deleteEmployerContacts(empcontactToUpdate);
				AssertJUnit.fail("Expected ValidationException is not thrown for null Phone");
			}
			catch(ValidationException e){
				
			}

		}
		
		
		 *//**
		    * <P>Test Update Primary contact of the Assisted Employer with Invalid Phone number format</P>
		    * <H3>Steps:</H3>
		    * <OL>
		    * <LI>Create a Primary Contact </LI>
		    * <LI>Save the Primary Contact</LI>
		    * <LI>Verify that Primary Contact is saved properly</LI>
		    * <LI>Fetch the saved Primary Contact</LI>
		    * <LI>Update the fetched Primary Contact with invalid phone number format</LI>
		    * <LI>Call addEmployerContacts passing modified employer contact as parameter</LI>
		    * </OL>
		    * <UL>
		    * <LI>Verify that ValidationException is thrown</LI>
		    * </UL>
		    * @throws ValidationException 
			 * @throws ServiceFailureException
		 *//*

		
		@Test
		public void testUpdateEmployerPrimaryContactWithInvalidPhone() throws ServiceFailureException, ValidationException{
			int contactLength = sEmployerService.getEmployerContacts().length;
			EmployerContact [] empcontacts = new EmployerContact[]{createEmployerContact("Benjamin", "Button", "212-888-5441",
					EmployerContactType.PrimaryContact)};
			EmployerContact [] savedcontacts = sEmployerService.addEmployerContacts(empcontacts);
			AssertJUnit.assertTrue(sEmployerService.getEmployerContacts().length == contactLength+1);
			verifyEmployerContacts(empcontacts,savedcontacts,true);
			
			EmployerContact[] empcontactToUpdate = new EmployerContact[1];

			for(int i = 0;i < savedcontacts.length ;i++){
				if(savedcontacts[i].getEmployerContactType().equals(EmployerContactType.PrimaryContact) && savedcontacts[i].getPhone().equals("212-888-5441")){
					empcontactToUpdate[0] = savedcontacts[i];
					break;
				}
			}

			empcontactToUpdate[0].setPhone("1234");
			
			try{
			
				sEmployerService.updateEmployerContacts(empcontactToUpdate);
				sEmployerService.deleteEmployerContacts(empcontactToUpdate);
				AssertJUnit.fail("Expected ValidationException is not thrown for invalid phone number");
			}
			catch(ValidationException e){
				
			}

		}
		
		 *//**
		    * <P>Test Update Primary contact of the Assisted Employer with email as empty string</P>
		    * <H3>Steps:</H3>
		    * <OL>
		    * <LI>Create a Primary Contact </LI>
		    * <LI>Save the Primary Contact</LI>
		    * <LI>Verify that Primary Contact is saved properly</LI>
		    * <LI>Fetch the saved Primary Contact</LI>
		    * <LI>Update the fetched Primary Contact with empty string as First email as empty string</LI>
		    * <LI>Call addEmployerContacts passing modified employer contact as parameter</LI>
		    * </OL>
		    * <UL>
		    * <LI>Verify that ValidationException is thrown</LI>
		    * </UL>
		    * @throws ValidationException 
			 * @throws ServiceFailureException
		 *//*

		@Test
		public void testUpdateEmployerPrimaryContactWithoutEmail() throws ServiceFailureException, ValidationException{
			int contactLength = sEmployerService.getEmployerContacts().length;
			
			EmployerContact [] empcontacts = new EmployerContact[]{createEmployerContact("Benjamin", "Button", "212-888-5541",
					EmployerContactType.PrimaryContact)};
			EmployerContact [] savedcontacts = sEmployerService.addEmployerContacts(empcontacts);
			AssertJUnit.assertTrue(sEmployerService.getEmployerContacts().length == contactLength+1);
			verifyEmployerContacts(empcontacts,savedcontacts,true);
			
			EmployerContact[] empcontactToUpdate = new EmployerContact[1];

			for(int i = 0;i < savedcontacts.length ;i++){
				if(savedcontacts[i].getEmployerContactType().equals(EmployerContactType.PrimaryContact) && savedcontacts[i].getPhone().equals("212-888-5541")){
					empcontactToUpdate[0] = savedcontacts[i];
					break;
				}
			}

			empcontactToUpdate[0].setEmail("");
			
			try{
			
				sEmployerService.updateEmployerContacts(empcontactToUpdate);
				sEmployerService.deleteEmployerContacts(empcontactToUpdate);
				AssertJUnit.fail("Expected ValidationException is not thrown for empty email");
			}
			catch(ValidationException e){
				
			}

		}
		
		 *//**
		    * <P>Test Update Primary contact of the Assisted Employer with null email</P>
		    * <H3>Steps:</H3>
		    * <OL>
		    * <LI>Create a Primary Contact </LI>
		    * <LI>Save the Primary Contact</LI>
		    * <LI>Verify that Primary Contact is saved properly</LI>
		    * <LI>Fetch the saved Primary Contact</LI>
		    * <LI>Update the fetched Primary Contact with null email</LI>
		    * <LI>Call addEmployerContacts passing modified employer contact as parameter</LI>
		    * </OL>
		    * <UL>
		    * <LI>Verify that ValidationException is thrown</LI>
		    * </UL>
		    * @throws ValidationException 
			 * @throws ServiceFailureException
		 *//*

		
		@Test
		public void testUpdateEmployerPrimaryContactWithNullEmail() throws ServiceFailureException, ValidationException{
			int contactLength = sEmployerService.getEmployerContacts().length;
			
			EmployerContact [] empcontacts = new EmployerContact[]{createEmployerContact("Benjamin", "Button", "212-888-5641",
					EmployerContactType.PrimaryContact)};
			EmployerContact [] savedcontacts = sEmployerService.addEmployerContacts(empcontacts);
			AssertJUnit.assertTrue(sEmployerService.getEmployerContacts().length == contactLength+1);
			verifyEmployerContacts(empcontacts,savedcontacts,true);
			
			EmployerContact[] empcontactToUpdate = new EmployerContact[1];

			for(int i = 0;i < savedcontacts.length ;i++){
				if(savedcontacts[i].getEmployerContactType().equals(EmployerContactType.PrimaryContact) && savedcontacts[i].getPhone().equals("212-888-5641")){
					empcontactToUpdate[0] = savedcontacts[i];
					break;
				}
			}

			empcontactToUpdate[0].setEmail(null);
			
			try{
			
				sEmployerService.updateEmployerContacts(empcontactToUpdate);
				sEmployerService.deleteEmployerContacts(empcontactToUpdate);
				AssertJUnit.fail("Expected ValidationException is not thrown for null email");
			}
			catch(ValidationException e){
				
			}

		}
		
		 *//**
		    * <P>Test Update Primary contact of the Assisted Employer with invalid email</P>
		    * <H3>Steps:</H3>
		    * <OL>
		    * <LI>Create a Primary Contact </LI>
		    * <LI>Save the Primary Contact</LI>
		    * <LI>Verify that Primary Contact is saved properly</LI>
		    * <LI>Fetch the saved Primary Contact</LI>
		    * <LI>Update the fetched Primary Contact with invalid email</LI>
		    * <LI>Call addEmployerContacts passing modified employer contact as parameter</LI>
		    * </OL>
		    * <UL>
		    * <LI>Verify that ValidationException is thrown</LI>
		    * </UL>
		    * @throws ValidationException 
			 * @throws ServiceFailureException
		 *//*

		
		@Test
		public void testUpdateEmployerPrimaryContactWithInvalidEmail() throws ServiceFailureException, ValidationException{
			int contactLength = sEmployerService.getEmployerContacts().length;
			
			EmployerContact [] empcontacts = new EmployerContact[]{createEmployerContact("Benjamin", "Button", "212-888-5641",
					EmployerContactType.PrimaryContact)};
			EmployerContact [] savedcontacts = sEmployerService.addEmployerContacts(empcontacts);
			AssertJUnit.assertTrue(sEmployerService.getEmployerContacts().length == contactLength+1);
			verifyEmployerContacts(empcontacts,savedcontacts,true);
			
			EmployerContact[] empcontactToUpdate = new EmployerContact[1];

			for(int i = 0;i < savedcontacts.length ;i++){
				if(savedcontacts[i].getEmployerContactType().equals(EmployerContactType.PrimaryContact) && savedcontacts[i].getPhone().equals("212-888-5641")){
					empcontactToUpdate[0] = savedcontacts[i];
					break;
				}
			}

			empcontactToUpdate[0].setEmail("email");
			
			try{
			
				sEmployerService.updateEmployerContacts(empcontactToUpdate);
				sEmployerService.deleteEmployerContacts(empcontactToUpdate);
				AssertJUnit.fail("Expected ValidationException is not thrown for invalid email forma");
			}
			catch(ValidationException e){
				
			}
    
    
		}
}
*/