/*package com.intuit.sb.payroll.qa.services.employer;

import org.testng.annotations.Test;

import com.intuit.sb.payroll.ServiceFailureException;
import com.intuit.sb.payroll.ValidationException;
import com.intuit.sb.payroll.services.common.PhysicalAddress;
import com.intuit.sb.payroll.services.employer.AssistedStateType;
import com.intuit.sb.payroll.services.employer.EmployerInfo;
import com.intuit.sb.payroll.services.employer.EmployerServiceTestBase;
import com.intuit.sb.payroll.services.employer.SaveEmployerInfoRequest;
import com.intuit.sb.payroll.services.taxes.EmployerTaxIdInfo;

public class EmployerLegalInfoTest extends EmployerServiceTestBase {

	*//**
	 * <P>
	 * Test Save Employer Info with empty string as DBA name
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create a employer Info (setup)</LI>
	 * <LI>Set Company Name as empty string</LI>
	 * <LI>Call saveEmployerInfo passing modified employer info</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that ValidationException is thrown</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*
	@Test(expectedExceptions = ValidationException.class)
	public void testSaveEmployerInfoWithoutDBAName()
			throws ServiceFailureException, ValidationException {
		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		employerInfo.setDBAName("");
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	*//**
	 * <P>
	 * Test Save Employer Info with null DBA name
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create a employer Info (setup)</LI>
	 * <LI>Set Company Name as null</LI>
	 * <LI>Call saveEmployerInfo passing modified employer info</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that ValidationException is thrown</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*
	@Test(expectedExceptions = ValidationException.class)
	public void testSaveEmployerInfoWithNullDBAName()
			throws ServiceFailureException, ValidationException {

		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		employerInfo.setDBAName(null);
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	*//**
	 * <P>
	 * Test Save Employer Info with null Legal Address
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create a employer Info (setup)</LI>
	 * <LI>Set Legal Address as null</LI>
	 * <LI>Call saveEmployerInfo passing modified employer info</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that ValidationException is thrown</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*
	@Test(expectedExceptions = ValidationException.class)
	public void testSaveEmployerInfoWithNullLegalAddress()
			throws ServiceFailureException, ValidationException {
		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		employerInfo.setLegalAddress(null);
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	*//**
	 * <P>
	 * Test Save Employer Info - without Address Line 1 in Legal Address
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create a employer Info (setup)</LI>
	 * <LI>Set Legal Address without Address Line 1</LI>
	 * <LI>Call saveEmployerInfo passing modified employer info</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that ValidationException is thrown</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*
	@Test(expectedExceptions = ValidationException.class)
	public void testSaveEmployerInfoWithoutLegalAddressLine1()
			throws ServiceFailureException, ValidationException {
		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		PhysicalAddress legalAddress = createPhysicalAddress();
		legalAddress.setAddressLine1("");
		employerInfo.setLegalAddress(legalAddress);
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	*//**
	 * <P>
	 * Test Save Employer Info - with null Address Line 1 in Legal Address
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create a employer Info (setup)</LI>
	 * <LI>Set Legal Address with null Address Line 1</LI>
	 * <LI>Call saveEmployerInfo passing modified employer info</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that ValidationException is thrown</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*
	@Test(expectedExceptions = ValidationException.class)
	public void testSaveEmployerInfoWithNullLegalAddressLine1()
			throws ServiceFailureException, ValidationException {

		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		PhysicalAddress legalAddress = createPhysicalAddress();
		legalAddress.setAddressLine1(null);
		employerInfo.setLegalAddress(legalAddress);
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	*//**
	 * <P>
	 * Test Save Employer Info - without City in Legal Address
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create a employer Info (setup)</LI>
	 * <LI>Set Legal Address without City</LI>
	 * <LI>Call saveEmployerInfo passing modified employer info</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that ValidationException is thrown</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*
	@Test(expectedExceptions = ValidationException.class)
	public void testSaveEmployerInfoWithoutLegalCity()
			throws ServiceFailureException, ValidationException {

		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		PhysicalAddress legalAddress = createPhysicalAddress();
		legalAddress.setCity("");
		employerInfo.setLegalAddress(legalAddress);
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	*//**
	 * <P>
	 * Test Save Employer Info - with null City
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create a employer Info (setup)</LI>
	 * <LI>Set Legal Address with null City</LI>
	 * <LI>Call saveEmployerInfo passing modified employer info</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that ValidationException is thrown</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*
	@Test(expectedExceptions = ValidationException.class)
	public void testSaveEmployerInfoWithNullLegalCity()
			throws ServiceFailureException, ValidationException {

		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		PhysicalAddress legalAddress = createPhysicalAddress();
		legalAddress.setCity(null);
		employerInfo.setLegalAddress(legalAddress);
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	*//**
	 * <P>
	 * Test Save Employer Info - without State
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create a employer Info (setup)</LI>
	 * <LI>Set Legal Address without State</LI>
	 * <LI>Call saveEmployerInfo passing modified employer info</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that ValidationException is thrown</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*
	@Test(expectedExceptions = ValidationException.class)
	public void testSaveEmployerInfoWithoutLegalState()
			throws ServiceFailureException, ValidationException {

		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		PhysicalAddress legalAddress = createPhysicalAddress();
		legalAddress.setStateOrRegion("");
		employerInfo.setLegalAddress(legalAddress);
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	*//**
	 * <P>
	 * Test Save Employer Info - Null State
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create a employer Info (setup)</LI>
	 * <LI>Set Legal Address with null State</LI>
	 * <LI>Call saveEmployerInfo passing modified employer info</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that ValidationException is thrown</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*
	@Test(expectedExceptions = ValidationException.class)
	public void testSaveEmployerInfoWithNullLegalState()
			throws ServiceFailureException, ValidationException {

		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		PhysicalAddress legalAddress = createPhysicalAddress();
		legalAddress.setStateOrRegion(null);
		employerInfo.setLegalAddress(legalAddress);
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	*//**
	 * <P>
	 * Test Save Employer Info - without Zip
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create a employer Info (setup)</LI>
	 * <LI>Set Legal Address without Zip</LI>
	 * <LI>Call saveEmployerInfo passing modified employer info</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that ValidationException is thrown</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*
	@Test(expectedExceptions = ValidationException.class)
	public void testSaveEmployerInfoWithoutLegalZip()
			throws ServiceFailureException, ValidationException {

		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		PhysicalAddress legalAddress = createPhysicalAddress();
		legalAddress.setZipOrPostalCode("");
		employerInfo.setLegalAddress(legalAddress);
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	*//**
	 * <P>
	 * Test Save Employer Info - Null Zip
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create a employer Info (setup)</LI>
	 * <LI>Set Legal Address with Null</LI>
	 * <LI>Call saveEmployerInfo passing modified employer info</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that ValidationException is thrown</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*

	@Test(expectedExceptions = ValidationException.class)
	public void testSaveEmployerInfoWithNullLegalZip()
			throws ServiceFailureException, ValidationException {
		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		PhysicalAddress legalAddress = createPhysicalAddress();
		legalAddress.setZipOrPostalCode(null);
		employerInfo.setLegalAddress(legalAddress);
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	*//**
	 * <P>
	 * Test Save Employer Info - Without Country
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create a employer Info (setup)</LI>
	 * <LI>Set Legal Address without Country</LI>
	 * <LI>Call saveEmployerInfo passing modified employer info</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that ValidationException is thrown</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*
	@Test(expectedExceptions = ValidationException.class)
	public void testSaveEmployerInfoWithoutLegalCountry()
			throws ServiceFailureException, ValidationException {
		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		PhysicalAddress legalAddress = createPhysicalAddress();
		legalAddress.setCountry("");
		employerInfo.setLegalAddress(legalAddress);
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	*//**
	 * <P>
	 * Test Save Employer Info - Wit null Country
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create a employer Info (setup)</LI>
	 * <LI>Set Legal Address without Country</LI>
	 * <LI>Call saveEmployerInfo passing modified employer info</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that ValidationException is thrown</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*
	@Test(expectedExceptions = ValidationException.class)
	public void testSaveEmployerInfoWithNullLegalCountry()
			throws ServiceFailureException, ValidationException {
		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		PhysicalAddress legalAddress = createPhysicalAddress();
		legalAddress.setCountry(null);
		employerInfo.setLegalAddress(legalAddress);
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	*//**
	 * <P>
	 * Test Save Employer Info - without Company Type/P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create a employer Info (setup)</LI>
	 * <LI>Set Legal Address without Comany Type</LI>
	 * <LI>Call saveEmployerInfo passing modified employer info</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that ValidationException is thrown</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*
	@Test(expectedExceptions = ValidationException.class)
	public void testSaveEmployerInfoWithNullCompanyType()
			throws ServiceFailureException, ValidationException {

		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		employerInfo.setCompanyType(null);
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	*//**
	 * <P>
	 * Test Save Employer Info - without Legal Name
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create a employer Info (setup)</LI>
	 * <LI>Set Legal Address without Legal Name</LI>
	 * <LI>Call saveEmployerInfo passing modified employer info</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that ValidationException is thrown</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*
	@Test(expectedExceptions = ValidationException.class)
	public void testSaveEmployerInfoWithoutLegalName()
			throws ServiceFailureException, ValidationException {

		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		employerInfo.setLegalName("");
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	*//**
	 * <P>
	 * Test Save Employer Info - with null Legal Name
	 * </P>
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Create a employer Info (setup)</LI>
	 * <LI>Set Legal Address with null Legal Name</LI>
	 * <LI>Call saveEmployerInfo passing modified employer info</LI>
	 * </OL>
	 * <UL>
	 * <LI>Verify that ValidationException is thrown</LI>
	 * </UL>
	 * 
	 * @throws ValidationException
	 * @throws ServiceFailureException
	 *//*
	@Test(expectedExceptions = ValidationException.class)
	public void testSaveEmployerInfoWithNullLegalName()
			throws ServiceFailureException, ValidationException {

		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		employerInfo.setLegalName(null);
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	@Test(expectedExceptions = ValidationException.class)
	public void testUpdateEmployerInfoWithoutDBAName()
			throws ServiceFailureException, ValidationException {

		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		employerInfo.setDBAName("");
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	@Test(expectedExceptions = ValidationException.class)
	public void testUpdateEmployerInfoWithNullDBAName()
			throws ServiceFailureException, ValidationException {

		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		employerInfo.setDBAName(null);
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	@Test(expectedExceptions = ValidationException.class)
	public void testUpdateEmployerInfoWithNullLegalAddress()
			throws ServiceFailureException, ValidationException {

		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		employerInfo.setLegalAddress(null);
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	@Test(expectedExceptions = ValidationException.class)
	public void testUpdateEmployerInfoWithoutLegalAddressLine1()
			throws ServiceFailureException, ValidationException {

		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		PhysicalAddress legalAddress = createPhysicalAddress();
		legalAddress.setAddressLine1("");
		employerInfo.setLegalAddress(legalAddress);
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	@Test(expectedExceptions = ValidationException.class)
	public void testUpdateEmployerInfoWithNullLegalAddressLine1()
			throws ServiceFailureException, ValidationException {

		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		PhysicalAddress legalAddress = createPhysicalAddress();
		legalAddress.setAddressLine1(null);
		employerInfo.setLegalAddress(legalAddress);
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	@Test(expectedExceptions = ValidationException.class)
	public void testUpdateEmployerInfoWithoutLegalCity()
			throws ServiceFailureException, ValidationException {

		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		PhysicalAddress legalAddress = createPhysicalAddress();
		legalAddress.setCity("");
		employerInfo.setLegalAddress(legalAddress);
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	@Test(expectedExceptions = ValidationException.class)
	public void testUpdateEmployerInfoWithNullLegalCity()
			throws ServiceFailureException, ValidationException {

		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		PhysicalAddress legalAddress = createPhysicalAddress();
		legalAddress.setCity(null);
		employerInfo.setLegalAddress(legalAddress);
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	@Test(expectedExceptions = ValidationException.class)
	public void testUpdateEmployerInfoWithoutLegalState()
			throws ServiceFailureException, ValidationException {

		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		PhysicalAddress legalAddress = createPhysicalAddress();
		legalAddress.setStateOrRegion("");
		employerInfo.setLegalAddress(legalAddress);
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	@Test(expectedExceptions = ValidationException.class)
	public void testUpdateEmployerInfoWithNullLegalState()
			throws ServiceFailureException, ValidationException {

		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		PhysicalAddress legalAddress = createPhysicalAddress();
		legalAddress.setStateOrRegion(null);
		employerInfo.setLegalAddress(legalAddress);
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	@Test(expectedExceptions = ValidationException.class)
	public void testUpdateEmployerInfoWithoutLegalZip()
			throws ServiceFailureException, ValidationException {

		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		PhysicalAddress legalAddress = createPhysicalAddress();
		legalAddress.setZipOrPostalCode("");
		employerInfo.setLegalAddress(legalAddress);
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	@Test(expectedExceptions = ValidationException.class)
	public void testUpdateEmployerInfoWithNullLegalZip()
			throws ServiceFailureException, ValidationException {
		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		PhysicalAddress legalAddress = createPhysicalAddress();
		legalAddress.setZipOrPostalCode(null);
		employerInfo.setLegalAddress(legalAddress);
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	@Test(expectedExceptions = ValidationException.class)
	public void testUpdateEmployerInfoWithoutLegalCountry()
			throws ServiceFailureException, ValidationException {

		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		PhysicalAddress legalAddress = createPhysicalAddress();
		legalAddress.setCountry("");
		employerInfo.setLegalAddress(legalAddress);
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	@Test(expectedExceptions = ValidationException.class)
	public void testUpdateEmployerInfoWithNullLegalCountry()
			throws ServiceFailureException, ValidationException {
		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		PhysicalAddress legalAddress = createPhysicalAddress();
		legalAddress.setCountry(null);
		employerInfo.setLegalAddress(legalAddress);
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	@Test(expectedExceptions = ValidationException.class)
	public void testUpdateEmployerInfoWithNullCompanyType()
			throws ServiceFailureException, ValidationException {
		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		employerInfo.setCompanyType(null);
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	@Test(expectedExceptions = ValidationException.class)
	public void testUpdateEmployerInfoWithoutLegalName()
			throws ServiceFailureException, ValidationException {
		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		employerInfo.setLegalName("");
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	@Test(expectedExceptions = ValidationException.class)
	public void testUpdateEmployerInfoWithNullLegalName()
			throws ServiceFailureException, ValidationException {
		EmployerInfo employerInfo = createBasicEmployerInfo();
		employerInfo.setAssistedStateType(AssistedStateType.InitiatedOnBoarding);

		employerInfo.setLegalName(null);
		SaveEmployerInfoRequest employerInfoRequest = new SaveEmployerInfoRequest();
		employerInfoRequest.setEmployerInfo(employerInfo);
		sEmployerService.saveEmployerInfo(employerInfoRequest);
	}

	@Test(expectedExceptions = ValidationException.class)
	public void testUpdateEmployerLegalInfoWithInvalidEIN() throws Exception {

		EmployerTaxIdInfo[] taxIdInfos = sEmployerTaxSettingsService
				.getEmployerTaxIDs();
		// assertEmployerTaxIdInfo(taxIdInfos);
		for (EmployerTaxIdInfo employerTaxIdInfo : taxIdInfos) {
			if (employerTaxIdInfo.getTaxAgency().name.contains("US_IRS")) {
				employerTaxIdInfo.setTaxId("123456");
				break;
			}
		}
		sEmployerTaxSettingsService.updateEmployerTaxIDs(taxIdInfos);
	}

}
*/