package com.intuit.sb.payroll.performance;

import java.util.Calendar;
import java.util.Date;
import com.intuit.sb.payroll.common.ServiceLocator;
import com.intuit.sb.payroll.services.taxes.EmployerTaxSettingsService;
import com.intuit.sb.payroll.services.taxes.SuiSetting;

public class ChangeEmployerSUISettingsServlet extends PerformanceTestServlet {

	private static final long serialVersionUID = -3036729585804961146L;
    private EmployerTaxSettingsService employerTaxSettingService = ServiceLocator.getInstance().getService(EmployerTaxSettingsService.JNDI_NAME);

	public String performTest(String userName)
	{
	  StringBuffer result = new StringBuffer("Update future SUI rate: <p>");
	  Date tommorrow = new Date(Calendar.getInstance().getTimeInMillis() + 24*60*60*1000);
	  SuiSetting[] settings = employerTaxSettingService.getEmployerSUIsettings();
	  for(SuiSetting setting:settings)
	  {
		setting.setFutureRate("3.2");
		setting.setFutureRateStartDate(tommorrow);
	  }
	  //now update in the back end
	  try
	  {
		employerTaxSettingService.updateEmployerSUIsettings(settings);
	  }
	  catch (Exception ex)
	  {
		  throw new RuntimeException("Error in updating SUI settings", ex);
	  }
	  return result.toString() + " to " + 3.2 + " from tomorrow";
	}
	
}
