package com.intuit.sb.payroll.performance;

import com.intuit.sb.payroll.common.ServiceLocator;
import com.intuit.sb.payroll.services.common.WorkLocation;
import com.intuit.sb.payroll.services.employer.EmployerService;

public class GetWorkLocationsServlet extends PerformanceTestServlet {

	private static final long serialVersionUID = 1L;
	private static ServiceLocator serviceLocator = ServiceLocator.getInstance();
	private static EmployerService employerService = serviceLocator.getService(EmployerService.JNDI_NAME);

	/**
	 * Test API com.intuit.sb.payroll.services.employer.EmployerService.getWorkLocations()
	 * @param username
	 */
	public String performTest(String username)
	{
		StringBuffer sb = new StringBuffer("Get WorkLocations for user " + username + ":");
		sb.append("<p>");
		WorkLocation [] locations = null;
		try
		{
			locations = employerService.getWorkLocations();
		}
		catch (Exception ex)
		{
			throw new RuntimeException(ex);
		}
       
        if(locations != null)
        {
            for (WorkLocation loc:locations)
            {
            	sb.append("WorkLocation " + loc.getName() + "<br>");
            }
        }
		return sb.toString();
	} 
}
