/*
 * Copyright 2007 Intuit Inc. All rights reserved. Unauthorized reproduction
 * is a violation of applicable law. This material contains certain
 * confidential or proprietary information and trade secrets of Intuit Inc.
 * 
 * com.intuit.sb.services.query.ScopedSimpleQueryVisitor.java
 * 
 * Created: Sep 8, 2011 1:38:51 PM
 * Author: gkesler
 */
package com.intuit.sb.services.query;

import com.intuit.sb.services.query.parser.SimpleNode;
import com.intuit.sb.services.query.parser.SimpleQueryParserVisitor;

/**
 *
 * @author gkesler
 */
public interface ScopedSimpleQueryVisitor extends SimpleQueryParserVisitor {
    /**
     * A generic method to tell to this visitor that it is leaving the 
     * scope of current node
     * 
     * NOTE: there is no corresponding "enter" method
     * visiting this node for the first time itself manifests
     * opening node's scope
     * 
     * @param node  node which scope is being closed
     * @param data  argument circulating within this scope
     */
    void leave (SimpleNode node, Object data);
}
