/*
 * Copyright 2007 Intuit Inc. All rights reserved. Unauthorized reproduction
 * is a violation of applicable law. This material contains certain
 * confidential or proprietary information and trade secrets of Intuit Inc.
 * 
 * com.intuit.sb.services.query.generator.InTuple.java
 * 
 * Created: Aug 16, 2011 10:53:44 PM
 * Author: gkesler
 */
package com.intuit.sb.services.query.generator.tuple;

import com.intuit.sb.services.query.generator.tuple.ExpressionTuple.Precedence;
import com.intuit.sb.services.query.validator.context.Property;
import java.util.HashSet;
import java.util.Set;

/**
 *
 * @author gkesler
 */
public class InTuple implements FilterTuple<Object> {
    private Property path;
    private final Set<Object> values = new HashSet<Object>();

    public Property getPath() {
        return path;
    }

    public Object getValue() {
        return values;
    }
    
    public Set<Object> getValues () {
        return values;
    }

    public <T> T accept(TupleVisitor<T> visitor, T data) {
        return visitor.visit(this, data);
    }

    public void setPath(Property path) {
        this.path = path;
    }

    public void addValue(Object value) {
        this.values.add(value);
    }

    @Override
    public String toString() {
        return getClass().getSimpleName() + "{" + "path=" + path + ", values=" + values + '}';
    }

    public Precedence getPrecedence() {
        return Precedence.Filter;
    }
}
