/*
 * Copyright 2007 Intuit Inc. All rights reserved. Unauthorized reproduction
 * is a violation of applicable law. This material contains certain
 * confidential or proprietary information and trade secrets of Intuit Inc.
 * 
 * com.intuit.sb.services.query.Optimizer.java
 * 
 * Created: Jul 12, 2011 1:14:55 PM
 * Author: gkesler
 */
package com.intuit.sb.services.query.optimizer;

import com.intuit.sb.services.query.parser.SimpleNode;

/**
 *
 * @author gkesler
 */
public interface Optimizer<T extends SimpleNode> {
    /**
     * Optimizer's entry point.
     * Optimization happens in a subtree rooted by the specified node
     * 
     * @param node  subtree root node to optimize
     * @param data  extra argument to be passed to optimizer
     * @throws OptimizerException
     */
    void optimize (T node, Object data);
}
