/*
 * Copyright 2007 Intuit Inc. All rights reserved. Unauthorized reproduction
 * is a violation of applicable law. This material contains certain
 * confidential or proprietary information and trade secrets of Intuit Inc.
 * 
 * com.intuit.sb.services.query.validator.context.CompositeProperty.java
 * 
 * Created: Aug 12, 2011 4:08:48 PM
 * Author: gkesler
 */
package com.intuit.sb.services.query.validator.context;

import java.util.Arrays;
import java.util.Collection;

/**
 *
 * @author gkesler
 */
public class CompositeProperty extends SingleValueProperty {
    private final Property keyProperty;
    private final Property valueProperty;
    
    public CompositeProperty (Context parent, String propertyName, Property key, Property value, boolean queryable, boolean sortable) {
        super(parent, propertyName, value.getType(), queryable, sortable);
        
        this.keyProperty = key;
        this.valueProperty = value;
    }

    @Override
    public Collection<Property> getAllProperties() {
        return Arrays.asList(keyProperty, valueProperty);
    }

    @Override
    public <T> T accept(PropertyVisitor<T> visitor, T data) {
        return visitor.visit(this, data);
    }
}
