/*
 * Copyright 2007 Intuit Inc. All rights reserved. Unauthorized reproduction
 * is a violation of applicable law. This material contains certain
 * confidential or proprietary information and trade secrets of Intuit Inc.
 * 
 * com.intuit.sb.services.query.ContextFactory.java
 * 
 * Created: Aug 8, 2011 2:35:46 PM
 * Author: gkesler
 */
package com.intuit.sb.services.query.validator.context;

import java.util.Map;

/**
 *
 * @author gkesler
 */
public interface ContextFactory {
    public static final String CONTEXT_NAME              = "query.context.name";
    public static final String CONTEXT_PREFIX            = "query.context.prefix";
    public static final String CONTEXT_USER_ID           = "query.context.userId";
    public static final String CONTEXT_APP_ID            = "query.context.appId";
    public static final String PAGE_MIN_LIMIT            = "query.pagination.minLimit";
    public static final String PAGE_MAX_LIMIT            = "query.pagination.maxLimit";
    public static final String DISTANCE_MIN_LIMIT        = "query.distance.minLimit";
    public static final String DISTANCE_MAX_LIMIT        = "query.distance.maxLimit";
    public static final String METADATA_PROVIDER_FACTORY = "query.context.metadataprovider.factory";
    
    /**
     * Creates Context for the given context name.
     * 
     * @param contextName   - short context name
     * @param props           - context properties
     * @return context instance
     * @throws InvalidContextException in case the context cannot be created
     */
    RootContext createContext (String contextName, Map<String, Object> props) 
            throws InvalidContextException;
}
