/*
 * Copyright 2007 Intuit Inc. All rights reserved. Unauthorized reproduction
 * is a violation of applicable law. This material contains certain
 * confidential or proprietary information and trade secrets of Intuit Inc.
 * 
 * com.intuit.sb.services.query.validator.PathBuilder.java
 * 
 * Created: Aug 17, 2011 6:42:27 PM
 * Author: gkesler
 */
package com.intuit.sb.services.query.validator.context;

import com.intuit.sb.services.query.parser.ASTPathExpression;

/**
 * Evaluates (looks up) the path expression.
 * The result will contain either single-valued property descriptor
 * or a Context object in case of collection-valued one
 *
 * @author gkesler
 */
public interface PathBuilder {
    /**
     * 
     * @param pathElement 
     */
    void addPathElement (String name);
    /**
     * 
     */
    void addAnyPathElement ();
    /**
     * 
     * @param idValue 
     */
    void addIdPathElement (String idValue);
    /**
     * 
     * @param nameValue 
     */
    void addNamePathElement (String nameValue);
    /**
     * 
     * @param path
     * @return 
     */
    Property evaluate (ASTPathExpression path);
}
