/*
 * Copyright 2007 Intuit Inc. All rights reserved. Unauthorized reproduction
 * is a violation of applicable law. This material contains certain
 * confidential or proprietary information and trade secrets of Intuit Inc.
 * 
 * com.intuit.sb.services.query.PositiveTest.java
 * 
 * Created: Jun 30, 2011 11:03:09 AM
 * Author: gkesler
 */
package com.intuit.sb.services.query;

import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.File;
import java.net.URL;
import java.util.List;
import org.junit.runners.Parameterized.Parameters;
import org.junit.runners.Parameterized;
import org.junit.runner.RunWith;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

/**
 *
 * @author gkesler
 */
@RunWith(Parameterized.class)
public class SearchPositiveTest {
    
    @Parameters
    public static List<Object[]> data () {
        try {
            System.out.println("SearchPositiveTest: searching for query files...");
            URL dummyURL = PositiveTest.class.getResource("/search/positive/dummy.txt");
            File dummy = new File(dummyURL.toURI());
            
            return Utils.findFiles(dummy.getParentFile(), ".sq");
        } catch (Exception e) {
            throw new ExceptionInInitializerError(e);
        }
    }
    
    private final File queryFile;
    
    public SearchPositiveTest(File queryFile) {
        this.queryFile = queryFile;
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }
    
    @Before
    public void setUp() {
    }
    
    @After
    public void tearDown() {
    }
    // TODO add test methods here.
    // The methods must be annotated with annotation @Test. For example:
    //
    @Test
    public void testQuery() throws Exception {
        System.out.println("SearchPositiveTest: queryFile '" + queryFile + "'");
        SimpleQuery parser = new SimpleQueryContext().newSimpleQuery(new BufferedInputStream(new FileInputStream(queryFile)));
        parser.setSyntaxMode(SimpleQuery.SyntaxMode.EXTENDED);
        parser.parse();
    }
}
