/*
 * Copyright 2007 Intuit Inc. All rights reserved. Unauthorized reproduction
 * is a violation of applicable law. This material contains certain
 * confidential or proprietary information and trade secrets of Intuit Inc.
 * 
 * com.intuit.sb.datasync.query.test.SimpleQueryResourceTest.java
 * 
 * Created: Dec 5, 2011 3:34:23 PM
 * Author: gkesler
 */
package com.intuit.sb.datasync.query.test;

import java.net.URLEncoder;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;

import org.jboss.resteasy.client.ClientRequest;
import org.jboss.resteasy.client.ClientResponse;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import static org.junit.Assert.*;

/**
 *
 * @author gkesler
 */
public class SimpleQueryResourceTest {

    public SimpleQueryResourceTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
//        BasicConfigurator.configure();
    }

    @After
    public void tearDown() {
    }
    // TODO add test methods here.
    // The methods must be annotated with annotation @Test. For example:
    //

    @Test
    public void testGetInvoice() throws Exception {
        System.out.println("testGetInvoice");
        
        final String invoiceQuery = 
                "SELECT Header.status, Header.customerId "
                + "WHERE Header.txnDate = '2011-07-18' "
                + "AND Header.totalAmt >= '1500.50' "
                + "ORDER BY Header.customerId ASC "
                + "MAXRESULTS 50";

        String encoded = URLEncoder.encode(invoiceQuery, "UTF-8");
        ClientRequest request = new ClientRequest("http://localhost:9095/v2/my-realm-id/invoice?q=" + encoded);
        ClientResponse<String> response = request.get(String.class);

        assertEquals(Response.Status.OK.getStatusCode(), response.getStatus());

        String responseContent = response.getEntity();
        assertNotNull(responseContent != null);
        assertTrue(responseContent.length() > 0);

        System.out.println("Response:");
        System.out.println(responseContent);
    }
    
    @Test
    public void testGet() throws Exception {
        System.out.println("testGetInvoice");
        
        final String query =
                "SELECT Header.status, Header.customerId "
                + "FROM Invoice "
                + "WHERE Header.txnDate = '2011-07-18' "
                + "AND Header.totalAmt >= '1500.50' "
                + "ORDER BY Header.customerId ASC "
                + "MAXRESULTS 50";

        String encoded = URLEncoder.encode(query, "UTF-8");
        ClientRequest request = new ClientRequest("http://localhost:9095/v2/my-realm-id?q=" + encoded);
        ClientResponse<String> response = request.get(String.class);

        assertEquals(Response.Status.OK.getStatusCode(), response.getStatus());

        String responseContent = response.getEntity();
        assertNotNull(responseContent != null);
        assertTrue(responseContent.length() > 0);

        System.out.println("Response:");
        System.out.println(responseContent);
    }

    @Test
    public void testPostInvoice() throws Exception {
        System.out.println("testPostInvoice");
        
        final String invoiceQuery =
                "SELECT Header.status, Header.customerId "
                + "WHERE Header.txnDate = '2011-07-18' "
                + "AND Header.totalAmt >= '1500.50' "
                + "ORDER BY Header.customerId ASC "
                + "MAXRESULTS 50";

        ClientRequest request = new ClientRequest("http://localhost:9095/v2/my-realm-id/invoice");
        request.body(MediaType.TEXT_PLAIN, invoiceQuery);
        ClientResponse<String> response = request.post(String.class);

        assertEquals(Response.Status.OK.getStatusCode(), response.getStatus());

        String responseContent = response.getEntity();
        assertNotNull(responseContent != null);
        assertTrue(responseContent.length() > 0);

        System.out.println("Response:");
        System.out.println(responseContent);
    }
}
