/*
 * Copyright 2007 Intuit Inc. All rights reserved. Unauthorized reproduction
 * is a violation of applicable law. This material contains certain
 * confidential or proprietary information and trade secrets of Intuit Inc.
 * 
 * com.intuit.sb.datasync.query.rest.SimpleQueryMessageBodyReader.java
 * 
 * Created: Nov 22, 2011 2:36:05 PM
 * Author: gkesler
 */
package com.intuit.sb.datasync.query.ws.rs;

import com.intuit.sb.services.query.SimpleQuery;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.lang.annotation.Annotation;
import java.lang.reflect.Type;
import java.util.Arrays;
import javax.ws.rs.Consumes;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.MultivaluedMap;
import javax.ws.rs.ext.MessageBodyReader;
import javax.ws.rs.ext.Provider;
import javax.ws.rs.ext.Providers;
import org.apache.log4j.Logger;

/**
 *
 * @author gkesler
 */
@Provider
@Consumes(MediaType.WILDCARD)
public class SimpleQueryMessageBodyReader implements MessageBodyReader<SimpleQuery> {
    private static final Logger logger = Logger.getLogger(SimpleQueryMessageBodyReader.class);
    
    @Context
    private Providers providers;

    public boolean isReadable(Class<?> type, Type genericType, 
            Annotation[] annotations, MediaType mediaType) {
        return type.isAssignableFrom(SimpleQuery.class);
    }

    public SimpleQuery readFrom(Class<SimpleQuery> type, Type genericType, 
            Annotation[] annotations, MediaType mediaType, MultivaluedMap<String, String> httpHeaders, 
            InputStream entityStream) throws IOException, WebApplicationException {
        logger.debug("annotations=" + Arrays.toString(annotations));
        return ConverterHelper.readFrom(new InputStreamReader(entityStream), providers, annotations, mediaType);
    }
}
