/*
 * Copyright 2007 Intuit Inc. All rights reserved. Unauthorized reproduction
 * is a violation of applicable law. This material contains certain
 * confidential or proprietary information and trade secrets of Intuit Inc.
 * 
 * com.intuit.sb.datasync.query.rest.SimpleQueryStringConverter.java
 * 
 * Created: Nov 29, 2011 3:48:03 PM
 * Author: gkesler
 */
package com.intuit.sb.datasync.query.ws.rs.resteasy;

import com.intuit.sb.datasync.query.ws.rs.ConverterHelper;
import com.intuit.sb.services.query.SimpleQuery;
import java.io.IOException;
import java.io.StringReader;
import java.lang.annotation.Annotation;
import java.util.Arrays;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.ext.Provider;
import javax.ws.rs.ext.Providers;
import org.apache.log4j.Logger;
import org.jboss.resteasy.spi.StringConverter;

/**
 *
 * @author gkesler
 */
@Provider
public class SimpleQueryStringConverter implements StringConverter<SimpleQuery> {
    private static final Logger logger = Logger.getLogger(SimpleQueryStringConverter.class);
    
    @Context
    protected Providers providers;

    protected Annotation annotations[] = {};

    public SimpleQuery fromString(String string) {
        try {
            logger.debug("annotations=" + Arrays.toString(annotations));
            return ConverterHelper.readFrom(new StringReader(string), providers, annotations, MediaType.WILDCARD_TYPE);
        } catch (IOException e) {
            throw new WebApplicationException(e);
        }
    }

    public String toString(SimpleQuery t) {
        throw new AssertionError("SimpleQuery marshalling is not supported");
    }
}
