/*
 * Copyright 2007 Intuit Inc. All rights reserved. Unauthorized reproduction
 * is a violation of applicable law. This material contains certain
 * confidential or proprietary information and trade secrets of Intuit Inc.
 * 
 * com.intuit.sb.datasync.query.ws.rs.uri.DumpVisitor.java
 * 
 * Created: Dec 1, 2011 10:47:08 PM
 * Author: gkesler
 */
package com.intuit.sb.datasync.query.ws.rs.utils;

/**
 *
 * @author gkesler
 */
public class DumpVisitor implements UriTemplateParserVisitor {
    public static final void dump (UriTemplate uriTemplate, String prefix) {
        uriTemplate.getParser().getRootNode().jjtAccept(new DumpVisitor(), prefix);
    }
    
    private Object dumpNode (SimpleNode node, Object data) {
        String prefix = (String)data;
        
        StringBuilder out = new StringBuilder();
        out.append(node.toString(prefix));                
        if (node.jjtGetValue() != null) {
            out.append(" : value=" + node.jjtGetValue());
        }
        System.out.println(out.toString());
        
        node.childrenAccept(this, prefix + " ");
        
        return data;
    }    

    public Object visit(SimpleNode node, Object data) {
        return dumpNode(node, data);
    }

    public Object visit(ASTTemplate node, Object data) {
        return dumpNode(node, data);
    }

    public Object visit(ASTRule node, Object data) {
        return dumpNode(node, data);
    }

    public Object visit (ASTOr node, Object value) {
        return dumpNode(node, value);
    }
    
    public Object visit(ASTSegment node, Object data) {
        return dumpNode(node, data);
    }

    public Object visit(ASTOptSegment node, Object data) {
        return dumpNode(node, data);
    }
    
    public Object visit(ASTParam node, Object data) {
        return dumpNode(node, data);
    }

    public Object visit(ASTName node, Object data) {
        return dumpNode(node, data);
    }

    public Object visit(ASTRegEx node, Object data) {
        return dumpNode(node, data);
    }

    public Object visit(ASTString node, Object data) {
        return dumpNode(node, data);
    }    
}
